# AdminSourcesApi

All URIs are relative to *https://platform.its4land.com*

Method | HTTP request | Description
------------- | ------------- | -------------
[**getAdminSourceByUID**](AdminSourcesApi.md#getAdminSourceByUID) | **GET** /adminsources/{adminsource_uid} | Returns a single Admin Source
[**getAdminSources**](AdminSourcesApi.md#getAdminSources) | **GET** /adminsources | Returns a list of AdminSource document indizes
[**newAdminSource**](AdminSourcesApi.md#newAdminSource) | **POST** /adminsources | Creates a new AdminSource
[**updateAdminSource**](AdminSourcesApi.md#updateAdminSource) | **PATCH** /adminsources/{adminsource_uid} | Update an Admin Source


<a name="getAdminSourceByUID"></a>
# **getAdminSourceByUID**
> AdminSourcesEndpointType getAdminSourceByUID(adminsourceUid, envelope, embed)

Returns a single Admin Source

Returns a single Admin Source

### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.AdminSourcesApi;


AdminSourcesApi apiInstance = new AdminSourcesApi();
String adminsourceUid = "adminsourceUid_example"; // String | AdminSource UID
String envelope = "envelope_example"; // String | The endpoint can package everything (header, status code) neatly into the response body. Include envelope=true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
List<String> embed = Arrays.asList("embed_example"); // List<String> | Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name)
try {
    AdminSourcesEndpointType result = apiInstance.getAdminSourceByUID(adminsourceUid, envelope, embed);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling AdminSourcesApi#getAdminSourceByUID");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **adminsourceUid** | **String**| AdminSource UID |
 **envelope** | **String**| The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. | [optional] [enum: yes, no]
 **embed** | [**List&lt;String&gt;**](String.md)| Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) | [optional]

### Return type

[**AdminSourcesEndpointType**](AdminSourcesEndpointType.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="getAdminSources"></a>
# **getAdminSources**
> List&lt;AdminSourcesEndpointType&gt; getAdminSources(envelope, uid, name, type, projects, spatialunits, tags, page, sort, fields, embed)

Returns a list of AdminSource document indizes

Returns a list of AdminSource document indizes

### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.AdminSourcesApi;


AdminSourcesApi apiInstance = new AdminSourcesApi();
String envelope = "envelope_example"; // String | The endpoint can package everything (header, status code) neatly into the response body. Include envelope=true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
List<String> uid = Arrays.asList("uid_example"); // List<String> | Comma separated list of AdminSources UID
List<String> name = Arrays.asList("name_example"); // List<String> | Comma separated list of AdminSources names
List<String> type = Arrays.asList("type_example"); // List<String> | Comma separated list of AdminSources types
List<String> projects = Arrays.asList("projects_example"); // List<String> | Comma separated list of project UID
List<String> spatialunits = Arrays.asList("spatialunits_example"); // List<String> | Comma separated list of SpatialUnit UID
List<String> tags = Arrays.asList("tags_example"); // List<String> | Comma separated list of tags
Integer page = 56; // Integer | Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default.
String sort = "sort_example"; // String | The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by.
List<String> fields = Arrays.asList("fields_example"); // List<String> | Comma separated list of tags
List<String> embed = Arrays.asList("embed_example"); // List<String> | Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name)
try {
    List<AdminSourcesEndpointType> result = apiInstance.getAdminSources(envelope, uid, name, type, projects, spatialunits, tags, page, sort, fields, embed);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling AdminSourcesApi#getAdminSources");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **envelope** | **String**| The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. | [optional] [enum: yes, no]
 **uid** | [**List&lt;String&gt;**](String.md)| Comma separated list of AdminSources UID | [optional]
 **name** | [**List&lt;String&gt;**](String.md)| Comma separated list of AdminSources names | [optional]
 **type** | [**List&lt;String&gt;**](String.md)| Comma separated list of AdminSources types | [optional]
 **projects** | [**List&lt;String&gt;**](String.md)| Comma separated list of project UID | [optional]
 **spatialunits** | [**List&lt;String&gt;**](String.md)| Comma separated list of SpatialUnit UID | [optional]
 **tags** | [**List&lt;String&gt;**](String.md)| Comma separated list of tags | [optional]
 **page** | **Integer**| Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. | [optional]
 **sort** | **String**| The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. | [optional]
 **fields** | [**List&lt;String&gt;**](String.md)| Comma separated list of tags | [optional]
 **embed** | [**List&lt;String&gt;**](String.md)| Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) | [optional]

### Return type

[**List&lt;AdminSourcesEndpointType&gt;**](AdminSourcesEndpointType.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="newAdminSource"></a>
# **newAdminSource**
> AdminSourcesEndpointType newAdminSource(newadminsource, envelope, embed, i4lProcessUid)

Creates a new AdminSource

Creates a new AdminSource

### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.AdminSourcesApi;


AdminSourcesApi apiInstance = new AdminSourcesApi();
AdminSourcesPostRequest newadminsource = new AdminSourcesPostRequest(); // AdminSourcesPostRequest | New AdminSource data
String envelope = "envelope_example"; // String | The endpoint can package everything (header, status code) neatly into the response body. Include envelope=true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
List<String> embed = Arrays.asList("embed_example"); // List<String> | Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name)
String i4lProcessUid = "i4lProcessUid_example"; // String | Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process.
try {
    AdminSourcesEndpointType result = apiInstance.newAdminSource(newadminsource, envelope, embed, i4lProcessUid);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling AdminSourcesApi#newAdminSource");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **newadminsource** | [**AdminSourcesPostRequest**](AdminSourcesPostRequest.md)| New AdminSource data |
 **envelope** | **String**| The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. | [optional] [enum: yes, no]
 **embed** | [**List&lt;String&gt;**](String.md)| Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) | [optional]
 **i4lProcessUid** | **String**| Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. | [optional]

### Return type

[**AdminSourcesEndpointType**](AdminSourcesEndpointType.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="updateAdminSource"></a>
# **updateAdminSource**
> AdminSourcesEndpointType updateAdminSource(adminsourceUid, patchadminsource, envelope, i4lProcessUid)

Update an Admin Source

Update an Admin Source

### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.AdminSourcesApi;


AdminSourcesApi apiInstance = new AdminSourcesApi();
String adminsourceUid = "adminsourceUid_example"; // String | AdminSource UID
RFC6902PatchRequest patchadminsource = new RFC6902PatchRequest(); // RFC6902PatchRequest | Update data
String envelope = "envelope_example"; // String | The endpoint can package everything (header, status code) neatly into the response body. Include envelope=true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
String i4lProcessUid = "i4lProcessUid_example"; // String | Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process.
try {
    AdminSourcesEndpointType result = apiInstance.updateAdminSource(adminsourceUid, patchadminsource, envelope, i4lProcessUid);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling AdminSourcesApi#updateAdminSource");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **adminsourceUid** | **String**| AdminSource UID |
 **patchadminsource** | [**RFC6902PatchRequest**](RFC6902PatchRequest.md)| Update data |
 **envelope** | **String**| The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. | [optional] [enum: yes, no]
 **i4lProcessUid** | **String**| Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. | [optional]

### Return type

[**AdminSourcesEndpointType**](AdminSourcesEndpointType.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

