# BoundaryFaceStringApi

All URIs are relative to *https://platform.its4land.com*

Method | HTTP request | Description
------------- | ------------- | -------------
[**getBoundaryFaceString**](BoundaryFaceStringApi.md#getBoundaryFaceString) | **GET** /boundaryfacestring | Returns a list of boundary face strings in a GeoJSON structure.
[**getBoundaryFaceStringByUID**](BoundaryFaceStringApi.md#getBoundaryFaceStringByUID) | **GET** /boundaryfacestring/{boundaryfacestring_uid} | Returns a single boundary face string
[**newBoundaryFaceString**](BoundaryFaceStringApi.md#newBoundaryFaceString) | **POST** /boundaryfacestring | Create a new concept for a boundary face string
[**putBoundaryFaceStringByUID**](BoundaryFaceStringApi.md#putBoundaryFaceStringByUID) | **PUT** /boundaryfacestring/{boundaryfacestring_uid} | Replace an existing BoundaryFaceString by a newer version
[**updateBoundaryFaceString**](BoundaryFaceStringApi.md#updateBoundaryFaceString) | **PATCH** /boundaryfacestring/{boundaryfacestring_uid} | Updates a boundary face string


<a name="getBoundaryFaceString"></a>
# **getBoundaryFaceString**
> BoundaryFaceStringEndpointType getBoundaryFaceString(envelope, uid, name, projects, spatialunit, tags, page, sort, fields, embed)

Returns a list of boundary face strings in a GeoJSON structure.

Returns a list of boundary face strings. A boundary face string is modeled as a GeoJSON feature.

### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.BoundaryFaceStringApi;


BoundaryFaceStringApi apiInstance = new BoundaryFaceStringApi();
String envelope = "envelope_example"; // String | The endpoint can package everything (header, status code) neatly into the response body. Include envelope=true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
List<String> uid = Arrays.asList("uid_example"); // List<String> | Comma separated list of Spatial unit UID
List<String> name = Arrays.asList("name_example"); // List<String> | Comma separated list of AdminSources names
List<String> projects = Arrays.asList("projects_example"); // List<String> | Comma separated list of project UID
List<String> spatialunit = Arrays.asList("spatialunit_example"); // List<String> | Comma separated list of SpatialSource UID
List<String> tags = Arrays.asList("tags_example"); // List<String> | Comma separated list of tags
Integer page = 56; // Integer | Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default.
String sort = "sort_example"; // String | The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by.
List<String> fields = Arrays.asList("fields_example"); // List<String> | Comma separated list of tags
List<String> embed = Arrays.asList("embed_example"); // List<String> | Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name)
try {
    BoundaryFaceStringEndpointType result = apiInstance.getBoundaryFaceString(envelope, uid, name, projects, spatialunit, tags, page, sort, fields, embed);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling BoundaryFaceStringApi#getBoundaryFaceString");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **envelope** | **String**| The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. | [optional] [enum: yes, no]
 **uid** | [**List&lt;String&gt;**](String.md)| Comma separated list of Spatial unit UID | [optional]
 **name** | [**List&lt;String&gt;**](String.md)| Comma separated list of AdminSources names | [optional]
 **projects** | [**List&lt;String&gt;**](String.md)| Comma separated list of project UID | [optional]
 **spatialunit** | [**List&lt;String&gt;**](String.md)| Comma separated list of SpatialSource UID | [optional]
 **tags** | [**List&lt;String&gt;**](String.md)| Comma separated list of tags | [optional]
 **page** | **Integer**| Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. | [optional]
 **sort** | **String**| The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. | [optional]
 **fields** | [**List&lt;String&gt;**](String.md)| Comma separated list of tags | [optional]
 **embed** | [**List&lt;String&gt;**](String.md)| Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) | [optional]

### Return type

[**BoundaryFaceStringEndpointType**](BoundaryFaceStringEndpointType.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="getBoundaryFaceStringByUID"></a>
# **getBoundaryFaceStringByUID**
> BoundaryFaceStringEndpointType getBoundaryFaceStringByUID(boundaryfacestringUid, envelope, embed)

Returns a single boundary face string

Returns a boundary face string as GeoJSON as a feature in a GeoJSON structure.

### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.BoundaryFaceStringApi;


BoundaryFaceStringApi apiInstance = new BoundaryFaceStringApi();
String boundaryfacestringUid = "boundaryfacestringUid_example"; // String | Boundary face string UID
String envelope = "envelope_example"; // String | The endpoint can package everything (header, status code) neatly into the response body. Include envelope=true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
List<String> embed = Arrays.asList("embed_example"); // List<String> | Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name)
try {
    BoundaryFaceStringEndpointType result = apiInstance.getBoundaryFaceStringByUID(boundaryfacestringUid, envelope, embed);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling BoundaryFaceStringApi#getBoundaryFaceStringByUID");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **boundaryfacestringUid** | **String**| Boundary face string UID |
 **envelope** | **String**| The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. | [optional] [enum: yes, no]
 **embed** | [**List&lt;String&gt;**](String.md)| Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) | [optional]

### Return type

[**BoundaryFaceStringEndpointType**](BoundaryFaceStringEndpointType.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="newBoundaryFaceString"></a>
# **newBoundaryFaceString**
> BoundaryFaceStringEndpointType newBoundaryFaceString(newboundaryfacestring, envelope, embed, i4lProcessUid)

Create a new concept for a boundary face string

Create a new concept for a boundary face string.

### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.BoundaryFaceStringApi;


BoundaryFaceStringApi apiInstance = new BoundaryFaceStringApi();
BoundaryFaceStringPostRequest newboundaryfacestring = new BoundaryFaceStringPostRequest(); // BoundaryFaceStringPostRequest | New boundary face string
String envelope = "envelope_example"; // String | The endpoint can package everything (header, status code) neatly into the response body. Include envelope=true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
List<String> embed = Arrays.asList("embed_example"); // List<String> | Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name)
String i4lProcessUid = "i4lProcessUid_example"; // String | Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process.
try {
    BoundaryFaceStringEndpointType result = apiInstance.newBoundaryFaceString(newboundaryfacestring, envelope, embed, i4lProcessUid);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling BoundaryFaceStringApi#newBoundaryFaceString");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **newboundaryfacestring** | [**BoundaryFaceStringPostRequest**](BoundaryFaceStringPostRequest.md)| New boundary face string |
 **envelope** | **String**| The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. | [optional] [enum: yes, no]
 **embed** | [**List&lt;String&gt;**](String.md)| Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) | [optional]
 **i4lProcessUid** | **String**| Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. | [optional]

### Return type

[**BoundaryFaceStringEndpointType**](BoundaryFaceStringEndpointType.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="putBoundaryFaceStringByUID"></a>
# **putBoundaryFaceStringByUID**
> BoundaryFaceStringEndpointType putBoundaryFaceStringByUID(boundaryfacestringUid, updatedboundaryfacestring, envelope, embed, i4lProcessUid)

Replace an existing BoundaryFaceString by a newer version

An existing BoundaryFaceString will be replaced by a newer version. The UID of BoundaryFaceString remains

### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.BoundaryFaceStringApi;


BoundaryFaceStringApi apiInstance = new BoundaryFaceStringApi();
String boundaryfacestringUid = "boundaryfacestringUid_example"; // String | Boundary face string UID
BoundaryFaceStringPostRequest updatedboundaryfacestring = new BoundaryFaceStringPostRequest(); // BoundaryFaceStringPostRequest | Updated boundary face string
String envelope = "envelope_example"; // String | The endpoint can package everything (header, status code) neatly into the response body. Include envelope=true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
List<String> embed = Arrays.asList("embed_example"); // List<String> | Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name)
String i4lProcessUid = "i4lProcessUid_example"; // String | Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process.
try {
    BoundaryFaceStringEndpointType result = apiInstance.putBoundaryFaceStringByUID(boundaryfacestringUid, updatedboundaryfacestring, envelope, embed, i4lProcessUid);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling BoundaryFaceStringApi#putBoundaryFaceStringByUID");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **boundaryfacestringUid** | **String**| Boundary face string UID |
 **updatedboundaryfacestring** | [**BoundaryFaceStringPostRequest**](BoundaryFaceStringPostRequest.md)| Updated boundary face string |
 **envelope** | **String**| The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. | [optional] [enum: yes, no]
 **embed** | [**List&lt;String&gt;**](String.md)| Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) | [optional]
 **i4lProcessUid** | **String**| Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. | [optional]

### Return type

[**BoundaryFaceStringEndpointType**](BoundaryFaceStringEndpointType.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="updateBoundaryFaceString"></a>
# **updateBoundaryFaceString**
> BoundaryFaceStringEndpointType updateBoundaryFaceString(boundaryfacestringUid, patchboundaryfacestring, envelope, i4lProcessUid)

Updates a boundary face string

Updates a boundary face string

### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.BoundaryFaceStringApi;


BoundaryFaceStringApi apiInstance = new BoundaryFaceStringApi();
String boundaryfacestringUid = "boundaryfacestringUid_example"; // String | Boundary face string UID
RFC6902PatchRequest patchboundaryfacestring = new RFC6902PatchRequest(); // RFC6902PatchRequest | Update data
String envelope = "envelope_example"; // String | The endpoint can package everything (header, status code) neatly into the response body. Include envelope=true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
String i4lProcessUid = "i4lProcessUid_example"; // String | Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process.
try {
    BoundaryFaceStringEndpointType result = apiInstance.updateBoundaryFaceString(boundaryfacestringUid, patchboundaryfacestring, envelope, i4lProcessUid);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling BoundaryFaceStringApi#updateBoundaryFaceString");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **boundaryfacestringUid** | **String**| Boundary face string UID |
 **patchboundaryfacestring** | [**RFC6902PatchRequest**](RFC6902PatchRequest.md)| Update data |
 **envelope** | **String**| The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. | [optional] [enum: yes, no]
 **i4lProcessUid** | **String**| Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. | [optional]

### Return type

[**BoundaryFaceStringEndpointType**](BoundaryFaceStringEndpointType.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

