# ContentItemsApi

All URIs are relative to *https://platform.its4land.com*

Method | HTTP request | Description
------------- | ------------- | -------------
[**getContentItem**](ContentItemsApi.md#getContentItem) | **GET** /contentitems/{contentitem_id} | Returns a single content from the object storage.
[**getContentItems**](ContentItemsApi.md#getContentItems) | **GET** /contentitems | Returns a list of contentitems
[**newContentItem**](ContentItemsApi.md#newContentItem) | **POST** /contentitems | Create a new content in the object storage


<a name="getContentItem"></a>
# **getContentItem**
> File getContentItem(contentitemId, envelope)

Returns a single content from the object storage.

Returns a single content from the object storage.

### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.ContentItemsApi;


ContentItemsApi apiInstance = new ContentItemsApi();
String contentitemId = "contentitemId_example"; // String | UID of the ContentItem
String envelope = "envelope_example"; // String | The endpoint can package everything (header, status code) neatly into the response body. Include envelope=true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
try {
    File result = apiInstance.getContentItem(contentitemId, envelope);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling ContentItemsApi#getContentItem");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **contentitemId** | **String**| UID of the ContentItem |
 **envelope** | **String**| The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. | [optional] [enum: yes, no]

### Return type

[**File**](File.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: multipart/form-data

<a name="getContentItems"></a>
# **getContentItems**
> List&lt;ContentItemEndpointType&gt; getContentItems(envelope, uid, contentname, contenttype, contentdescription, page, sort, fields, embed)

Returns a list of contentitems

Returns a list of contentitem metadata based on the filter criteria

### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.ContentItemsApi;


ContentItemsApi apiInstance = new ContentItemsApi();
String envelope = "envelope_example"; // String | The endpoint can package everything (header, status code) neatly into the response body. Include envelope=true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
List<String> uid = Arrays.asList("uid_example"); // List<String> | UID of a ContentItem
List<String> contentname = Arrays.asList("contentname_example"); // List<String> | Name of File
List<String> contenttype = Arrays.asList("contenttype_example"); // List<String> | mime/type of the content
String contentdescription = "contentdescription_example"; // String | Free text for description. Only plain text.
Integer page = 56; // Integer | Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default.
String sort = "sort_example"; // String | The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by.
List<String> fields = Arrays.asList("fields_example"); // List<String> | Comma separated list of field names
List<String> embed = Arrays.asList("embed_example"); // List<String> | Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name)
try {
    List<ContentItemEndpointType> result = apiInstance.getContentItems(envelope, uid, contentname, contenttype, contentdescription, page, sort, fields, embed);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling ContentItemsApi#getContentItems");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **envelope** | **String**| The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. | [optional] [enum: yes, no]
 **uid** | [**List&lt;String&gt;**](String.md)| UID of a ContentItem | [optional]
 **contentname** | [**List&lt;String&gt;**](String.md)| Name of File | [optional]
 **contenttype** | [**List&lt;String&gt;**](String.md)| mime/type of the content | [optional]
 **contentdescription** | **String**| Free text for description. Only plain text. | [optional]
 **page** | **Integer**| Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. | [optional]
 **sort** | **String**| The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. | [optional]
 **fields** | [**List&lt;String&gt;**](String.md)| Comma separated list of field names | [optional]
 **embed** | [**List&lt;String&gt;**](String.md)| Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) | [optional]

### Return type

[**List&lt;ContentItemEndpointType&gt;**](ContentItemEndpointType.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="newContentItem"></a>
# **newContentItem**
> ContentItemEndpointType newContentItem(newcontent, envelope, description, i4lProcessUid)

Create a new content in the object storage

Create a new content in the object storage

### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.ContentItemsApi;


ContentItemsApi apiInstance = new ContentItemsApi();
File newcontent = new File("/path/to/file.txt"); // File | Content as multipart from-data
String envelope = "envelope_example"; // String | The endpoint can package everything (header, status code) neatly into the response body. Include envelope=true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
String description = "description_example"; // String | Description of content (optional)
String i4lProcessUid = "i4lProcessUid_example"; // String | Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process.
try {
    ContentItemEndpointType result = apiInstance.newContentItem(newcontent, envelope, description, i4lProcessUid);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling ContentItemsApi#newContentItem");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **newcontent** | **File**| Content as multipart from-data |
 **envelope** | **String**| The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. | [optional] [enum: yes, no]
 **description** | **String**| Description of content (optional) | [optional]
 **i4lProcessUid** | **String**| Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. | [optional]

### Return type

[**ContentItemEndpointType**](ContentItemEndpointType.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: multipart/form-data
 - **Accept**: application/json

