# MetricMapFeaturesApi

All URIs are relative to *https://platform.its4land.com*

Method | HTTP request | Description
------------- | ------------- | -------------
[**getMetricMapFeature**](MetricMapFeaturesApi.md#getMetricMapFeature) | **GET** /metricmapfeature | Returns MetricMapFeature
[**newMetricMapFeature**](MetricMapFeaturesApi.md#newMetricMapFeature) | **POST** /metricmapfeature | Create a new metricMapFeature
[**updateMetricMapFeature**](MetricMapFeaturesApi.md#updateMetricMapFeature) | **PATCH** /metricmapfeature/{mmf_uid} | Updates a metric map feature


<a name="getMetricMapFeature"></a>
# **getMetricMapFeature**
> MetricMapFeaturesEndpointType getMetricMapFeature(querywindow, envelope, fgroup, ftype, fsubtype)

Returns MetricMapFeature

Returns MetricMapFeature in a GeoJSON structure. A metric map feature is modeled as a feature in  the GeoJSON structure.

### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.MetricMapFeaturesApi;


MetricMapFeaturesApi apiInstance = new MetricMapFeaturesApi();
String querywindow = "querywindow_example"; // String | Polygon. The polygon is encoded a comma separated list of coordinates. X1, Y1, X2, Y2, ..., Xn, Yn, X1, Y1
String envelope = "envelope_example"; // String | The endpoint can package everything (header, status code) neatly into the response body. Include envelope=true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
String fgroup = "fgroup_example"; // String | Restricts the output to the listed feature group
String ftype = "ftype_example"; // String | Restricts the output to the listed feature types. When used in combination with fgroup, output contains only those ftype which are contained in the feature groups
String fsubtype = "fsubtype_example"; // String | Restricts the output to the listed feature types. When used in combination with fgroup and/or ftype, output contains only those fsubtype which are contained in the feature groups and feature types
try {
    MetricMapFeaturesEndpointType result = apiInstance.getMetricMapFeature(querywindow, envelope, fgroup, ftype, fsubtype);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling MetricMapFeaturesApi#getMetricMapFeature");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **querywindow** | **String**| Polygon. The polygon is encoded a comma separated list of coordinates. X1, Y1, X2, Y2, ..., Xn, Yn, X1, Y1 |
 **envelope** | **String**| The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. | [optional] [enum: yes, no]
 **fgroup** | **String**| Restricts the output to the listed feature group | [optional]
 **ftype** | **String**| Restricts the output to the listed feature types. When used in combination with fgroup, output contains only those ftype which are contained in the feature groups | [optional]
 **fsubtype** | **String**| Restricts the output to the listed feature types. When used in combination with fgroup and/or ftype, output contains only those fsubtype which are contained in the feature groups and feature types | [optional]

### Return type

[**MetricMapFeaturesEndpointType**](MetricMapFeaturesEndpointType.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="newMetricMapFeature"></a>
# **newMetricMapFeature**
> MetricMapFeaturesEndpointType newMetricMapFeature(newmetricmapfeature, envelope, i4lProcessUid)

Create a new metricMapFeature

Create a new MetricMapFeature. The new metric map feature is a feature in the GeoJSON structure. Currently ony one new feature per request is allowed.

### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.MetricMapFeaturesApi;


MetricMapFeaturesApi apiInstance = new MetricMapFeaturesApi();
MetricMapFeaturePostRequest newmetricmapfeature = new MetricMapFeaturePostRequest(); // MetricMapFeaturePostRequest | New MetricMap Feature data
String envelope = "envelope_example"; // String | The endpoint can package everything (header, status code) neatly into the response body. Include envelope=true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
String i4lProcessUid = "i4lProcessUid_example"; // String | Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process.
try {
    MetricMapFeaturesEndpointType result = apiInstance.newMetricMapFeature(newmetricmapfeature, envelope, i4lProcessUid);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling MetricMapFeaturesApi#newMetricMapFeature");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **newmetricmapfeature** | [**MetricMapFeaturePostRequest**](MetricMapFeaturePostRequest.md)| New MetricMap Feature data |
 **envelope** | **String**| The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. | [optional] [enum: yes, no]
 **i4lProcessUid** | **String**| Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. | [optional]

### Return type

[**MetricMapFeaturesEndpointType**](MetricMapFeaturesEndpointType.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="updateMetricMapFeature"></a>
# **updateMetricMapFeature**
> MetricMapFeaturesEndpointType updateMetricMapFeature(mmfUid, patchmetricmapfeature, envelope, i4lProcessUid)

Updates a metric map feature

Updates a metric map feature. Only fgroup, fname, ftype, fsubtype and fURI can be updated

### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.MetricMapFeaturesApi;


MetricMapFeaturesApi apiInstance = new MetricMapFeaturesApi();
String mmfUid = "mmfUid_example"; // String | MetricMapFeature UID
RFC6902PatchRequest patchmetricmapfeature = new RFC6902PatchRequest(); // RFC6902PatchRequest | Update data
String envelope = "envelope_example"; // String | The endpoint can package everything (header, status code) neatly into the response body. Include envelope=true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
String i4lProcessUid = "i4lProcessUid_example"; // String | Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process.
try {
    MetricMapFeaturesEndpointType result = apiInstance.updateMetricMapFeature(mmfUid, patchmetricmapfeature, envelope, i4lProcessUid);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling MetricMapFeaturesApi#updateMetricMapFeature");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **mmfUid** | **String**| MetricMapFeature UID |
 **patchmetricmapfeature** | [**RFC6902PatchRequest**](RFC6902PatchRequest.md)| Update data |
 **envelope** | **String**| The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. | [optional] [enum: yes, no]
 **i4lProcessUid** | **String**| Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. | [optional]

### Return type

[**MetricMapFeaturesEndpointType**](MetricMapFeaturesEndpointType.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

