# SpatialUnitsApi

All URIs are relative to *https://platform.its4land.com*

Method | HTTP request | Description
------------- | ------------- | -------------
[**create2PpolygonSPUfromBFS**](SpatialUnitsApi.md#create2PpolygonSPUfromBFS) | **POST** /spatialunits/create2Dpolygonspatialunit | Creates a spatial unit
[**getSpatialUnitByUID**](SpatialUnitsApi.md#getSpatialUnitByUID) | **GET** /spatialunits/qualitative/{spatialunit_uid} | Returns a single spatial unit
[**getSpatialUnitConceptByUID**](SpatialUnitsApi.md#getSpatialUnitConceptByUID) | **GET** /spatialunits/concepts/{concept_uid} | Returns a single spatial unit concept
[**getSpatialUnits**](SpatialUnitsApi.md#getSpatialUnits) | **GET** /spatialunits | Returns a list of SpatialUnits in a GeoJSON structure.
[**getSpatialUnitsByUUID**](SpatialUnitsApi.md#getSpatialUnitsByUUID) | **GET** /spatialunits/{spatialunit_uid} | Returns a list of SpatialUnits
[**getSpatialUnitsConcepts**](SpatialUnitsApi.md#getSpatialUnitsConcepts) | **GET** /spatialunits/concepts | Returns a list of spatial units concepts
[**getSpatialUnitsQualitative**](SpatialUnitsApi.md#getSpatialUnitsQualitative) | **GET** /spatialunits/qualitative | Returns a list of SpatialUnits
[**newSpatialUnit**](SpatialUnitsApi.md#newSpatialUnit) | **POST** /spatialunits | Create a new SpatialUnit
[**newSpatialUnitConcept**](SpatialUnitsApi.md#newSpatialUnitConcept) | **POST** /spatialunits/concepts | Create a new concept for a spatial unit
[**newSpatialUnitQualitative**](SpatialUnitsApi.md#newSpatialUnitQualitative) | **POST** /spatialunits/qualitative | Create a new SpatialUnit
[**updateSpatialUnit**](SpatialUnitsApi.md#updateSpatialUnit) | **PATCH** /spatialunits/{spatialunit_uid} | Update an spatial unit
[**updateSpatialUnitConcept**](SpatialUnitsApi.md#updateSpatialUnitConcept) | **PATCH** /spatialunits/concepts/{concept_uid} | Updates a new spatial unit concept
[**updateSpatialUnitQualitative**](SpatialUnitsApi.md#updateSpatialUnitQualitative) | **PATCH** /spatialunits/qualitative/{spatialunit_uid} | Updates a new SpatialUnit


<a name="create2PpolygonSPUfromBFS"></a>
# **create2PpolygonSPUfromBFS**
> SpatialUnitsFeatureEndpointType create2PpolygonSPUfromBFS(spatialunitdata, envelope, i4lProcessUid, embed)

Creates a spatial unit

Create a 2D polygon base spatial unit from a boundary face string  as GeoJSON

### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.SpatialUnitsApi;


SpatialUnitsApi apiInstance = new SpatialUnitsApi();
SpatialUnitBaseFeaturePostRequest spatialunitdata = new SpatialUnitBaseFeaturePostRequest(); // SpatialUnitBaseFeaturePostRequest | Update data
String envelope = "envelope_example"; // String | The endpoint can package everything (header, status code) neatly into the response body. Include envelope=true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
String i4lProcessUid = "i4lProcessUid_example"; // String | Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process.
List<String> embed = Arrays.asList("embed_example"); // List<String> | Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name)
try {
    SpatialUnitsFeatureEndpointType result = apiInstance.create2PpolygonSPUfromBFS(spatialunitdata, envelope, i4lProcessUid, embed);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling SpatialUnitsApi#create2PpolygonSPUfromBFS");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **spatialunitdata** | [**SpatialUnitBaseFeaturePostRequest**](SpatialUnitBaseFeaturePostRequest.md)| Update data |
 **envelope** | **String**| The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. | [optional] [enum: yes, no]
 **i4lProcessUid** | **String**| Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. | [optional]
 **embed** | [**List&lt;String&gt;**](String.md)| Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) | [optional]

### Return type

[**SpatialUnitsFeatureEndpointType**](SpatialUnitsFeatureEndpointType.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="getSpatialUnitByUID"></a>
# **getSpatialUnitByUID**
> SpatialUnitsFeatureEndpointType getSpatialUnitByUID(spatialunitUid, envelope, embed)

Returns a single spatial unit

Returns a single spatial unit with qualitative base qualitative base spatial profile

### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.SpatialUnitsApi;


SpatialUnitsApi apiInstance = new SpatialUnitsApi();
String spatialunitUid = "spatialunitUid_example"; // String | Spatial unit UID
String envelope = "envelope_example"; // String | The endpoint can package everything (header, status code) neatly into the response body. Include envelope=true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
List<String> embed = Arrays.asList("embed_example"); // List<String> | Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name)
try {
    SpatialUnitsFeatureEndpointType result = apiInstance.getSpatialUnitByUID(spatialunitUid, envelope, embed);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling SpatialUnitsApi#getSpatialUnitByUID");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **spatialunitUid** | **String**| Spatial unit UID |
 **envelope** | **String**| The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. | [optional] [enum: yes, no]
 **embed** | [**List&lt;String&gt;**](String.md)| Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) | [optional]

### Return type

[**SpatialUnitsFeatureEndpointType**](SpatialUnitsFeatureEndpointType.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="getSpatialUnitConceptByUID"></a>
# **getSpatialUnitConceptByUID**
> SpatialUnitConceptEndpointType getSpatialUnitConceptByUID(conceptUid, envelope, embed)

Returns a single spatial unit concept

Returns a single spatial unit concept

### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.SpatialUnitsApi;


SpatialUnitsApi apiInstance = new SpatialUnitsApi();
String conceptUid = "conceptUid_example"; // String | Spatial unit concept UID
String envelope = "envelope_example"; // String | The endpoint can package everything (header, status code) neatly into the response body. Include envelope=true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
List<String> embed = Arrays.asList("embed_example"); // List<String> | Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name)
try {
    SpatialUnitConceptEndpointType result = apiInstance.getSpatialUnitConceptByUID(conceptUid, envelope, embed);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling SpatialUnitsApi#getSpatialUnitConceptByUID");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **conceptUid** | **String**| Spatial unit concept UID |
 **envelope** | **String**| The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. | [optional] [enum: yes, no]
 **embed** | [**List&lt;String&gt;**](String.md)| Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) | [optional]

### Return type

[**SpatialUnitConceptEndpointType**](SpatialUnitConceptEndpointType.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="getSpatialUnits"></a>
# **getSpatialUnits**
> List&lt;SpatialUnitsFeatureEndpointType&gt; getSpatialUnits(querywindow, envelope, uid, name, concept, level, projects, adminsource, tags, page, sort, fields, embed)

Returns a list of SpatialUnits in a GeoJSON structure.

Returns a list of SpatialUnits as GeoJSON feature with 2D polygon base spatial profile

### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.SpatialUnitsApi;


SpatialUnitsApi apiInstance = new SpatialUnitsApi();
String querywindow = "querywindow_example"; // String | Polygon. The polygon is encoded a comma separated list of coordinates. X1, Y1, X2, Y2, ..., Xn, Yn, X1, Y1
String envelope = "envelope_example"; // String | The endpoint can package everything (header, status code) neatly into the response body. Include envelope=true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
List<String> uid = Arrays.asList("uid_example"); // List<String> | Comma separated list of AdminSources UID
List<String> name = Arrays.asList("name_example"); // List<String> | Comma separated list of AdminSources names
List<String> concept = Arrays.asList("concept_example"); // List<String> | Comma separated list of Spatial Unit concepts
List<String> level = Arrays.asList("level_example"); // List<String> | Comma separated list of LADM Levels
List<String> projects = Arrays.asList("projects_example"); // List<String> | Comma separated list of project UID
List<String> adminsource = Arrays.asList("adminsource_example"); // List<String> | Comma separated list of SpatialSource UID
List<String> tags = Arrays.asList("tags_example"); // List<String> | Comma separated list of tags
Integer page = 56; // Integer | Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default.
String sort = "sort_example"; // String | The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by.
List<String> fields = Arrays.asList("fields_example"); // List<String> | Comma separated list of tags
List<String> embed = Arrays.asList("embed_example"); // List<String> | Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name)
try {
    List<SpatialUnitsFeatureEndpointType> result = apiInstance.getSpatialUnits(querywindow, envelope, uid, name, concept, level, projects, adminsource, tags, page, sort, fields, embed);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling SpatialUnitsApi#getSpatialUnits");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **querywindow** | **String**| Polygon. The polygon is encoded a comma separated list of coordinates. X1, Y1, X2, Y2, ..., Xn, Yn, X1, Y1 |
 **envelope** | **String**| The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. | [optional] [enum: yes, no]
 **uid** | [**List&lt;String&gt;**](String.md)| Comma separated list of AdminSources UID | [optional]
 **name** | [**List&lt;String&gt;**](String.md)| Comma separated list of AdminSources names | [optional]
 **concept** | [**List&lt;String&gt;**](String.md)| Comma separated list of Spatial Unit concepts | [optional]
 **level** | [**List&lt;String&gt;**](String.md)| Comma separated list of LADM Levels | [optional]
 **projects** | [**List&lt;String&gt;**](String.md)| Comma separated list of project UID | [optional]
 **adminsource** | [**List&lt;String&gt;**](String.md)| Comma separated list of SpatialSource UID | [optional]
 **tags** | [**List&lt;String&gt;**](String.md)| Comma separated list of tags | [optional]
 **page** | **Integer**| Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. | [optional]
 **sort** | **String**| The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. | [optional]
 **fields** | [**List&lt;String&gt;**](String.md)| Comma separated list of tags | [optional]
 **embed** | [**List&lt;String&gt;**](String.md)| Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) | [optional]

### Return type

[**List&lt;SpatialUnitsFeatureEndpointType&gt;**](SpatialUnitsFeatureEndpointType.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="getSpatialUnitsByUUID"></a>
# **getSpatialUnitsByUUID**
> List&lt;SpatialUnitsFeatureEndpointType&gt; getSpatialUnitsByUUID(spatialunitUid, envelope, embed)

Returns a list of SpatialUnits

Returns a list of SpatialUnits as feature with 2d polygon base spatial profile

### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.SpatialUnitsApi;


SpatialUnitsApi apiInstance = new SpatialUnitsApi();
String spatialunitUid = "spatialunitUid_example"; // String | Spatial unit UID
String envelope = "envelope_example"; // String | The endpoint can package everything (header, status code) neatly into the response body. Include envelope=true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
List<String> embed = Arrays.asList("embed_example"); // List<String> | Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name)
try {
    List<SpatialUnitsFeatureEndpointType> result = apiInstance.getSpatialUnitsByUUID(spatialunitUid, envelope, embed);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling SpatialUnitsApi#getSpatialUnitsByUUID");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **spatialunitUid** | **String**| Spatial unit UID |
 **envelope** | **String**| The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. | [optional] [enum: yes, no]
 **embed** | [**List&lt;String&gt;**](String.md)| Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) | [optional]

### Return type

[**List&lt;SpatialUnitsFeatureEndpointType&gt;**](SpatialUnitsFeatureEndpointType.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="getSpatialUnitsConcepts"></a>
# **getSpatialUnitsConcepts**
> List&lt;SpatialUnitsFeatureEndpointType&gt; getSpatialUnitsConcepts(envelope, uid, name, projects, spatialunit, tags, page, sort, fields, embed)

Returns a list of spatial units concepts

Returns a list of spatial units concepts

### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.SpatialUnitsApi;


SpatialUnitsApi apiInstance = new SpatialUnitsApi();
String envelope = "envelope_example"; // String | The endpoint can package everything (header, status code) neatly into the response body. Include envelope=true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
List<String> uid = Arrays.asList("uid_example"); // List<String> | Comma separated list of Spatial unit UID
List<String> name = Arrays.asList("name_example"); // List<String> | Comma separated list of AdminSources names
List<String> projects = Arrays.asList("projects_example"); // List<String> | Comma separated list of project UID
List<String> spatialunit = Arrays.asList("spatialunit_example"); // List<String> | Comma separated list of SpatialSource UID
List<String> tags = Arrays.asList("tags_example"); // List<String> | Comma separated list of tags
Integer page = 56; // Integer | Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default.
String sort = "sort_example"; // String | The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by.
List<String> fields = Arrays.asList("fields_example"); // List<String> | Comma separated list of tags
List<String> embed = Arrays.asList("embed_example"); // List<String> | Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name)
try {
    List<SpatialUnitsFeatureEndpointType> result = apiInstance.getSpatialUnitsConcepts(envelope, uid, name, projects, spatialunit, tags, page, sort, fields, embed);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling SpatialUnitsApi#getSpatialUnitsConcepts");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **envelope** | **String**| The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. | [optional] [enum: yes, no]
 **uid** | [**List&lt;String&gt;**](String.md)| Comma separated list of Spatial unit UID | [optional]
 **name** | [**List&lt;String&gt;**](String.md)| Comma separated list of AdminSources names | [optional]
 **projects** | [**List&lt;String&gt;**](String.md)| Comma separated list of project UID | [optional]
 **spatialunit** | [**List&lt;String&gt;**](String.md)| Comma separated list of SpatialSource UID | [optional]
 **tags** | [**List&lt;String&gt;**](String.md)| Comma separated list of tags | [optional]
 **page** | **Integer**| Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. | [optional]
 **sort** | **String**| The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. | [optional]
 **fields** | [**List&lt;String&gt;**](String.md)| Comma separated list of tags | [optional]
 **embed** | [**List&lt;String&gt;**](String.md)| Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) | [optional]

### Return type

[**List&lt;SpatialUnitsFeatureEndpointType&gt;**](SpatialUnitsFeatureEndpointType.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="getSpatialUnitsQualitative"></a>
# **getSpatialUnitsQualitative**
> List&lt;SpatialUnitsFeatureEndpointType&gt; getSpatialUnitsQualitative(querywindow, envelope, uid, name, concept, level, projects, adminsource, tags, page, sort, fields, embed)

Returns a list of SpatialUnits

Returns a list of SpatialUnits as feature with geometry

### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.SpatialUnitsApi;


SpatialUnitsApi apiInstance = new SpatialUnitsApi();
String querywindow = "querywindow_example"; // String | Polygon. The polygon is encoded a comma separated list of coordinates. X1, Y1, X2, Y2, ..., Xn, Yn, X1, Y1
String envelope = "envelope_example"; // String | The endpoint can package everything (header, status code) neatly into the response body. Include envelope=true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
List<String> uid = Arrays.asList("uid_example"); // List<String> | Comma separated list of Spatial unit UID
List<String> name = Arrays.asList("name_example"); // List<String> | Comma separated list of AdminSources names
List<String> concept = Arrays.asList("concept_example"); // List<String> | Comma separated list of Spatial Unit concepts
List<String> level = Arrays.asList("level_example"); // List<String> | Comma separated list of LADM Levels
List<String> projects = Arrays.asList("projects_example"); // List<String> | Comma separated list of project UID
List<String> adminsource = Arrays.asList("adminsource_example"); // List<String> | Comma separated list of SpatialSource UID
List<String> tags = Arrays.asList("tags_example"); // List<String> | Comma separated list of tags
Integer page = 56; // Integer | Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default.
String sort = "sort_example"; // String | The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by.
List<String> fields = Arrays.asList("fields_example"); // List<String> | Comma separated list of tags
List<String> embed = Arrays.asList("embed_example"); // List<String> | Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name)
try {
    List<SpatialUnitsFeatureEndpointType> result = apiInstance.getSpatialUnitsQualitative(querywindow, envelope, uid, name, concept, level, projects, adminsource, tags, page, sort, fields, embed);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling SpatialUnitsApi#getSpatialUnitsQualitative");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **querywindow** | **String**| Polygon. The polygon is encoded a comma separated list of coordinates. X1, Y1, X2, Y2, ..., Xn, Yn, X1, Y1 |
 **envelope** | **String**| The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. | [optional] [enum: yes, no]
 **uid** | [**List&lt;String&gt;**](String.md)| Comma separated list of Spatial unit UID | [optional]
 **name** | [**List&lt;String&gt;**](String.md)| Comma separated list of AdminSources names | [optional]
 **concept** | [**List&lt;String&gt;**](String.md)| Comma separated list of Spatial Unit concepts | [optional]
 **level** | [**List&lt;String&gt;**](String.md)| Comma separated list of LADM Levels | [optional]
 **projects** | [**List&lt;String&gt;**](String.md)| Comma separated list of project UID | [optional]
 **adminsource** | [**List&lt;String&gt;**](String.md)| Comma separated list of SpatialSource UID | [optional]
 **tags** | [**List&lt;String&gt;**](String.md)| Comma separated list of tags | [optional]
 **page** | **Integer**| Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. | [optional]
 **sort** | **String**| The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. | [optional]
 **fields** | [**List&lt;String&gt;**](String.md)| Comma separated list of tags | [optional]
 **embed** | [**List&lt;String&gt;**](String.md)| Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) | [optional]

### Return type

[**List&lt;SpatialUnitsFeatureEndpointType&gt;**](SpatialUnitsFeatureEndpointType.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="newSpatialUnit"></a>
# **newSpatialUnit**
> SpatialUnitsFeatureEndpointType newSpatialUnit(newspatialunit, envelope, embed, i4lProcessUid)

Create a new SpatialUnit

Create a new SpatialUnit with 2d polygon base spatial profile. The spatial unit is modeled as a GeoJSON feature. The endpoint currently allows only one spatial unit per request.

### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.SpatialUnitsApi;


SpatialUnitsApi apiInstance = new SpatialUnitsApi();
SpatialUnitsFeaturePostRequest newspatialunit = new SpatialUnitsFeaturePostRequest(); // SpatialUnitsFeaturePostRequest | New Spatial Unit data
String envelope = "envelope_example"; // String | The endpoint can package everything (header, status code) neatly into the response body. Include envelope=true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
List<String> embed = Arrays.asList("embed_example"); // List<String> | Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name)
String i4lProcessUid = "i4lProcessUid_example"; // String | Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process.
try {
    SpatialUnitsFeatureEndpointType result = apiInstance.newSpatialUnit(newspatialunit, envelope, embed, i4lProcessUid);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling SpatialUnitsApi#newSpatialUnit");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **newspatialunit** | [**SpatialUnitsFeaturePostRequest**](SpatialUnitsFeaturePostRequest.md)| New Spatial Unit data |
 **envelope** | **String**| The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. | [optional] [enum: yes, no]
 **embed** | [**List&lt;String&gt;**](String.md)| Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) | [optional]
 **i4lProcessUid** | **String**| Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. | [optional]

### Return type

[**SpatialUnitsFeatureEndpointType**](SpatialUnitsFeatureEndpointType.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="newSpatialUnitConcept"></a>
# **newSpatialUnitConcept**
> SpatialUnitConceptEndpointType newSpatialUnitConcept(newspatialunitconcept, envelope, embed, i4lProcessUid)

Create a new concept for a spatial unit

Create a new concept for a spatial unit.

### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.SpatialUnitsApi;


SpatialUnitsApi apiInstance = new SpatialUnitsApi();
SpatialUnitConceptPostRequest newspatialunitconcept = new SpatialUnitConceptPostRequest(); // SpatialUnitConceptPostRequest | New Spatial Unit concept data
String envelope = "envelope_example"; // String | The endpoint can package everything (header, status code) neatly into the response body. Include envelope=true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
List<String> embed = Arrays.asList("embed_example"); // List<String> | Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name)
String i4lProcessUid = "i4lProcessUid_example"; // String | Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process.
try {
    SpatialUnitConceptEndpointType result = apiInstance.newSpatialUnitConcept(newspatialunitconcept, envelope, embed, i4lProcessUid);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling SpatialUnitsApi#newSpatialUnitConcept");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **newspatialunitconcept** | [**SpatialUnitConceptPostRequest**](SpatialUnitConceptPostRequest.md)| New Spatial Unit concept data |
 **envelope** | **String**| The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. | [optional] [enum: yes, no]
 **embed** | [**List&lt;String&gt;**](String.md)| Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) | [optional]
 **i4lProcessUid** | **String**| Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. | [optional]

### Return type

[**SpatialUnitConceptEndpointType**](SpatialUnitConceptEndpointType.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="newSpatialUnitQualitative"></a>
# **newSpatialUnitQualitative**
> SpatialUnitsFeatureEndpointType newSpatialUnitQualitative(newspatialunit, envelope, embed, i4lProcessUid)

Create a new SpatialUnit

Create a new SpatialUnit with qualitative base spatial profile

### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.SpatialUnitsApi;


SpatialUnitsApi apiInstance = new SpatialUnitsApi();
SpatialUnitsFeaturePostRequest newspatialunit = new SpatialUnitsFeaturePostRequest(); // SpatialUnitsFeaturePostRequest | New Spatial Unit data
String envelope = "envelope_example"; // String | The endpoint can package everything (header, status code) neatly into the response body. Include envelope=true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
List<String> embed = Arrays.asList("embed_example"); // List<String> | Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name)
String i4lProcessUid = "i4lProcessUid_example"; // String | Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process.
try {
    SpatialUnitsFeatureEndpointType result = apiInstance.newSpatialUnitQualitative(newspatialunit, envelope, embed, i4lProcessUid);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling SpatialUnitsApi#newSpatialUnitQualitative");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **newspatialunit** | [**SpatialUnitsFeaturePostRequest**](SpatialUnitsFeaturePostRequest.md)| New Spatial Unit data |
 **envelope** | **String**| The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. | [optional] [enum: yes, no]
 **embed** | [**List&lt;String&gt;**](String.md)| Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) | [optional]
 **i4lProcessUid** | **String**| Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. | [optional]

### Return type

[**SpatialUnitsFeatureEndpointType**](SpatialUnitsFeatureEndpointType.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="updateSpatialUnit"></a>
# **updateSpatialUnit**
> SpatialUnitsFeatureEndpointType updateSpatialUnit(spatialunitUid, patchspatialunit, envelope, i4lProcessUid)

Update an spatial unit

Update an spatial unit with 2d polygon base spatial profile

### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.SpatialUnitsApi;


SpatialUnitsApi apiInstance = new SpatialUnitsApi();
String spatialunitUid = "spatialunitUid_example"; // String | Spatial unit UID
RFC6902PatchRequest patchspatialunit = new RFC6902PatchRequest(); // RFC6902PatchRequest | Update data
String envelope = "envelope_example"; // String | The endpoint can package everything (header, status code) neatly into the response body. Include envelope=true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
String i4lProcessUid = "i4lProcessUid_example"; // String | Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process.
try {
    SpatialUnitsFeatureEndpointType result = apiInstance.updateSpatialUnit(spatialunitUid, patchspatialunit, envelope, i4lProcessUid);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling SpatialUnitsApi#updateSpatialUnit");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **spatialunitUid** | **String**| Spatial unit UID |
 **patchspatialunit** | [**RFC6902PatchRequest**](RFC6902PatchRequest.md)| Update data |
 **envelope** | **String**| The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. | [optional] [enum: yes, no]
 **i4lProcessUid** | **String**| Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. | [optional]

### Return type

[**SpatialUnitsFeatureEndpointType**](SpatialUnitsFeatureEndpointType.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="updateSpatialUnitConcept"></a>
# **updateSpatialUnitConcept**
> SpatialUnitConceptEndpointType updateSpatialUnitConcept(conceptUid, patchspatialunitconcept, envelope, i4lProcessUid)

Updates a new spatial unit concept

Updates a spatial unit concept

### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.SpatialUnitsApi;


SpatialUnitsApi apiInstance = new SpatialUnitsApi();
String conceptUid = "conceptUid_example"; // String | Spatial unit concept UID
RFC6902PatchRequest patchspatialunitconcept = new RFC6902PatchRequest(); // RFC6902PatchRequest | Update data
String envelope = "envelope_example"; // String | The endpoint can package everything (header, status code) neatly into the response body. Include envelope=true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
String i4lProcessUid = "i4lProcessUid_example"; // String | Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process.
try {
    SpatialUnitConceptEndpointType result = apiInstance.updateSpatialUnitConcept(conceptUid, patchspatialunitconcept, envelope, i4lProcessUid);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling SpatialUnitsApi#updateSpatialUnitConcept");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **conceptUid** | **String**| Spatial unit concept UID |
 **patchspatialunitconcept** | [**RFC6902PatchRequest**](RFC6902PatchRequest.md)| Update data |
 **envelope** | **String**| The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. | [optional] [enum: yes, no]
 **i4lProcessUid** | **String**| Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. | [optional]

### Return type

[**SpatialUnitConceptEndpointType**](SpatialUnitConceptEndpointType.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="updateSpatialUnitQualitative"></a>
# **updateSpatialUnitQualitative**
> SpatialUnitsFeatureEndpointType updateSpatialUnitQualitative(spatialunitUid, patchspatialunit, envelope, i4lProcessUid)

Updates a new SpatialUnit

Updates SpatialUnit with qualitative base spatial profile

### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.SpatialUnitsApi;


SpatialUnitsApi apiInstance = new SpatialUnitsApi();
String spatialunitUid = "spatialunitUid_example"; // String | Spatial unit UID
RFC6902PatchRequest patchspatialunit = new RFC6902PatchRequest(); // RFC6902PatchRequest | Update data
String envelope = "envelope_example"; // String | The endpoint can package everything (header, status code) neatly into the response body. Include envelope=true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
String i4lProcessUid = "i4lProcessUid_example"; // String | Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process.
try {
    SpatialUnitsFeatureEndpointType result = apiInstance.updateSpatialUnitQualitative(spatialunitUid, patchspatialunit, envelope, i4lProcessUid);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling SpatialUnitsApi#updateSpatialUnitQualitative");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **spatialunitUid** | **String**| Spatial unit UID |
 **patchspatialunit** | [**RFC6902PatchRequest**](RFC6902PatchRequest.md)| Update data |
 **envelope** | **String**| The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. | [optional] [enum: yes, no]
 **i4lProcessUid** | **String**| Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. | [optional]

### Return type

[**SpatialUnitsFeatureEndpointType**](SpatialUnitsFeatureEndpointType.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

