# Wp5ValidationSetsApi

All URIs are relative to *https://platform.its4land.com*

Method | HTTP request | Description
------------- | ------------- | -------------
[**getWP5ValidationSetByUID**](Wp5ValidationSetsApi.md#getWP5ValidationSetByUID) | **GET** /WP5ValidationSets/{wp5validationset_uid} | Returns a single WP5ValidationSet
[**getWP5ValidationSets**](Wp5ValidationSetsApi.md#getWP5ValidationSets) | **GET** /WP5ValidationSets | Returns a list of WP5ValidationSets
[**newWP5ValidationSets**](Wp5ValidationSetsApi.md#newWP5ValidationSets) | **POST** /WP5ValidationSets | Create a new WP5ValidationSets


<a name="getWP5ValidationSetByUID"></a>
# **getWP5ValidationSetByUID**
> WP5ValidationSetsEndpointType getWP5ValidationSetByUID(wp5validationsetUid, envelope, embed)

Returns a single WP5ValidationSet

Returns a single WP5ValidationSet

### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.Wp5ValidationSetsApi;


Wp5ValidationSetsApi apiInstance = new Wp5ValidationSetsApi();
String wp5validationsetUid = "wp5validationsetUid_example"; // String | WP5ValidationSet UID
String envelope = "envelope_example"; // String | The endpoint can package everything (header, status code) neatly into the response body. Include envelope=true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
List<String> embed = Arrays.asList("embed_example"); // List<String> | Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name)
try {
    WP5ValidationSetsEndpointType result = apiInstance.getWP5ValidationSetByUID(wp5validationsetUid, envelope, embed);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling Wp5ValidationSetsApi#getWP5ValidationSetByUID");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **wp5validationsetUid** | **String**| WP5ValidationSet UID |
 **envelope** | **String**| The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. | [optional] [enum: yes, no]
 **embed** | [**List&lt;String&gt;**](String.md)| Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) | [optional]

### Return type

[**WP5ValidationSetsEndpointType**](WP5ValidationSetsEndpointType.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="getWP5ValidationSets"></a>
# **getWP5ValidationSets**
> List&lt;WP5ValidationSetsEndpointType&gt; getWP5ValidationSets(envelope, uid, name, models, projects, tags, page, sort, fields, embed)

Returns a list of WP5ValidationSets

Returns a list of WP5ValidationSets

### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.Wp5ValidationSetsApi;


Wp5ValidationSetsApi apiInstance = new Wp5ValidationSetsApi();
String envelope = "envelope_example"; // String | The endpoint can package everything (header, status code) neatly into the response body. Include envelope=true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
List<String> uid = Arrays.asList("uid_example"); // List<String> | Comma separated list of TrainingSet UID
List<String> name = Arrays.asList("name_example"); // List<String> | Comma separated list of WP5ValidationSets Names
List<String> models = Arrays.asList("models_example"); // List<String> | Comma separated list of model UID
List<String> projects = Arrays.asList("projects_example"); // List<String> | Comma separated list of project UID
List<String> tags = Arrays.asList("tags_example"); // List<String> | Comma separated list of tags
Integer page = 56; // Integer | Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default.
String sort = "sort_example"; // String | The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by.
List<String> fields = Arrays.asList("fields_example"); // List<String> | Comma separated list of field names
List<String> embed = Arrays.asList("embed_example"); // List<String> | Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name)
try {
    List<WP5ValidationSetsEndpointType> result = apiInstance.getWP5ValidationSets(envelope, uid, name, models, projects, tags, page, sort, fields, embed);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling Wp5ValidationSetsApi#getWP5ValidationSets");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **envelope** | **String**| The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. | [optional] [enum: yes, no]
 **uid** | [**List&lt;String&gt;**](String.md)| Comma separated list of TrainingSet UID | [optional]
 **name** | [**List&lt;String&gt;**](String.md)| Comma separated list of WP5ValidationSets Names | [optional]
 **models** | [**List&lt;String&gt;**](String.md)| Comma separated list of model UID | [optional]
 **projects** | [**List&lt;String&gt;**](String.md)| Comma separated list of project UID | [optional]
 **tags** | [**List&lt;String&gt;**](String.md)| Comma separated list of tags | [optional]
 **page** | **Integer**| Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. | [optional]
 **sort** | **String**| The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. | [optional]
 **fields** | [**List&lt;String&gt;**](String.md)| Comma separated list of field names | [optional]
 **embed** | [**List&lt;String&gt;**](String.md)| Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) | [optional]

### Return type

[**List&lt;WP5ValidationSetsEndpointType&gt;**](WP5ValidationSetsEndpointType.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="newWP5ValidationSets"></a>
# **newWP5ValidationSets**
> WP5ValidationSetsEndpointType newWP5ValidationSets(newwp5validationsets, envelope, embed, i4lProcessUid)

Create a new WP5ValidationSets

Create a new TrainingSet. To add a new WP5ValidationSets , the content of WP5ValidationSets  must be stored in advanced via the ContentItem endpoint

### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.Wp5ValidationSetsApi;


Wp5ValidationSetsApi apiInstance = new Wp5ValidationSetsApi();
WP5ValidationSetsPostRequest newwp5validationsets = new WP5ValidationSetsPostRequest(); // WP5ValidationSetsPostRequest | New WP5ValidationSet data
String envelope = "envelope_example"; // String | The endpoint can package everything (header, status code) neatly into the response body. Include envelope=true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
List<String> embed = Arrays.asList("embed_example"); // List<String> | Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name)
String i4lProcessUid = "i4lProcessUid_example"; // String | Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process.
try {
    WP5ValidationSetsEndpointType result = apiInstance.newWP5ValidationSets(newwp5validationsets, envelope, embed, i4lProcessUid);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling Wp5ValidationSetsApi#newWP5ValidationSets");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **newwp5validationsets** | [**WP5ValidationSetsPostRequest**](WP5ValidationSetsPostRequest.md)| New WP5ValidationSet data |
 **envelope** | **String**| The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. | [optional] [enum: yes, no]
 **embed** | [**List&lt;String&gt;**](String.md)| Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) | [optional]
 **i4lProcessUid** | **String**| Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. | [optional]

### Return type

[**WP5ValidationSetsEndpointType**](WP5ValidationSetsEndpointType.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

