/*
 * its4land Public API
 * The its4land Public API provides access to the services of the its4land Publish and Share platform.
 *
 * OpenAPI spec version: 0.0.2
 * Contact: contact@its4land.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package io.swagger.client.api;

import io.swagger.client.ApiCallback;
import io.swagger.client.ApiClient;
import io.swagger.client.ApiException;
import io.swagger.client.ApiResponse;
import io.swagger.client.Configuration;
import io.swagger.client.Pair;
import io.swagger.client.ProgressRequestBody;
import io.swagger.client.ProgressResponseBody;

import com.google.gson.reflect.TypeToken;

import java.io.IOException;


import io.swagger.client.model.MetricMapFeaturePostRequest;
import io.swagger.client.model.MetricMapFeaturesEndpointType;
import io.swagger.client.model.RFC6902PatchRequest;

import java.lang.reflect.Type;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class MetricMapFeaturesApi {
    private ApiClient apiClient;

    public MetricMapFeaturesApi() {
        this(Configuration.getDefaultApiClient());
    }

    public MetricMapFeaturesApi(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    public ApiClient getApiClient() {
        return apiClient;
    }

    public void setApiClient(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    /**
     * Build call for getMetricMapFeature
     * @param querywindow Polygon. The polygon is encoded a comma separated list of coordinates. X1, Y1, X2, Y2, ..., Xn, Yn, X1, Y1 (required)
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param fgroup Restricts the output to the listed feature group (optional)
     * @param ftype Restricts the output to the listed feature types. When used in combination with fgroup, output contains only those ftype which are contained in the feature groups (optional)
     * @param fsubtype Restricts the output to the listed feature types. When used in combination with fgroup and/or ftype, output contains only those fsubtype which are contained in the feature groups and feature types (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call getMetricMapFeatureCall(String querywindow, String envelope, String fgroup, String ftype, String fsubtype, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;

        // create path and map variables
        String localVarPath = "/metricmapfeature";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (envelope != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("envelope", envelope));
        if (querywindow != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("querywindow", querywindow));
        if (fgroup != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("fgroup", fgroup));
        if (ftype != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("ftype", ftype));
        if (fsubtype != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("fsubtype", fsubtype));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call getMetricMapFeatureValidateBeforeCall(String querywindow, String envelope, String fgroup, String ftype, String fsubtype, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'querywindow' is set
        if (querywindow == null) {
            throw new ApiException("Missing the required parameter 'querywindow' when calling getMetricMapFeature(Async)");
        }
        

        com.squareup.okhttp.Call call = getMetricMapFeatureCall(querywindow, envelope, fgroup, ftype, fsubtype, progressListener, progressRequestListener);
        return call;

    }

    /**
     * Returns MetricMapFeature
     * Returns MetricMapFeature in a GeoJSON structure. A metric map feature is modeled as a feature in  the GeoJSON structure.
     * @param querywindow Polygon. The polygon is encoded a comma separated list of coordinates. X1, Y1, X2, Y2, ..., Xn, Yn, X1, Y1 (required)
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param fgroup Restricts the output to the listed feature group (optional)
     * @param ftype Restricts the output to the listed feature types. When used in combination with fgroup, output contains only those ftype which are contained in the feature groups (optional)
     * @param fsubtype Restricts the output to the listed feature types. When used in combination with fgroup and/or ftype, output contains only those fsubtype which are contained in the feature groups and feature types (optional)
     * @return MetricMapFeaturesEndpointType
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public MetricMapFeaturesEndpointType getMetricMapFeature(String querywindow, String envelope, String fgroup, String ftype, String fsubtype) throws ApiException {
        ApiResponse<MetricMapFeaturesEndpointType> resp = getMetricMapFeatureWithHttpInfo(querywindow, envelope, fgroup, ftype, fsubtype);
        return resp.getData();
    }

    /**
     * Returns MetricMapFeature
     * Returns MetricMapFeature in a GeoJSON structure. A metric map feature is modeled as a feature in  the GeoJSON structure.
     * @param querywindow Polygon. The polygon is encoded a comma separated list of coordinates. X1, Y1, X2, Y2, ..., Xn, Yn, X1, Y1 (required)
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param fgroup Restricts the output to the listed feature group (optional)
     * @param ftype Restricts the output to the listed feature types. When used in combination with fgroup, output contains only those ftype which are contained in the feature groups (optional)
     * @param fsubtype Restricts the output to the listed feature types. When used in combination with fgroup and/or ftype, output contains only those fsubtype which are contained in the feature groups and feature types (optional)
     * @return ApiResponse&lt;MetricMapFeaturesEndpointType&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<MetricMapFeaturesEndpointType> getMetricMapFeatureWithHttpInfo(String querywindow, String envelope, String fgroup, String ftype, String fsubtype) throws ApiException {
        com.squareup.okhttp.Call call = getMetricMapFeatureValidateBeforeCall(querywindow, envelope, fgroup, ftype, fsubtype, null, null);
        Type localVarReturnType = new TypeToken<MetricMapFeaturesEndpointType>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Returns MetricMapFeature (asynchronously)
     * Returns MetricMapFeature in a GeoJSON structure. A metric map feature is modeled as a feature in  the GeoJSON structure.
     * @param querywindow Polygon. The polygon is encoded a comma separated list of coordinates. X1, Y1, X2, Y2, ..., Xn, Yn, X1, Y1 (required)
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param fgroup Restricts the output to the listed feature group (optional)
     * @param ftype Restricts the output to the listed feature types. When used in combination with fgroup, output contains only those ftype which are contained in the feature groups (optional)
     * @param fsubtype Restricts the output to the listed feature types. When used in combination with fgroup and/or ftype, output contains only those fsubtype which are contained in the feature groups and feature types (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call getMetricMapFeatureAsync(String querywindow, String envelope, String fgroup, String ftype, String fsubtype, final ApiCallback<MetricMapFeaturesEndpointType> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = getMetricMapFeatureValidateBeforeCall(querywindow, envelope, fgroup, ftype, fsubtype, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<MetricMapFeaturesEndpointType>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for newMetricMapFeature
     * @param newmetricmapfeature New MetricMap Feature data (required)
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param i4lProcessUid Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call newMetricMapFeatureCall(MetricMapFeaturePostRequest newmetricmapfeature, String envelope, String i4lProcessUid, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = newmetricmapfeature;

        // create path and map variables
        String localVarPath = "/metricmapfeature";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (envelope != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("envelope", envelope));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        if (i4lProcessUid != null)
        localVarHeaderParams.put("i4l-process-uid", apiClient.parameterToString(i4lProcessUid));

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call newMetricMapFeatureValidateBeforeCall(MetricMapFeaturePostRequest newmetricmapfeature, String envelope, String i4lProcessUid, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'newmetricmapfeature' is set
        if (newmetricmapfeature == null) {
            throw new ApiException("Missing the required parameter 'newmetricmapfeature' when calling newMetricMapFeature(Async)");
        }
        

        com.squareup.okhttp.Call call = newMetricMapFeatureCall(newmetricmapfeature, envelope, i4lProcessUid, progressListener, progressRequestListener);
        return call;

    }

    /**
     * Create a new metricMapFeature
     * Create a new MetricMapFeature. The new metric map feature is a feature in the GeoJSON structure. Currently ony one new feature per request is allowed.
     * @param newmetricmapfeature New MetricMap Feature data (required)
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param i4lProcessUid Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)
     * @return MetricMapFeaturesEndpointType
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public MetricMapFeaturesEndpointType newMetricMapFeature(MetricMapFeaturePostRequest newmetricmapfeature, String envelope, String i4lProcessUid) throws ApiException {
        ApiResponse<MetricMapFeaturesEndpointType> resp = newMetricMapFeatureWithHttpInfo(newmetricmapfeature, envelope, i4lProcessUid);
        return resp.getData();
    }

    /**
     * Create a new metricMapFeature
     * Create a new MetricMapFeature. The new metric map feature is a feature in the GeoJSON structure. Currently ony one new feature per request is allowed.
     * @param newmetricmapfeature New MetricMap Feature data (required)
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param i4lProcessUid Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)
     * @return ApiResponse&lt;MetricMapFeaturesEndpointType&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<MetricMapFeaturesEndpointType> newMetricMapFeatureWithHttpInfo(MetricMapFeaturePostRequest newmetricmapfeature, String envelope, String i4lProcessUid) throws ApiException {
        com.squareup.okhttp.Call call = newMetricMapFeatureValidateBeforeCall(newmetricmapfeature, envelope, i4lProcessUid, null, null);
        Type localVarReturnType = new TypeToken<MetricMapFeaturesEndpointType>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Create a new metricMapFeature (asynchronously)
     * Create a new MetricMapFeature. The new metric map feature is a feature in the GeoJSON structure. Currently ony one new feature per request is allowed.
     * @param newmetricmapfeature New MetricMap Feature data (required)
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param i4lProcessUid Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call newMetricMapFeatureAsync(MetricMapFeaturePostRequest newmetricmapfeature, String envelope, String i4lProcessUid, final ApiCallback<MetricMapFeaturesEndpointType> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = newMetricMapFeatureValidateBeforeCall(newmetricmapfeature, envelope, i4lProcessUid, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<MetricMapFeaturesEndpointType>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for updateMetricMapFeature
     * @param mmfUid MetricMapFeature UID (required)
     * @param patchmetricmapfeature Update data (required)
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param i4lProcessUid Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call updateMetricMapFeatureCall(String mmfUid, RFC6902PatchRequest patchmetricmapfeature, String envelope, String i4lProcessUid, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = patchmetricmapfeature;

        // create path and map variables
        String localVarPath = "/metricmapfeature/{mmf_uid}"
            .replaceAll("\\{" + "mmf_uid" + "\\}", apiClient.escapeString(mmfUid.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (envelope != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("envelope", envelope));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        if (i4lProcessUid != null)
        localVarHeaderParams.put("i4l-process-uid", apiClient.parameterToString(i4lProcessUid));

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "PATCH", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call updateMetricMapFeatureValidateBeforeCall(String mmfUid, RFC6902PatchRequest patchmetricmapfeature, String envelope, String i4lProcessUid, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'mmfUid' is set
        if (mmfUid == null) {
            throw new ApiException("Missing the required parameter 'mmfUid' when calling updateMetricMapFeature(Async)");
        }
        
        // verify the required parameter 'patchmetricmapfeature' is set
        if (patchmetricmapfeature == null) {
            throw new ApiException("Missing the required parameter 'patchmetricmapfeature' when calling updateMetricMapFeature(Async)");
        }
        

        com.squareup.okhttp.Call call = updateMetricMapFeatureCall(mmfUid, patchmetricmapfeature, envelope, i4lProcessUid, progressListener, progressRequestListener);
        return call;

    }

    /**
     * Updates a metric map feature
     * Updates a metric map feature. Only fgroup, fname, ftype, fsubtype and fURI can be updated
     * @param mmfUid MetricMapFeature UID (required)
     * @param patchmetricmapfeature Update data (required)
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param i4lProcessUid Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)
     * @return MetricMapFeaturesEndpointType
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public MetricMapFeaturesEndpointType updateMetricMapFeature(String mmfUid, RFC6902PatchRequest patchmetricmapfeature, String envelope, String i4lProcessUid) throws ApiException {
        ApiResponse<MetricMapFeaturesEndpointType> resp = updateMetricMapFeatureWithHttpInfo(mmfUid, patchmetricmapfeature, envelope, i4lProcessUid);
        return resp.getData();
    }

    /**
     * Updates a metric map feature
     * Updates a metric map feature. Only fgroup, fname, ftype, fsubtype and fURI can be updated
     * @param mmfUid MetricMapFeature UID (required)
     * @param patchmetricmapfeature Update data (required)
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param i4lProcessUid Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)
     * @return ApiResponse&lt;MetricMapFeaturesEndpointType&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<MetricMapFeaturesEndpointType> updateMetricMapFeatureWithHttpInfo(String mmfUid, RFC6902PatchRequest patchmetricmapfeature, String envelope, String i4lProcessUid) throws ApiException {
        com.squareup.okhttp.Call call = updateMetricMapFeatureValidateBeforeCall(mmfUid, patchmetricmapfeature, envelope, i4lProcessUid, null, null);
        Type localVarReturnType = new TypeToken<MetricMapFeaturesEndpointType>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Updates a metric map feature (asynchronously)
     * Updates a metric map feature. Only fgroup, fname, ftype, fsubtype and fURI can be updated
     * @param mmfUid MetricMapFeature UID (required)
     * @param patchmetricmapfeature Update data (required)
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param i4lProcessUid Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call updateMetricMapFeatureAsync(String mmfUid, RFC6902PatchRequest patchmetricmapfeature, String envelope, String i4lProcessUid, final ApiCallback<MetricMapFeaturesEndpointType> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = updateMetricMapFeatureValidateBeforeCall(mmfUid, patchmetricmapfeature, envelope, i4lProcessUid, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<MetricMapFeaturesEndpointType>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
}
