/*
 * its4land Public API
 * The its4land Public API provides access to the services of the its4land Publish and Share platform.
 *
 * OpenAPI spec version: 0.0.2
 * Contact: contact@its4land.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package io.swagger.client.api;

import io.swagger.client.ApiCallback;
import io.swagger.client.ApiClient;
import io.swagger.client.ApiException;
import io.swagger.client.ApiResponse;
import io.swagger.client.Configuration;
import io.swagger.client.Pair;
import io.swagger.client.ProgressRequestBody;
import io.swagger.client.ProgressResponseBody;

import com.google.gson.reflect.TypeToken;

import java.io.IOException;


import io.swagger.client.model.LogEntryEndpointType;
import io.swagger.client.model.LogEntryPostRequest;
import io.swagger.client.model.ProcessEndpointType;
import io.swagger.client.model.ProcessPostRequest;

import java.lang.reflect.Type;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class ProcessesApi {
    private ApiClient apiClient;

    public ProcessesApi() {
        this(Configuration.getDefaultApiClient());
    }

    public ProcessesApi(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    public ApiClient getApiClient() {
        return apiClient;
    }

    public void setApiClient(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    /**
     * Build call for createProcessLog
     * @param processUid Process UID (required)
     * @param newlogentry New log entry (required)
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param i4lProcessUid Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call createProcessLogCall(String processUid, LogEntryPostRequest newlogentry, String envelope, String i4lProcessUid, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = newlogentry;

        // create path and map variables
        String localVarPath = "/processes/{process_uid}/log"
            .replaceAll("\\{" + "process_uid" + "\\}", apiClient.escapeString(processUid.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (envelope != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("envelope", envelope));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        if (i4lProcessUid != null)
        localVarHeaderParams.put("i4l-process-uid", apiClient.parameterToString(i4lProcessUid));

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call createProcessLogValidateBeforeCall(String processUid, LogEntryPostRequest newlogentry, String envelope, String i4lProcessUid, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'processUid' is set
        if (processUid == null) {
            throw new ApiException("Missing the required parameter 'processUid' when calling createProcessLog(Async)");
        }
        
        // verify the required parameter 'newlogentry' is set
        if (newlogentry == null) {
            throw new ApiException("Missing the required parameter 'newlogentry' when calling createProcessLog(Async)");
        }
        

        com.squareup.okhttp.Call call = createProcessLogCall(processUid, newlogentry, envelope, i4lProcessUid, progressListener, progressRequestListener);
        return call;

    }

    /**
     * Writes a single log entry
     * Writes a single log entry
     * @param processUid Process UID (required)
     * @param newlogentry New log entry (required)
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param i4lProcessUid Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)
     * @return LogEntryEndpointType
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public LogEntryEndpointType createProcessLog(String processUid, LogEntryPostRequest newlogentry, String envelope, String i4lProcessUid) throws ApiException {
        ApiResponse<LogEntryEndpointType> resp = createProcessLogWithHttpInfo(processUid, newlogentry, envelope, i4lProcessUid);
        return resp.getData();
    }

    /**
     * Writes a single log entry
     * Writes a single log entry
     * @param processUid Process UID (required)
     * @param newlogentry New log entry (required)
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param i4lProcessUid Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)
     * @return ApiResponse&lt;LogEntryEndpointType&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<LogEntryEndpointType> createProcessLogWithHttpInfo(String processUid, LogEntryPostRequest newlogentry, String envelope, String i4lProcessUid) throws ApiException {
        com.squareup.okhttp.Call call = createProcessLogValidateBeforeCall(processUid, newlogentry, envelope, i4lProcessUid, null, null);
        Type localVarReturnType = new TypeToken<LogEntryEndpointType>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Writes a single log entry (asynchronously)
     * Writes a single log entry
     * @param processUid Process UID (required)
     * @param newlogentry New log entry (required)
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param i4lProcessUid Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call createProcessLogAsync(String processUid, LogEntryPostRequest newlogentry, String envelope, String i4lProcessUid, final ApiCallback<LogEntryEndpointType> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = createProcessLogValidateBeforeCall(processUid, newlogentry, envelope, i4lProcessUid, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<LogEntryEndpointType>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for createProcesses
     * @param newprocess New process metadata (required)
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)
     * @param i4lProcessUid Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call createProcessesCall(ProcessPostRequest newprocess, String envelope, List<String> embed, String i4lProcessUid, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = newprocess;

        // create path and map variables
        String localVarPath = "/processes";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (envelope != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("envelope", envelope));
        if (embed != null)
        localVarCollectionQueryParams.addAll(apiClient.parameterToPairs("csv", "embed", embed));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        if (i4lProcessUid != null)
        localVarHeaderParams.put("i4l-process-uid", apiClient.parameterToString(i4lProcessUid));

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call createProcessesValidateBeforeCall(ProcessPostRequest newprocess, String envelope, List<String> embed, String i4lProcessUid, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'newprocess' is set
        if (newprocess == null) {
            throw new ApiException("Missing the required parameter 'newprocess' when calling createProcesses(Async)");
        }
        

        com.squareup.okhttp.Call call = createProcessesCall(newprocess, envelope, embed, i4lProcessUid, progressListener, progressRequestListener);
        return call;

    }

    /**
     * Creates a new  processes
     * Creates a new  processes
     * @param newprocess New process metadata (required)
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)
     * @param i4lProcessUid Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)
     * @return ProcessEndpointType
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ProcessEndpointType createProcesses(ProcessPostRequest newprocess, String envelope, List<String> embed, String i4lProcessUid) throws ApiException {
        ApiResponse<ProcessEndpointType> resp = createProcessesWithHttpInfo(newprocess, envelope, embed, i4lProcessUid);
        return resp.getData();
    }

    /**
     * Creates a new  processes
     * Creates a new  processes
     * @param newprocess New process metadata (required)
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)
     * @param i4lProcessUid Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)
     * @return ApiResponse&lt;ProcessEndpointType&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<ProcessEndpointType> createProcessesWithHttpInfo(ProcessPostRequest newprocess, String envelope, List<String> embed, String i4lProcessUid) throws ApiException {
        com.squareup.okhttp.Call call = createProcessesValidateBeforeCall(newprocess, envelope, embed, i4lProcessUid, null, null);
        Type localVarReturnType = new TypeToken<ProcessEndpointType>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Creates a new  processes (asynchronously)
     * Creates a new  processes
     * @param newprocess New process metadata (required)
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)
     * @param i4lProcessUid Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call createProcessesAsync(ProcessPostRequest newprocess, String envelope, List<String> embed, String i4lProcessUid, final ApiCallback<ProcessEndpointType> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = createProcessesValidateBeforeCall(newprocess, envelope, embed, i4lProcessUid, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<ProcessEndpointType>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for getProcessByUID
     * @param processUid Process UID (required)
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call getProcessByUIDCall(String processUid, String envelope, List<String> embed, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;

        // create path and map variables
        String localVarPath = "/processes/{process_uid}"
            .replaceAll("\\{" + "process_uid" + "\\}", apiClient.escapeString(processUid.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (envelope != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("envelope", envelope));
        if (embed != null)
        localVarCollectionQueryParams.addAll(apiClient.parameterToPairs("csv", "embed", embed));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call getProcessByUIDValidateBeforeCall(String processUid, String envelope, List<String> embed, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'processUid' is set
        if (processUid == null) {
            throw new ApiException("Missing the required parameter 'processUid' when calling getProcessByUID(Async)");
        }
        

        com.squareup.okhttp.Call call = getProcessByUIDCall(processUid, envelope, embed, progressListener, progressRequestListener);
        return call;

    }

    /**
     * Returns metadata for a single process
     * Returns metadata for a single process
     * @param processUid Process UID (required)
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)
     * @return ProcessEndpointType
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ProcessEndpointType getProcessByUID(String processUid, String envelope, List<String> embed) throws ApiException {
        ApiResponse<ProcessEndpointType> resp = getProcessByUIDWithHttpInfo(processUid, envelope, embed);
        return resp.getData();
    }

    /**
     * Returns metadata for a single process
     * Returns metadata for a single process
     * @param processUid Process UID (required)
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)
     * @return ApiResponse&lt;ProcessEndpointType&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<ProcessEndpointType> getProcessByUIDWithHttpInfo(String processUid, String envelope, List<String> embed) throws ApiException {
        com.squareup.okhttp.Call call = getProcessByUIDValidateBeforeCall(processUid, envelope, embed, null, null);
        Type localVarReturnType = new TypeToken<ProcessEndpointType>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Returns metadata for a single process (asynchronously)
     * Returns metadata for a single process
     * @param processUid Process UID (required)
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call getProcessByUIDAsync(String processUid, String envelope, List<String> embed, final ApiCallback<ProcessEndpointType> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = getProcessByUIDValidateBeforeCall(processUid, envelope, embed, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<ProcessEndpointType>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for getProcessLog
     * @param processUid Process UID (required)
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param loglevel LogLevel : error, info, warning, debug. Default is info. The higher order level includes the lower level (optional)
     * @param logsource Source of the log entry. Values: GUI, &lt;ToolName&gt; (optional)
     * @param page Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)
     * @param sort The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)
     * @param fields Comma separated list of field names (optional)
     * @param embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call getProcessLogCall(String processUid, String envelope, List<String> loglevel, List<String> logsource, Integer page, String sort, List<String> fields, List<String> embed, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;

        // create path and map variables
        String localVarPath = "/processes/{process_uid}/log"
            .replaceAll("\\{" + "process_uid" + "\\}", apiClient.escapeString(processUid.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (envelope != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("envelope", envelope));
        if (loglevel != null)
        localVarCollectionQueryParams.addAll(apiClient.parameterToPairs("csv", "loglevel", loglevel));
        if (logsource != null)
        localVarCollectionQueryParams.addAll(apiClient.parameterToPairs("csv", "logsource", logsource));
        if (page != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("page", page));
        if (sort != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("sort", sort));
        if (fields != null)
        localVarCollectionQueryParams.addAll(apiClient.parameterToPairs("csv", "fields", fields));
        if (embed != null)
        localVarCollectionQueryParams.addAll(apiClient.parameterToPairs("csv", "embed", embed));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call getProcessLogValidateBeforeCall(String processUid, String envelope, List<String> loglevel, List<String> logsource, Integer page, String sort, List<String> fields, List<String> embed, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'processUid' is set
        if (processUid == null) {
            throw new ApiException("Missing the required parameter 'processUid' when calling getProcessLog(Async)");
        }
        

        com.squareup.okhttp.Call call = getProcessLogCall(processUid, envelope, loglevel, logsource, page, sort, fields, embed, progressListener, progressRequestListener);
        return call;

    }

    /**
     * Get the full log of a process
     * Get the full log of a process. Oldest entry first
     * @param processUid Process UID (required)
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param loglevel LogLevel : error, info, warning, debug. Default is info. The higher order level includes the lower level (optional)
     * @param logsource Source of the log entry. Values: GUI, &lt;ToolName&gt; (optional)
     * @param page Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)
     * @param sort The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)
     * @param fields Comma separated list of field names (optional)
     * @param embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)
     * @return List&lt;LogEntryEndpointType&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public List<LogEntryEndpointType> getProcessLog(String processUid, String envelope, List<String> loglevel, List<String> logsource, Integer page, String sort, List<String> fields, List<String> embed) throws ApiException {
        ApiResponse<List<LogEntryEndpointType>> resp = getProcessLogWithHttpInfo(processUid, envelope, loglevel, logsource, page, sort, fields, embed);
        return resp.getData();
    }

    /**
     * Get the full log of a process
     * Get the full log of a process. Oldest entry first
     * @param processUid Process UID (required)
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param loglevel LogLevel : error, info, warning, debug. Default is info. The higher order level includes the lower level (optional)
     * @param logsource Source of the log entry. Values: GUI, &lt;ToolName&gt; (optional)
     * @param page Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)
     * @param sort The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)
     * @param fields Comma separated list of field names (optional)
     * @param embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)
     * @return ApiResponse&lt;List&lt;LogEntryEndpointType&gt;&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<List<LogEntryEndpointType>> getProcessLogWithHttpInfo(String processUid, String envelope, List<String> loglevel, List<String> logsource, Integer page, String sort, List<String> fields, List<String> embed) throws ApiException {
        com.squareup.okhttp.Call call = getProcessLogValidateBeforeCall(processUid, envelope, loglevel, logsource, page, sort, fields, embed, null, null);
        Type localVarReturnType = new TypeToken<List<LogEntryEndpointType>>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Get the full log of a process (asynchronously)
     * Get the full log of a process. Oldest entry first
     * @param processUid Process UID (required)
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param loglevel LogLevel : error, info, warning, debug. Default is info. The higher order level includes the lower level (optional)
     * @param logsource Source of the log entry. Values: GUI, &lt;ToolName&gt; (optional)
     * @param page Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)
     * @param sort The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)
     * @param fields Comma separated list of field names (optional)
     * @param embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call getProcessLogAsync(String processUid, String envelope, List<String> loglevel, List<String> logsource, Integer page, String sort, List<String> fields, List<String> embed, final ApiCallback<List<LogEntryEndpointType>> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = getProcessLogValidateBeforeCall(processUid, envelope, loglevel, logsource, page, sort, fields, embed, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<List<LogEntryEndpointType>>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for getProcesses
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param uid Comma separated list of Tag UID (optional)
     * @param project Comma separated list of project uid (optional)
     * @param status Status of the project. Can be one of:   * WAITING: Process is queued for execution   * RUNNING: Process is currently executing   * FINISHED: Process terminated normally   * ABORTED: Process terminated unexpectedly   * ZOMBIE: Process is listed in the platform process table, but the internal (process) API has no information about it. Possible in case of historical/archived processes or due to platform error.  (optional)
     * @param tooluid Comma separated list of tool UID (optional)
     * @param page Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)
     * @param sort The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)
     * @param fields Comma separated list of fields (optional)
     * @param embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call getProcessesCall(String envelope, List<String> uid, List<String> project, String status, List<String> tooluid, Integer page, String sort, List<String> fields, List<String> embed, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;

        // create path and map variables
        String localVarPath = "/processes";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (envelope != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("envelope", envelope));
        if (uid != null)
        localVarCollectionQueryParams.addAll(apiClient.parameterToPairs("csv", "uid", uid));
        if (project != null)
        localVarCollectionQueryParams.addAll(apiClient.parameterToPairs("csv", "project", project));
        if (status != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("status", status));
        if (tooluid != null)
        localVarCollectionQueryParams.addAll(apiClient.parameterToPairs("csv", "tooluid", tooluid));
        if (page != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("page", page));
        if (sort != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("sort", sort));
        if (fields != null)
        localVarCollectionQueryParams.addAll(apiClient.parameterToPairs("csv", "fields", fields));
        if (embed != null)
        localVarCollectionQueryParams.addAll(apiClient.parameterToPairs("csv", "embed", embed));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call getProcessesValidateBeforeCall(String envelope, List<String> uid, List<String> project, String status, List<String> tooluid, Integer page, String sort, List<String> fields, List<String> embed, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        

        com.squareup.okhttp.Call call = getProcessesCall(envelope, uid, project, status, tooluid, page, sort, fields, embed, progressListener, progressRequestListener);
        return call;

    }

    /**
     * Get a list of processes
     * Get a list of processes
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param uid Comma separated list of Tag UID (optional)
     * @param project Comma separated list of project uid (optional)
     * @param status Status of the project. Can be one of:   * WAITING: Process is queued for execution   * RUNNING: Process is currently executing   * FINISHED: Process terminated normally   * ABORTED: Process terminated unexpectedly   * ZOMBIE: Process is listed in the platform process table, but the internal (process) API has no information about it. Possible in case of historical/archived processes or due to platform error.  (optional)
     * @param tooluid Comma separated list of tool UID (optional)
     * @param page Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)
     * @param sort The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)
     * @param fields Comma separated list of fields (optional)
     * @param embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)
     * @return List&lt;ProcessEndpointType&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public List<ProcessEndpointType> getProcesses(String envelope, List<String> uid, List<String> project, String status, List<String> tooluid, Integer page, String sort, List<String> fields, List<String> embed) throws ApiException {
        ApiResponse<List<ProcessEndpointType>> resp = getProcessesWithHttpInfo(envelope, uid, project, status, tooluid, page, sort, fields, embed);
        return resp.getData();
    }

    /**
     * Get a list of processes
     * Get a list of processes
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param uid Comma separated list of Tag UID (optional)
     * @param project Comma separated list of project uid (optional)
     * @param status Status of the project. Can be one of:   * WAITING: Process is queued for execution   * RUNNING: Process is currently executing   * FINISHED: Process terminated normally   * ABORTED: Process terminated unexpectedly   * ZOMBIE: Process is listed in the platform process table, but the internal (process) API has no information about it. Possible in case of historical/archived processes or due to platform error.  (optional)
     * @param tooluid Comma separated list of tool UID (optional)
     * @param page Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)
     * @param sort The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)
     * @param fields Comma separated list of fields (optional)
     * @param embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)
     * @return ApiResponse&lt;List&lt;ProcessEndpointType&gt;&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<List<ProcessEndpointType>> getProcessesWithHttpInfo(String envelope, List<String> uid, List<String> project, String status, List<String> tooluid, Integer page, String sort, List<String> fields, List<String> embed) throws ApiException {
        com.squareup.okhttp.Call call = getProcessesValidateBeforeCall(envelope, uid, project, status, tooluid, page, sort, fields, embed, null, null);
        Type localVarReturnType = new TypeToken<List<ProcessEndpointType>>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Get a list of processes (asynchronously)
     * Get a list of processes
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param uid Comma separated list of Tag UID (optional)
     * @param project Comma separated list of project uid (optional)
     * @param status Status of the project. Can be one of:   * WAITING: Process is queued for execution   * RUNNING: Process is currently executing   * FINISHED: Process terminated normally   * ABORTED: Process terminated unexpectedly   * ZOMBIE: Process is listed in the platform process table, but the internal (process) API has no information about it. Possible in case of historical/archived processes or due to platform error.  (optional)
     * @param tooluid Comma separated list of tool UID (optional)
     * @param page Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)
     * @param sort The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)
     * @param fields Comma separated list of fields (optional)
     * @param embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call getProcessesAsync(String envelope, List<String> uid, List<String> project, String status, List<String> tooluid, Integer page, String sort, List<String> fields, List<String> embed, final ApiCallback<List<ProcessEndpointType>> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = getProcessesValidateBeforeCall(envelope, uid, project, status, tooluid, page, sort, fields, embed, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<List<ProcessEndpointType>>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
}
