/*
 * its4land Public API
 * The its4land Public API provides access to the services of the its4land Publish and Share platform.
 *
 * OpenAPI spec version: 0.0.2
 * Contact: contact@its4land.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package io.swagger.client.api;

import io.swagger.client.ApiCallback;
import io.swagger.client.ApiClient;
import io.swagger.client.ApiException;
import io.swagger.client.ApiResponse;
import io.swagger.client.Configuration;
import io.swagger.client.Pair;
import io.swagger.client.ProgressRequestBody;
import io.swagger.client.ProgressResponseBody;

import com.google.gson.reflect.TypeToken;

import java.io.IOException;


import io.swagger.client.model.ConnectedObjectsEndpointType;
import io.swagger.client.model.ModelsEndpointType;
import io.swagger.client.model.ModelsPostRequest;
import io.swagger.client.model.ProjectsEndpointType;
import io.swagger.client.model.ProjectsPostRequest;
import io.swagger.client.model.RFC6902PatchRequest;
import io.swagger.client.model.SpatialSourcesEndpointType;
import io.swagger.client.model.SpatialSourcesPostRequest;
import io.swagger.client.model.TagsListResponse;
import io.swagger.client.model.TagsPostRequest;

import java.lang.reflect.Type;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class ProjectsApi {
    private ApiClient apiClient;

    public ProjectsApi() {
        this(Configuration.getDefaultApiClient());
    }

    public ProjectsApi(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    public ApiClient getApiClient() {
        return apiClient;
    }

    public void setApiClient(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    /**
     * Build call for addTagToProject
     * @param projectUid Project UID (required)
     * @param newtag New Tag data (required)
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)
     * @param i4lProcessUid Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call addTagToProjectCall(String projectUid, TagsPostRequest newtag, String envelope, List<String> embed, String i4lProcessUid, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = newtag;

        // create path and map variables
        String localVarPath = "/projects/{project_uid}/Tags"
            .replaceAll("\\{" + "project_uid" + "\\}", apiClient.escapeString(projectUid.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (envelope != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("envelope", envelope));
        if (embed != null)
        localVarCollectionQueryParams.addAll(apiClient.parameterToPairs("csv", "embed", embed));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        if (i4lProcessUid != null)
        localVarHeaderParams.put("i4l-process-uid", apiClient.parameterToString(i4lProcessUid));

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call addTagToProjectValidateBeforeCall(String projectUid, TagsPostRequest newtag, String envelope, List<String> embed, String i4lProcessUid, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'projectUid' is set
        if (projectUid == null) {
            throw new ApiException("Missing the required parameter 'projectUid' when calling addTagToProject(Async)");
        }
        
        // verify the required parameter 'newtag' is set
        if (newtag == null) {
            throw new ApiException("Missing the required parameter 'newtag' when calling addTagToProject(Async)");
        }
        

        com.squareup.okhttp.Call call = addTagToProjectCall(projectUid, newtag, envelope, embed, i4lProcessUid, progressListener, progressRequestListener);
        return call;

    }

    /**
     * Adds a tag to the project
     * Creates a new tag and attach it to the project. If the tag already exist, the existing tag will be attached to the project.
     * @param projectUid Project UID (required)
     * @param newtag New Tag data (required)
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)
     * @param i4lProcessUid Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)
     * @return ProjectsEndpointType
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ProjectsEndpointType addTagToProject(String projectUid, TagsPostRequest newtag, String envelope, List<String> embed, String i4lProcessUid) throws ApiException {
        ApiResponse<ProjectsEndpointType> resp = addTagToProjectWithHttpInfo(projectUid, newtag, envelope, embed, i4lProcessUid);
        return resp.getData();
    }

    /**
     * Adds a tag to the project
     * Creates a new tag and attach it to the project. If the tag already exist, the existing tag will be attached to the project.
     * @param projectUid Project UID (required)
     * @param newtag New Tag data (required)
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)
     * @param i4lProcessUid Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)
     * @return ApiResponse&lt;ProjectsEndpointType&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<ProjectsEndpointType> addTagToProjectWithHttpInfo(String projectUid, TagsPostRequest newtag, String envelope, List<String> embed, String i4lProcessUid) throws ApiException {
        com.squareup.okhttp.Call call = addTagToProjectValidateBeforeCall(projectUid, newtag, envelope, embed, i4lProcessUid, null, null);
        Type localVarReturnType = new TypeToken<ProjectsEndpointType>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Adds a tag to the project (asynchronously)
     * Creates a new tag and attach it to the project. If the tag already exist, the existing tag will be attached to the project.
     * @param projectUid Project UID (required)
     * @param newtag New Tag data (required)
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)
     * @param i4lProcessUid Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call addTagToProjectAsync(String projectUid, TagsPostRequest newtag, String envelope, List<String> embed, String i4lProcessUid, final ApiCallback<ProjectsEndpointType> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = addTagToProjectValidateBeforeCall(projectUid, newtag, envelope, embed, i4lProcessUid, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<ProjectsEndpointType>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for delProjectByUID
     * @param projectUid UID of the project (required)
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)
     * @param i4lProcessUid Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call delProjectByUIDCall(String projectUid, String envelope, List<String> embed, String i4lProcessUid, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;

        // create path and map variables
        String localVarPath = "/projects/{project_uid}"
            .replaceAll("\\{" + "project_uid" + "\\}", apiClient.escapeString(projectUid.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (envelope != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("envelope", envelope));
        if (embed != null)
        localVarCollectionQueryParams.addAll(apiClient.parameterToPairs("csv", "embed", embed));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        if (i4lProcessUid != null)
        localVarHeaderParams.put("i4l-process-uid", apiClient.parameterToString(i4lProcessUid));

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "DELETE", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call delProjectByUIDValidateBeforeCall(String projectUid, String envelope, List<String> embed, String i4lProcessUid, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'projectUid' is set
        if (projectUid == null) {
            throw new ApiException("Missing the required parameter 'projectUid' when calling delProjectByUID(Async)");
        }
        

        com.squareup.okhttp.Call call = delProjectByUIDCall(projectUid, envelope, embed, i4lProcessUid, progressListener, progressRequestListener);
        return call;

    }

    /**
     * Deletes a single e project by its UID
     * A single project is deleted. This endpoint deletes the project itself and the connected to subordered data like SpatialSources, etc. The subordered data itself are not deleted
     * @param projectUid UID of the project (required)
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)
     * @param i4lProcessUid Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)
     * @return ProjectsEndpointType
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ProjectsEndpointType delProjectByUID(String projectUid, String envelope, List<String> embed, String i4lProcessUid) throws ApiException {
        ApiResponse<ProjectsEndpointType> resp = delProjectByUIDWithHttpInfo(projectUid, envelope, embed, i4lProcessUid);
        return resp.getData();
    }

    /**
     * Deletes a single e project by its UID
     * A single project is deleted. This endpoint deletes the project itself and the connected to subordered data like SpatialSources, etc. The subordered data itself are not deleted
     * @param projectUid UID of the project (required)
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)
     * @param i4lProcessUid Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)
     * @return ApiResponse&lt;ProjectsEndpointType&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<ProjectsEndpointType> delProjectByUIDWithHttpInfo(String projectUid, String envelope, List<String> embed, String i4lProcessUid) throws ApiException {
        com.squareup.okhttp.Call call = delProjectByUIDValidateBeforeCall(projectUid, envelope, embed, i4lProcessUid, null, null);
        Type localVarReturnType = new TypeToken<ProjectsEndpointType>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Deletes a single e project by its UID (asynchronously)
     * A single project is deleted. This endpoint deletes the project itself and the connected to subordered data like SpatialSources, etc. The subordered data itself are not deleted
     * @param projectUid UID of the project (required)
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)
     * @param i4lProcessUid Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call delProjectByUIDAsync(String projectUid, String envelope, List<String> embed, String i4lProcessUid, final ApiCallback<ProjectsEndpointType> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = delProjectByUIDValidateBeforeCall(projectUid, envelope, embed, i4lProcessUid, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<ProjectsEndpointType>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for detachProjectModel
     * @param projectUid Project UID (required)
     * @param modelUid Model UID (required)
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param forceDelete Deletes the model resource. ********* What&#39;s about subordinate resources? ********* (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call detachProjectModelCall(String projectUid, String modelUid, String envelope, String forceDelete, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;

        // create path and map variables
        String localVarPath = "/projects/{project_uid}/Models/{model_uid}"
            .replaceAll("\\{" + "project_uid" + "\\}", apiClient.escapeString(projectUid.toString()))
            .replaceAll("\\{" + "model_uid" + "\\}", apiClient.escapeString(modelUid.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (envelope != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("envelope", envelope));
        if (forceDelete != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("force_delete", forceDelete));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "DELETE", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call detachProjectModelValidateBeforeCall(String projectUid, String modelUid, String envelope, String forceDelete, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'projectUid' is set
        if (projectUid == null) {
            throw new ApiException("Missing the required parameter 'projectUid' when calling detachProjectModel(Async)");
        }
        
        // verify the required parameter 'modelUid' is set
        if (modelUid == null) {
            throw new ApiException("Missing the required parameter 'modelUid' when calling detachProjectModel(Async)");
        }
        

        com.squareup.okhttp.Call call = detachProjectModelCall(projectUid, modelUid, envelope, forceDelete, progressListener, progressRequestListener);
        return call;

    }

    /**
     * Removes a model from a project.
     * Removes a model from a project. By default only the link between model and project is removed.
     * @param projectUid Project UID (required)
     * @param modelUid Model UID (required)
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param forceDelete Deletes the model resource. ********* What&#39;s about subordinate resources? ********* (optional)
     * @return ProjectsEndpointType
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ProjectsEndpointType detachProjectModel(String projectUid, String modelUid, String envelope, String forceDelete) throws ApiException {
        ApiResponse<ProjectsEndpointType> resp = detachProjectModelWithHttpInfo(projectUid, modelUid, envelope, forceDelete);
        return resp.getData();
    }

    /**
     * Removes a model from a project.
     * Removes a model from a project. By default only the link between model and project is removed.
     * @param projectUid Project UID (required)
     * @param modelUid Model UID (required)
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param forceDelete Deletes the model resource. ********* What&#39;s about subordinate resources? ********* (optional)
     * @return ApiResponse&lt;ProjectsEndpointType&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<ProjectsEndpointType> detachProjectModelWithHttpInfo(String projectUid, String modelUid, String envelope, String forceDelete) throws ApiException {
        com.squareup.okhttp.Call call = detachProjectModelValidateBeforeCall(projectUid, modelUid, envelope, forceDelete, null, null);
        Type localVarReturnType = new TypeToken<ProjectsEndpointType>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Removes a model from a project. (asynchronously)
     * Removes a model from a project. By default only the link between model and project is removed.
     * @param projectUid Project UID (required)
     * @param modelUid Model UID (required)
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param forceDelete Deletes the model resource. ********* What&#39;s about subordinate resources? ********* (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call detachProjectModelAsync(String projectUid, String modelUid, String envelope, String forceDelete, final ApiCallback<ProjectsEndpointType> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = detachProjectModelValidateBeforeCall(projectUid, modelUid, envelope, forceDelete, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<ProjectsEndpointType>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for detachProjectSpatialSource
     * @param projectUid Project UID (required)
     * @param spatialsourceUid SpatialSource UID (required)
     * @param forceDelete Deletes the spatialsource resource. ********* What&#39;s about subordinate resources? ********* (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call detachProjectSpatialSourceCall(String projectUid, String spatialsourceUid, String forceDelete, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;

        // create path and map variables
        String localVarPath = "/projects/{project_uid}/SpatialSources/{spatialsource_uid}"
            .replaceAll("\\{" + "project_uid" + "\\}", apiClient.escapeString(projectUid.toString()))
            .replaceAll("\\{" + "spatialsource_uid" + "\\}", apiClient.escapeString(spatialsourceUid.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (forceDelete != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("force_delete", forceDelete));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "DELETE", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call detachProjectSpatialSourceValidateBeforeCall(String projectUid, String spatialsourceUid, String forceDelete, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'projectUid' is set
        if (projectUid == null) {
            throw new ApiException("Missing the required parameter 'projectUid' when calling detachProjectSpatialSource(Async)");
        }
        
        // verify the required parameter 'spatialsourceUid' is set
        if (spatialsourceUid == null) {
            throw new ApiException("Missing the required parameter 'spatialsourceUid' when calling detachProjectSpatialSource(Async)");
        }
        

        com.squareup.okhttp.Call call = detachProjectSpatialSourceCall(projectUid, spatialsourceUid, forceDelete, progressListener, progressRequestListener);
        return call;

    }

    /**
     * Removes a spatialsource from a project.
     * Removes a spatial from a project. By default only the link between spatialsource and project is removed.
     * @param projectUid Project UID (required)
     * @param spatialsourceUid SpatialSource UID (required)
     * @param forceDelete Deletes the spatialsource resource. ********* What&#39;s about subordinate resources? ********* (optional)
     * @return ProjectsEndpointType
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ProjectsEndpointType detachProjectSpatialSource(String projectUid, String spatialsourceUid, String forceDelete) throws ApiException {
        ApiResponse<ProjectsEndpointType> resp = detachProjectSpatialSourceWithHttpInfo(projectUid, spatialsourceUid, forceDelete);
        return resp.getData();
    }

    /**
     * Removes a spatialsource from a project.
     * Removes a spatial from a project. By default only the link between spatialsource and project is removed.
     * @param projectUid Project UID (required)
     * @param spatialsourceUid SpatialSource UID (required)
     * @param forceDelete Deletes the spatialsource resource. ********* What&#39;s about subordinate resources? ********* (optional)
     * @return ApiResponse&lt;ProjectsEndpointType&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<ProjectsEndpointType> detachProjectSpatialSourceWithHttpInfo(String projectUid, String spatialsourceUid, String forceDelete) throws ApiException {
        com.squareup.okhttp.Call call = detachProjectSpatialSourceValidateBeforeCall(projectUid, spatialsourceUid, forceDelete, null, null);
        Type localVarReturnType = new TypeToken<ProjectsEndpointType>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Removes a spatialsource from a project. (asynchronously)
     * Removes a spatial from a project. By default only the link between spatialsource and project is removed.
     * @param projectUid Project UID (required)
     * @param spatialsourceUid SpatialSource UID (required)
     * @param forceDelete Deletes the spatialsource resource. ********* What&#39;s about subordinate resources? ********* (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call detachProjectSpatialSourceAsync(String projectUid, String spatialsourceUid, String forceDelete, final ApiCallback<ProjectsEndpointType> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = detachProjectSpatialSourceValidateBeforeCall(projectUid, spatialsourceUid, forceDelete, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<ProjectsEndpointType>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for detachProjectTag
     * @param projectUid Project UID (required)
     * @param tag tag value (required)
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param forceDelete Deletes the tag resource. ********* Only possible, when tag is not attached to any other resource. ********* (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call detachProjectTagCall(String projectUid, String tag, String envelope, String forceDelete, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;

        // create path and map variables
        String localVarPath = "/projects/{project_uid}/Tags/{tag}"
            .replaceAll("\\{" + "project_uid" + "\\}", apiClient.escapeString(projectUid.toString()))
            .replaceAll("\\{" + "tag" + "\\}", apiClient.escapeString(tag.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (envelope != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("envelope", envelope));
        if (forceDelete != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("force_delete", forceDelete));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "DELETE", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call detachProjectTagValidateBeforeCall(String projectUid, String tag, String envelope, String forceDelete, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'projectUid' is set
        if (projectUid == null) {
            throw new ApiException("Missing the required parameter 'projectUid' when calling detachProjectTag(Async)");
        }
        
        // verify the required parameter 'tag' is set
        if (tag == null) {
            throw new ApiException("Missing the required parameter 'tag' when calling detachProjectTag(Async)");
        }
        

        com.squareup.okhttp.Call call = detachProjectTagCall(projectUid, tag, envelope, forceDelete, progressListener, progressRequestListener);
        return call;

    }

    /**
     * Removes a tag from a project.
     * Removes a tag from a project. By default only the link between tag and project is removed.
     * @param projectUid Project UID (required)
     * @param tag tag value (required)
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param forceDelete Deletes the tag resource. ********* Only possible, when tag is not attached to any other resource. ********* (optional)
     * @return ProjectsEndpointType
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ProjectsEndpointType detachProjectTag(String projectUid, String tag, String envelope, String forceDelete) throws ApiException {
        ApiResponse<ProjectsEndpointType> resp = detachProjectTagWithHttpInfo(projectUid, tag, envelope, forceDelete);
        return resp.getData();
    }

    /**
     * Removes a tag from a project.
     * Removes a tag from a project. By default only the link between tag and project is removed.
     * @param projectUid Project UID (required)
     * @param tag tag value (required)
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param forceDelete Deletes the tag resource. ********* Only possible, when tag is not attached to any other resource. ********* (optional)
     * @return ApiResponse&lt;ProjectsEndpointType&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<ProjectsEndpointType> detachProjectTagWithHttpInfo(String projectUid, String tag, String envelope, String forceDelete) throws ApiException {
        com.squareup.okhttp.Call call = detachProjectTagValidateBeforeCall(projectUid, tag, envelope, forceDelete, null, null);
        Type localVarReturnType = new TypeToken<ProjectsEndpointType>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Removes a tag from a project. (asynchronously)
     * Removes a tag from a project. By default only the link between tag and project is removed.
     * @param projectUid Project UID (required)
     * @param tag tag value (required)
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param forceDelete Deletes the tag resource. ********* Only possible, when tag is not attached to any other resource. ********* (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call detachProjectTagAsync(String projectUid, String tag, String envelope, String forceDelete, final ApiCallback<ProjectsEndpointType> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = detachProjectTagValidateBeforeCall(projectUid, tag, envelope, forceDelete, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<ProjectsEndpointType>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for getConnectedObjectsByProjectUID
     * @param projectUid Project UID (required)
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param page Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)
     * @param sort The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)
     * @param fields Comma separated list of field names (optional)
     * @param embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call getConnectedObjectsByProjectUIDCall(String projectUid, String envelope, Integer page, String sort, List<String> fields, List<String> embed, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;

        // create path and map variables
        String localVarPath = "/projects/{project_uid}/connectedObjects"
            .replaceAll("\\{" + "project_uid" + "\\}", apiClient.escapeString(projectUid.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (envelope != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("envelope", envelope));
        if (page != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("page", page));
        if (sort != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("sort", sort));
        if (fields != null)
        localVarCollectionQueryParams.addAll(apiClient.parameterToPairs("csv", "fields", fields));
        if (embed != null)
        localVarCollectionQueryParams.addAll(apiClient.parameterToPairs("csv", "embed", embed));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call getConnectedObjectsByProjectUIDValidateBeforeCall(String projectUid, String envelope, Integer page, String sort, List<String> fields, List<String> embed, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'projectUid' is set
        if (projectUid == null) {
            throw new ApiException("Missing the required parameter 'projectUid' when calling getConnectedObjectsByProjectUID(Async)");
        }
        

        com.squareup.okhttp.Call call = getConnectedObjectsByProjectUIDCall(projectUid, envelope, page, sort, fields, embed, progressListener, progressRequestListener);
        return call;

    }

    /**
     * Returns an array of connect objects
     * Returns an array of connect objects of a project. For each connected object the endpoint returns the type, name and uuid
     * @param projectUid Project UID (required)
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param page Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)
     * @param sort The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)
     * @param fields Comma separated list of field names (optional)
     * @param embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)
     * @return ConnectedObjectsEndpointType
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ConnectedObjectsEndpointType getConnectedObjectsByProjectUID(String projectUid, String envelope, Integer page, String sort, List<String> fields, List<String> embed) throws ApiException {
        ApiResponse<ConnectedObjectsEndpointType> resp = getConnectedObjectsByProjectUIDWithHttpInfo(projectUid, envelope, page, sort, fields, embed);
        return resp.getData();
    }

    /**
     * Returns an array of connect objects
     * Returns an array of connect objects of a project. For each connected object the endpoint returns the type, name and uuid
     * @param projectUid Project UID (required)
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param page Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)
     * @param sort The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)
     * @param fields Comma separated list of field names (optional)
     * @param embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)
     * @return ApiResponse&lt;ConnectedObjectsEndpointType&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<ConnectedObjectsEndpointType> getConnectedObjectsByProjectUIDWithHttpInfo(String projectUid, String envelope, Integer page, String sort, List<String> fields, List<String> embed) throws ApiException {
        com.squareup.okhttp.Call call = getConnectedObjectsByProjectUIDValidateBeforeCall(projectUid, envelope, page, sort, fields, embed, null, null);
        Type localVarReturnType = new TypeToken<ConnectedObjectsEndpointType>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Returns an array of connect objects (asynchronously)
     * Returns an array of connect objects of a project. For each connected object the endpoint returns the type, name and uuid
     * @param projectUid Project UID (required)
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param page Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)
     * @param sort The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)
     * @param fields Comma separated list of field names (optional)
     * @param embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call getConnectedObjectsByProjectUIDAsync(String projectUid, String envelope, Integer page, String sort, List<String> fields, List<String> embed, final ApiCallback<ConnectedObjectsEndpointType> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = getConnectedObjectsByProjectUIDValidateBeforeCall(projectUid, envelope, page, sort, fields, embed, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<ConnectedObjectsEndpointType>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for getModelsByProjectUID
     * @param projectUid Project UID (required)
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param page Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)
     * @param sort The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)
     * @param fields Comma separated list of field names (optional)
     * @param embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call getModelsByProjectUIDCall(String projectUid, String envelope, Integer page, String sort, List<String> fields, List<String> embed, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;

        // create path and map variables
        String localVarPath = "/projects/{project_uid}/Models"
            .replaceAll("\\{" + "project_uid" + "\\}", apiClient.escapeString(projectUid.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (envelope != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("envelope", envelope));
        if (page != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("page", page));
        if (sort != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("sort", sort));
        if (fields != null)
        localVarCollectionQueryParams.addAll(apiClient.parameterToPairs("csv", "fields", fields));
        if (embed != null)
        localVarCollectionQueryParams.addAll(apiClient.parameterToPairs("csv", "embed", embed));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call getModelsByProjectUIDValidateBeforeCall(String projectUid, String envelope, Integer page, String sort, List<String> fields, List<String> embed, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'projectUid' is set
        if (projectUid == null) {
            throw new ApiException("Missing the required parameter 'projectUid' when calling getModelsByProjectUID(Async)");
        }
        

        com.squareup.okhttp.Call call = getModelsByProjectUIDCall(projectUid, envelope, page, sort, fields, embed, progressListener, progressRequestListener);
        return call;

    }

    /**
     * Returns the models of a project
     * Returns the models of a project
     * @param projectUid Project UID (required)
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param page Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)
     * @param sort The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)
     * @param fields Comma separated list of field names (optional)
     * @param embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)
     * @return List&lt;ModelsEndpointType&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public List<ModelsEndpointType> getModelsByProjectUID(String projectUid, String envelope, Integer page, String sort, List<String> fields, List<String> embed) throws ApiException {
        ApiResponse<List<ModelsEndpointType>> resp = getModelsByProjectUIDWithHttpInfo(projectUid, envelope, page, sort, fields, embed);
        return resp.getData();
    }

    /**
     * Returns the models of a project
     * Returns the models of a project
     * @param projectUid Project UID (required)
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param page Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)
     * @param sort The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)
     * @param fields Comma separated list of field names (optional)
     * @param embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)
     * @return ApiResponse&lt;List&lt;ModelsEndpointType&gt;&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<List<ModelsEndpointType>> getModelsByProjectUIDWithHttpInfo(String projectUid, String envelope, Integer page, String sort, List<String> fields, List<String> embed) throws ApiException {
        com.squareup.okhttp.Call call = getModelsByProjectUIDValidateBeforeCall(projectUid, envelope, page, sort, fields, embed, null, null);
        Type localVarReturnType = new TypeToken<List<ModelsEndpointType>>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Returns the models of a project (asynchronously)
     * Returns the models of a project
     * @param projectUid Project UID (required)
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param page Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)
     * @param sort The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)
     * @param fields Comma separated list of field names (optional)
     * @param embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call getModelsByProjectUIDAsync(String projectUid, String envelope, Integer page, String sort, List<String> fields, List<String> embed, final ApiCallback<List<ModelsEndpointType>> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = getModelsByProjectUIDValidateBeforeCall(projectUid, envelope, page, sort, fields, embed, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<List<ModelsEndpointType>>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for getProjectTagsByProjectUID
     * @param projectUid Project UID (required)
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call getProjectTagsByProjectUIDCall(String projectUid, String envelope, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;

        // create path and map variables
        String localVarPath = "/projects/{project_uid}/Tags"
            .replaceAll("\\{" + "project_uid" + "\\}", apiClient.escapeString(projectUid.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (envelope != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("envelope", envelope));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call getProjectTagsByProjectUIDValidateBeforeCall(String projectUid, String envelope, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'projectUid' is set
        if (projectUid == null) {
            throw new ApiException("Missing the required parameter 'projectUid' when calling getProjectTagsByProjectUID(Async)");
        }
        

        com.squareup.okhttp.Call call = getProjectTagsByProjectUIDCall(projectUid, envelope, progressListener, progressRequestListener);
        return call;

    }

    /**
     * Returns the tags of a project.
     * Is this method really necessary? Returns the tags of a project.
     * @param projectUid Project UID (required)
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @return TagsListResponse
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public TagsListResponse getProjectTagsByProjectUID(String projectUid, String envelope) throws ApiException {
        ApiResponse<TagsListResponse> resp = getProjectTagsByProjectUIDWithHttpInfo(projectUid, envelope);
        return resp.getData();
    }

    /**
     * Returns the tags of a project.
     * Is this method really necessary? Returns the tags of a project.
     * @param projectUid Project UID (required)
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @return ApiResponse&lt;TagsListResponse&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<TagsListResponse> getProjectTagsByProjectUIDWithHttpInfo(String projectUid, String envelope) throws ApiException {
        com.squareup.okhttp.Call call = getProjectTagsByProjectUIDValidateBeforeCall(projectUid, envelope, null, null);
        Type localVarReturnType = new TypeToken<TagsListResponse>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Returns the tags of a project. (asynchronously)
     * Is this method really necessary? Returns the tags of a project.
     * @param projectUid Project UID (required)
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call getProjectTagsByProjectUIDAsync(String projectUid, String envelope, final ApiCallback<TagsListResponse> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = getProjectTagsByProjectUIDValidateBeforeCall(projectUid, envelope, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<TagsListResponse>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for getProjects
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param uid Comma separated list of UID (optional)
     * @param name Comma separated list of names (optional)
     * @param aoi Polygon. The polygon is encoded a comma separated list of coordinates. X1, Y1, X2, Y2, ..., Xn, Yn, X1, Y1 (optional)
     * @param tags Comma separated list of tags (optional)
     * @param page Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)
     * @param sort The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)
     * @param fields Comma separated list of field names (optional)
     * @param embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call getProjectsCall(String envelope, List<String> uid, List<String> name, String aoi, List<String> tags, Integer page, String sort, List<String> fields, List<String> embed, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;

        // create path and map variables
        String localVarPath = "/projects";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (envelope != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("envelope", envelope));
        if (uid != null)
        localVarCollectionQueryParams.addAll(apiClient.parameterToPairs("csv", "uid", uid));
        if (name != null)
        localVarCollectionQueryParams.addAll(apiClient.parameterToPairs("csv", "name", name));
        if (aoi != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("aoi", aoi));
        if (tags != null)
        localVarCollectionQueryParams.addAll(apiClient.parameterToPairs("csv", "tags", tags));
        if (page != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("page", page));
        if (sort != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("sort", sort));
        if (fields != null)
        localVarCollectionQueryParams.addAll(apiClient.parameterToPairs("csv", "fields", fields));
        if (embed != null)
        localVarCollectionQueryParams.addAll(apiClient.parameterToPairs("csv", "embed", embed));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call getProjectsValidateBeforeCall(String envelope, List<String> uid, List<String> name, String aoi, List<String> tags, Integer page, String sort, List<String> fields, List<String> embed, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        

        com.squareup.okhttp.Call call = getProjectsCall(envelope, uid, name, aoi, tags, page, sort, fields, embed, progressListener, progressRequestListener);
        return call;

    }

    /**
     * Get a GeoJSON structure containing a list of Projects.
     * Get a GeoJSON structure containing a list of Projects. A single project is modeled as a GeoJSON feature.
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param uid Comma separated list of UID (optional)
     * @param name Comma separated list of names (optional)
     * @param aoi Polygon. The polygon is encoded a comma separated list of coordinates. X1, Y1, X2, Y2, ..., Xn, Yn, X1, Y1 (optional)
     * @param tags Comma separated list of tags (optional)
     * @param page Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)
     * @param sort The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)
     * @param fields Comma separated list of field names (optional)
     * @param embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)
     * @return ProjectsEndpointType
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ProjectsEndpointType getProjects(String envelope, List<String> uid, List<String> name, String aoi, List<String> tags, Integer page, String sort, List<String> fields, List<String> embed) throws ApiException {
        ApiResponse<ProjectsEndpointType> resp = getProjectsWithHttpInfo(envelope, uid, name, aoi, tags, page, sort, fields, embed);
        return resp.getData();
    }

    /**
     * Get a GeoJSON structure containing a list of Projects.
     * Get a GeoJSON structure containing a list of Projects. A single project is modeled as a GeoJSON feature.
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param uid Comma separated list of UID (optional)
     * @param name Comma separated list of names (optional)
     * @param aoi Polygon. The polygon is encoded a comma separated list of coordinates. X1, Y1, X2, Y2, ..., Xn, Yn, X1, Y1 (optional)
     * @param tags Comma separated list of tags (optional)
     * @param page Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)
     * @param sort The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)
     * @param fields Comma separated list of field names (optional)
     * @param embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)
     * @return ApiResponse&lt;ProjectsEndpointType&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<ProjectsEndpointType> getProjectsWithHttpInfo(String envelope, List<String> uid, List<String> name, String aoi, List<String> tags, Integer page, String sort, List<String> fields, List<String> embed) throws ApiException {
        com.squareup.okhttp.Call call = getProjectsValidateBeforeCall(envelope, uid, name, aoi, tags, page, sort, fields, embed, null, null);
        Type localVarReturnType = new TypeToken<ProjectsEndpointType>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Get a GeoJSON structure containing a list of Projects. (asynchronously)
     * Get a GeoJSON structure containing a list of Projects. A single project is modeled as a GeoJSON feature.
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param uid Comma separated list of UID (optional)
     * @param name Comma separated list of names (optional)
     * @param aoi Polygon. The polygon is encoded a comma separated list of coordinates. X1, Y1, X2, Y2, ..., Xn, Yn, X1, Y1 (optional)
     * @param tags Comma separated list of tags (optional)
     * @param page Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)
     * @param sort The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)
     * @param fields Comma separated list of field names (optional)
     * @param embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call getProjectsAsync(String envelope, List<String> uid, List<String> name, String aoi, List<String> tags, Integer page, String sort, List<String> fields, List<String> embed, final ApiCallback<ProjectsEndpointType> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = getProjectsValidateBeforeCall(envelope, uid, name, aoi, tags, page, sort, fields, embed, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<ProjectsEndpointType>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for getProjectsByUID
     * @param projectUid UID of the project (required)
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call getProjectsByUIDCall(String projectUid, String envelope, List<String> embed, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;

        // create path and map variables
        String localVarPath = "/projects/{project_uid}"
            .replaceAll("\\{" + "project_uid" + "\\}", apiClient.escapeString(projectUid.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (envelope != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("envelope", envelope));
        if (embed != null)
        localVarCollectionQueryParams.addAll(apiClient.parameterToPairs("csv", "embed", embed));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call getProjectsByUIDValidateBeforeCall(String projectUid, String envelope, List<String> embed, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'projectUid' is set
        if (projectUid == null) {
            throw new ApiException("Missing the required parameter 'projectUid' when calling getProjectsByUID(Async)");
        }
        

        com.squareup.okhttp.Call call = getProjectsByUIDCall(projectUid, envelope, embed, progressListener, progressRequestListener);
        return call;

    }

    /**
     * Getting single Projects by its UID
     * Getting single Projects by its UID. The project is modeled as a feature in a GeoJSON structure.
     * @param projectUid UID of the project (required)
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)
     * @return ProjectsEndpointType
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ProjectsEndpointType getProjectsByUID(String projectUid, String envelope, List<String> embed) throws ApiException {
        ApiResponse<ProjectsEndpointType> resp = getProjectsByUIDWithHttpInfo(projectUid, envelope, embed);
        return resp.getData();
    }

    /**
     * Getting single Projects by its UID
     * Getting single Projects by its UID. The project is modeled as a feature in a GeoJSON structure.
     * @param projectUid UID of the project (required)
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)
     * @return ApiResponse&lt;ProjectsEndpointType&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<ProjectsEndpointType> getProjectsByUIDWithHttpInfo(String projectUid, String envelope, List<String> embed) throws ApiException {
        com.squareup.okhttp.Call call = getProjectsByUIDValidateBeforeCall(projectUid, envelope, embed, null, null);
        Type localVarReturnType = new TypeToken<ProjectsEndpointType>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Getting single Projects by its UID (asynchronously)
     * Getting single Projects by its UID. The project is modeled as a feature in a GeoJSON structure.
     * @param projectUid UID of the project (required)
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call getProjectsByUIDAsync(String projectUid, String envelope, List<String> embed, final ApiCallback<ProjectsEndpointType> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = getProjectsByUIDValidateBeforeCall(projectUid, envelope, embed, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<ProjectsEndpointType>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for getSpatialSourceByProjectUID
     * @param projectUid Project UID (required)
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param page Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)
     * @param sort The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)
     * @param fields Comma separated list of field names (optional)
     * @param embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call getSpatialSourceByProjectUIDCall(String projectUid, String envelope, Integer page, String sort, List<String> fields, List<String> embed, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;

        // create path and map variables
        String localVarPath = "/projects/{project_uid}/SpatialSources"
            .replaceAll("\\{" + "project_uid" + "\\}", apiClient.escapeString(projectUid.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (envelope != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("envelope", envelope));
        if (page != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("page", page));
        if (sort != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("sort", sort));
        if (fields != null)
        localVarCollectionQueryParams.addAll(apiClient.parameterToPairs("csv", "fields", fields));
        if (embed != null)
        localVarCollectionQueryParams.addAll(apiClient.parameterToPairs("csv", "embed", embed));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call getSpatialSourceByProjectUIDValidateBeforeCall(String projectUid, String envelope, Integer page, String sort, List<String> fields, List<String> embed, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'projectUid' is set
        if (projectUid == null) {
            throw new ApiException("Missing the required parameter 'projectUid' when calling getSpatialSourceByProjectUID(Async)");
        }
        

        com.squareup.okhttp.Call call = getSpatialSourceByProjectUIDCall(projectUid, envelope, page, sort, fields, embed, progressListener, progressRequestListener);
        return call;

    }

    /**
     * Returns the SpatialSources of a Project.
     * Returns the SpatialSources of a Project.
     * @param projectUid Project UID (required)
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param page Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)
     * @param sort The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)
     * @param fields Comma separated list of field names (optional)
     * @param embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)
     * @return List&lt;SpatialSourcesEndpointType&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public List<SpatialSourcesEndpointType> getSpatialSourceByProjectUID(String projectUid, String envelope, Integer page, String sort, List<String> fields, List<String> embed) throws ApiException {
        ApiResponse<List<SpatialSourcesEndpointType>> resp = getSpatialSourceByProjectUIDWithHttpInfo(projectUid, envelope, page, sort, fields, embed);
        return resp.getData();
    }

    /**
     * Returns the SpatialSources of a Project.
     * Returns the SpatialSources of a Project.
     * @param projectUid Project UID (required)
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param page Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)
     * @param sort The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)
     * @param fields Comma separated list of field names (optional)
     * @param embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)
     * @return ApiResponse&lt;List&lt;SpatialSourcesEndpointType&gt;&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<List<SpatialSourcesEndpointType>> getSpatialSourceByProjectUIDWithHttpInfo(String projectUid, String envelope, Integer page, String sort, List<String> fields, List<String> embed) throws ApiException {
        com.squareup.okhttp.Call call = getSpatialSourceByProjectUIDValidateBeforeCall(projectUid, envelope, page, sort, fields, embed, null, null);
        Type localVarReturnType = new TypeToken<List<SpatialSourcesEndpointType>>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Returns the SpatialSources of a Project. (asynchronously)
     * Returns the SpatialSources of a Project.
     * @param projectUid Project UID (required)
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param page Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)
     * @param sort The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)
     * @param fields Comma separated list of field names (optional)
     * @param embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call getSpatialSourceByProjectUIDAsync(String projectUid, String envelope, Integer page, String sort, List<String> fields, List<String> embed, final ApiCallback<List<SpatialSourcesEndpointType>> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = getSpatialSourceByProjectUIDValidateBeforeCall(projectUid, envelope, page, sort, fields, embed, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<List<SpatialSourcesEndpointType>>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for newModelUnderProject
     * @param projectUid Project UID (required)
     * @param newmodel New model data (required)
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)
     * @param i4lProcessUid Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call newModelUnderProjectCall(String projectUid, ModelsPostRequest newmodel, String envelope, List<String> embed, String i4lProcessUid, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = newmodel;

        // create path and map variables
        String localVarPath = "/projects/{project_uid}/Models"
            .replaceAll("\\{" + "project_uid" + "\\}", apiClient.escapeString(projectUid.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (envelope != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("envelope", envelope));
        if (embed != null)
        localVarCollectionQueryParams.addAll(apiClient.parameterToPairs("csv", "embed", embed));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        if (i4lProcessUid != null)
        localVarHeaderParams.put("i4l-process-uid", apiClient.parameterToString(i4lProcessUid));

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call newModelUnderProjectValidateBeforeCall(String projectUid, ModelsPostRequest newmodel, String envelope, List<String> embed, String i4lProcessUid, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'projectUid' is set
        if (projectUid == null) {
            throw new ApiException("Missing the required parameter 'projectUid' when calling newModelUnderProject(Async)");
        }
        
        // verify the required parameter 'newmodel' is set
        if (newmodel == null) {
            throw new ApiException("Missing the required parameter 'newmodel' when calling newModelUnderProject(Async)");
        }
        

        com.squareup.okhttp.Call call = newModelUnderProjectCall(projectUid, newmodel, envelope, embed, i4lProcessUid, progressListener, progressRequestListener);
        return call;

    }

    /**
     * Create a new model
     * Create a new model.  To add a new Model , the content of Models  must be stored in advanced via the ContentItem endpoint
     * @param projectUid Project UID (required)
     * @param newmodel New model data (required)
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)
     * @param i4lProcessUid Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)
     * @return ProjectsEndpointType
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ProjectsEndpointType newModelUnderProject(String projectUid, ModelsPostRequest newmodel, String envelope, List<String> embed, String i4lProcessUid) throws ApiException {
        ApiResponse<ProjectsEndpointType> resp = newModelUnderProjectWithHttpInfo(projectUid, newmodel, envelope, embed, i4lProcessUid);
        return resp.getData();
    }

    /**
     * Create a new model
     * Create a new model.  To add a new Model , the content of Models  must be stored in advanced via the ContentItem endpoint
     * @param projectUid Project UID (required)
     * @param newmodel New model data (required)
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)
     * @param i4lProcessUid Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)
     * @return ApiResponse&lt;ProjectsEndpointType&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<ProjectsEndpointType> newModelUnderProjectWithHttpInfo(String projectUid, ModelsPostRequest newmodel, String envelope, List<String> embed, String i4lProcessUid) throws ApiException {
        com.squareup.okhttp.Call call = newModelUnderProjectValidateBeforeCall(projectUid, newmodel, envelope, embed, i4lProcessUid, null, null);
        Type localVarReturnType = new TypeToken<ProjectsEndpointType>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Create a new model (asynchronously)
     * Create a new model.  To add a new Model , the content of Models  must be stored in advanced via the ContentItem endpoint
     * @param projectUid Project UID (required)
     * @param newmodel New model data (required)
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)
     * @param i4lProcessUid Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call newModelUnderProjectAsync(String projectUid, ModelsPostRequest newmodel, String envelope, List<String> embed, String i4lProcessUid, final ApiCallback<ProjectsEndpointType> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = newModelUnderProjectValidateBeforeCall(projectUid, newmodel, envelope, embed, i4lProcessUid, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<ProjectsEndpointType>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for newProject
     * @param newproject New project data (required)
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)
     * @param i4lProcessUid Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call newProjectCall(ProjectsPostRequest newproject, String envelope, List<String> embed, String i4lProcessUid, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = newproject;

        // create path and map variables
        String localVarPath = "/projects";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (envelope != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("envelope", envelope));
        if (embed != null)
        localVarCollectionQueryParams.addAll(apiClient.parameterToPairs("csv", "embed", embed));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        if (i4lProcessUid != null)
        localVarHeaderParams.put("i4l-process-uid", apiClient.parameterToString(i4lProcessUid));

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call newProjectValidateBeforeCall(ProjectsPostRequest newproject, String envelope, List<String> embed, String i4lProcessUid, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'newproject' is set
        if (newproject == null) {
            throw new ApiException("Missing the required parameter 'newproject' when calling newProject(Async)");
        }
        

        com.squareup.okhttp.Call call = newProjectCall(newproject, envelope, embed, i4lProcessUid, progressListener, progressRequestListener);
        return call;

    }

    /**
     * Create a new project
     * Create a new project. The new project is modeled as a feature in a GeoJSON structure. Currently only one project feature is allowed.
     * @param newproject New project data (required)
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)
     * @param i4lProcessUid Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)
     * @return ProjectsEndpointType
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ProjectsEndpointType newProject(ProjectsPostRequest newproject, String envelope, List<String> embed, String i4lProcessUid) throws ApiException {
        ApiResponse<ProjectsEndpointType> resp = newProjectWithHttpInfo(newproject, envelope, embed, i4lProcessUid);
        return resp.getData();
    }

    /**
     * Create a new project
     * Create a new project. The new project is modeled as a feature in a GeoJSON structure. Currently only one project feature is allowed.
     * @param newproject New project data (required)
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)
     * @param i4lProcessUid Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)
     * @return ApiResponse&lt;ProjectsEndpointType&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<ProjectsEndpointType> newProjectWithHttpInfo(ProjectsPostRequest newproject, String envelope, List<String> embed, String i4lProcessUid) throws ApiException {
        com.squareup.okhttp.Call call = newProjectValidateBeforeCall(newproject, envelope, embed, i4lProcessUid, null, null);
        Type localVarReturnType = new TypeToken<ProjectsEndpointType>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Create a new project (asynchronously)
     * Create a new project. The new project is modeled as a feature in a GeoJSON structure. Currently only one project feature is allowed.
     * @param newproject New project data (required)
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)
     * @param i4lProcessUid Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call newProjectAsync(ProjectsPostRequest newproject, String envelope, List<String> embed, String i4lProcessUid, final ApiCallback<ProjectsEndpointType> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = newProjectValidateBeforeCall(newproject, envelope, embed, i4lProcessUid, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<ProjectsEndpointType>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for newSpatialSourceUnderProject
     * @param projectUid Project UID (required)
     * @param newspatialsource New SpatialSource data (required)
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)
     * @param i4lProcessUid Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call newSpatialSourceUnderProjectCall(String projectUid, SpatialSourcesPostRequest newspatialsource, String envelope, List<String> embed, String i4lProcessUid, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = newspatialsource;

        // create path and map variables
        String localVarPath = "/projects/{project_uid}/SpatialSources"
            .replaceAll("\\{" + "project_uid" + "\\}", apiClient.escapeString(projectUid.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (envelope != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("envelope", envelope));
        if (embed != null)
        localVarCollectionQueryParams.addAll(apiClient.parameterToPairs("csv", "embed", embed));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        if (i4lProcessUid != null)
        localVarHeaderParams.put("i4l-process-uid", apiClient.parameterToString(i4lProcessUid));

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call newSpatialSourceUnderProjectValidateBeforeCall(String projectUid, SpatialSourcesPostRequest newspatialsource, String envelope, List<String> embed, String i4lProcessUid, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'projectUid' is set
        if (projectUid == null) {
            throw new ApiException("Missing the required parameter 'projectUid' when calling newSpatialSourceUnderProject(Async)");
        }
        
        // verify the required parameter 'newspatialsource' is set
        if (newspatialsource == null) {
            throw new ApiException("Missing the required parameter 'newspatialsource' when calling newSpatialSourceUnderProject(Async)");
        }
        

        com.squareup.okhttp.Call call = newSpatialSourceUnderProjectCall(projectUid, newspatialsource, envelope, embed, i4lProcessUid, progressListener, progressRequestListener);
        return call;

    }

    /**
     * Create a new SpatialSource
     * Create a new SpatialSource. To add a new SpatialSource , the content of SpatialSource  must be stored in advanced via the ContentItem endpoint
     * @param projectUid Project UID (required)
     * @param newspatialsource New SpatialSource data (required)
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)
     * @param i4lProcessUid Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)
     * @return ProjectsEndpointType
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ProjectsEndpointType newSpatialSourceUnderProject(String projectUid, SpatialSourcesPostRequest newspatialsource, String envelope, List<String> embed, String i4lProcessUid) throws ApiException {
        ApiResponse<ProjectsEndpointType> resp = newSpatialSourceUnderProjectWithHttpInfo(projectUid, newspatialsource, envelope, embed, i4lProcessUid);
        return resp.getData();
    }

    /**
     * Create a new SpatialSource
     * Create a new SpatialSource. To add a new SpatialSource , the content of SpatialSource  must be stored in advanced via the ContentItem endpoint
     * @param projectUid Project UID (required)
     * @param newspatialsource New SpatialSource data (required)
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)
     * @param i4lProcessUid Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)
     * @return ApiResponse&lt;ProjectsEndpointType&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<ProjectsEndpointType> newSpatialSourceUnderProjectWithHttpInfo(String projectUid, SpatialSourcesPostRequest newspatialsource, String envelope, List<String> embed, String i4lProcessUid) throws ApiException {
        com.squareup.okhttp.Call call = newSpatialSourceUnderProjectValidateBeforeCall(projectUid, newspatialsource, envelope, embed, i4lProcessUid, null, null);
        Type localVarReturnType = new TypeToken<ProjectsEndpointType>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Create a new SpatialSource (asynchronously)
     * Create a new SpatialSource. To add a new SpatialSource , the content of SpatialSource  must be stored in advanced via the ContentItem endpoint
     * @param projectUid Project UID (required)
     * @param newspatialsource New SpatialSource data (required)
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)
     * @param i4lProcessUid Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call newSpatialSourceUnderProjectAsync(String projectUid, SpatialSourcesPostRequest newspatialsource, String envelope, List<String> embed, String i4lProcessUid, final ApiCallback<ProjectsEndpointType> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = newSpatialSourceUnderProjectValidateBeforeCall(projectUid, newspatialsource, envelope, embed, i4lProcessUid, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<ProjectsEndpointType>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for updateProjects
     * @param projectUid Project UID to be patched (required)
     * @param patchproject Update data (required)
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)
     * @param i4lProcessUid Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call updateProjectsCall(String projectUid, RFC6902PatchRequest patchproject, String envelope, List<String> embed, String i4lProcessUid, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = patchproject;

        // create path and map variables
        String localVarPath = "/projects/{project_uid}"
            .replaceAll("\\{" + "project_uid" + "\\}", apiClient.escapeString(projectUid.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (envelope != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("envelope", envelope));
        if (embed != null)
        localVarCollectionQueryParams.addAll(apiClient.parameterToPairs("csv", "embed", embed));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        if (i4lProcessUid != null)
        localVarHeaderParams.put("i4l-process-uid", apiClient.parameterToString(i4lProcessUid));

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "PATCH", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call updateProjectsValidateBeforeCall(String projectUid, RFC6902PatchRequest patchproject, String envelope, List<String> embed, String i4lProcessUid, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'projectUid' is set
        if (projectUid == null) {
            throw new ApiException("Missing the required parameter 'projectUid' when calling updateProjects(Async)");
        }
        
        // verify the required parameter 'patchproject' is set
        if (patchproject == null) {
            throw new ApiException("Missing the required parameter 'patchproject' when calling updateProjects(Async)");
        }
        

        com.squareup.okhttp.Call call = updateProjectsCall(projectUid, patchproject, envelope, embed, i4lProcessUid, progressListener, progressRequestListener);
        return call;

    }

    /**
     * Update a project
     * Updates some attributes of a project.
     * @param projectUid Project UID to be patched (required)
     * @param patchproject Update data (required)
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)
     * @param i4lProcessUid Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)
     * @return ProjectsEndpointType
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ProjectsEndpointType updateProjects(String projectUid, RFC6902PatchRequest patchproject, String envelope, List<String> embed, String i4lProcessUid) throws ApiException {
        ApiResponse<ProjectsEndpointType> resp = updateProjectsWithHttpInfo(projectUid, patchproject, envelope, embed, i4lProcessUid);
        return resp.getData();
    }

    /**
     * Update a project
     * Updates some attributes of a project.
     * @param projectUid Project UID to be patched (required)
     * @param patchproject Update data (required)
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)
     * @param i4lProcessUid Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)
     * @return ApiResponse&lt;ProjectsEndpointType&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<ProjectsEndpointType> updateProjectsWithHttpInfo(String projectUid, RFC6902PatchRequest patchproject, String envelope, List<String> embed, String i4lProcessUid) throws ApiException {
        com.squareup.okhttp.Call call = updateProjectsValidateBeforeCall(projectUid, patchproject, envelope, embed, i4lProcessUid, null, null);
        Type localVarReturnType = new TypeToken<ProjectsEndpointType>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Update a project (asynchronously)
     * Updates some attributes of a project.
     * @param projectUid Project UID to be patched (required)
     * @param patchproject Update data (required)
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)
     * @param i4lProcessUid Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call updateProjectsAsync(String projectUid, RFC6902PatchRequest patchproject, String envelope, List<String> embed, String i4lProcessUid, final ApiCallback<ProjectsEndpointType> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = updateProjectsValidateBeforeCall(projectUid, patchproject, envelope, embed, i4lProcessUid, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<ProjectsEndpointType>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
}
