/*
 * its4land Public API
 * The its4land Public API provides access to the services of the its4land Publish and Share platform.
 *
 * OpenAPI spec version: 0.0.2
 * Contact: contact@its4land.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package io.swagger.client.api;

import io.swagger.client.ApiCallback;
import io.swagger.client.ApiClient;
import io.swagger.client.ApiException;
import io.swagger.client.ApiResponse;
import io.swagger.client.Configuration;
import io.swagger.client.Pair;
import io.swagger.client.ProgressRequestBody;
import io.swagger.client.ProgressResponseBody;

import com.google.gson.reflect.TypeToken;

import java.io.IOException;


import io.swagger.client.model.AdditionalDocumentsEndpointType;
import io.swagger.client.model.AdditionalDocumentsPost;
import io.swagger.client.model.SpatialSourcesEndpointType;
import io.swagger.client.model.SpatialSourcesPostRequest;

import java.lang.reflect.Type;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class SpatialSourcesApi {
    private ApiClient apiClient;

    public SpatialSourcesApi() {
        this(Configuration.getDefaultApiClient());
    }

    public SpatialSourcesApi(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    public ApiClient getApiClient() {
        return apiClient;
    }

    public void setApiClient(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    /**
     * Build call for detachSpatialSourceAddDoc
     * @param spatialsourceUid SpatialSource UID (required)
     * @param adddocUid SpatialSource UID (required)
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param forceDelete Deletes the additional document resource. (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call detachSpatialSourceAddDocCall(String spatialsourceUid, String adddocUid, String envelope, String forceDelete, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;

        // create path and map variables
        String localVarPath = "/spatialsource/{spatialsource_uid}/AdditionalDocument/{adddoc_uid}"
            .replaceAll("\\{" + "spatialsource_uid" + "\\}", apiClient.escapeString(spatialsourceUid.toString()))
            .replaceAll("\\{" + "adddoc_uid" + "\\}", apiClient.escapeString(adddocUid.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (envelope != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("envelope", envelope));
        if (forceDelete != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("force_delete", forceDelete));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "DELETE", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call detachSpatialSourceAddDocValidateBeforeCall(String spatialsourceUid, String adddocUid, String envelope, String forceDelete, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'spatialsourceUid' is set
        if (spatialsourceUid == null) {
            throw new ApiException("Missing the required parameter 'spatialsourceUid' when calling detachSpatialSourceAddDoc(Async)");
        }
        
        // verify the required parameter 'adddocUid' is set
        if (adddocUid == null) {
            throw new ApiException("Missing the required parameter 'adddocUid' when calling detachSpatialSourceAddDoc(Async)");
        }
        

        com.squareup.okhttp.Call call = detachSpatialSourceAddDocCall(spatialsourceUid, adddocUid, envelope, forceDelete, progressListener, progressRequestListener);
        return call;

    }

    /**
     * Removes an additional document for a spatial source.
     * Removes an additional document for a spatial source. By default only the link between additional document and spatial source is removed.
     * @param spatialsourceUid SpatialSource UID (required)
     * @param adddocUid SpatialSource UID (required)
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param forceDelete Deletes the additional document resource. (optional)
     * @return List&lt;SpatialSourcesEndpointType&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public List<SpatialSourcesEndpointType> detachSpatialSourceAddDoc(String spatialsourceUid, String adddocUid, String envelope, String forceDelete) throws ApiException {
        ApiResponse<List<SpatialSourcesEndpointType>> resp = detachSpatialSourceAddDocWithHttpInfo(spatialsourceUid, adddocUid, envelope, forceDelete);
        return resp.getData();
    }

    /**
     * Removes an additional document for a spatial source.
     * Removes an additional document for a spatial source. By default only the link between additional document and spatial source is removed.
     * @param spatialsourceUid SpatialSource UID (required)
     * @param adddocUid SpatialSource UID (required)
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param forceDelete Deletes the additional document resource. (optional)
     * @return ApiResponse&lt;List&lt;SpatialSourcesEndpointType&gt;&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<List<SpatialSourcesEndpointType>> detachSpatialSourceAddDocWithHttpInfo(String spatialsourceUid, String adddocUid, String envelope, String forceDelete) throws ApiException {
        com.squareup.okhttp.Call call = detachSpatialSourceAddDocValidateBeforeCall(spatialsourceUid, adddocUid, envelope, forceDelete, null, null);
        Type localVarReturnType = new TypeToken<List<SpatialSourcesEndpointType>>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Removes an additional document for a spatial source. (asynchronously)
     * Removes an additional document for a spatial source. By default only the link between additional document and spatial source is removed.
     * @param spatialsourceUid SpatialSource UID (required)
     * @param adddocUid SpatialSource UID (required)
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param forceDelete Deletes the additional document resource. (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call detachSpatialSourceAddDocAsync(String spatialsourceUid, String adddocUid, String envelope, String forceDelete, final ApiCallback<List<SpatialSourcesEndpointType>> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = detachSpatialSourceAddDocValidateBeforeCall(spatialsourceUid, adddocUid, envelope, forceDelete, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<List<SpatialSourcesEndpointType>>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for getSpatialSourceAddDocs
     * @param spatialsourceUid SpatialSource UID (required)
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param page Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)
     * @param sort The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)
     * @param fields Comma separated list of field names (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call getSpatialSourceAddDocsCall(String spatialsourceUid, String envelope, Integer page, String sort, List<String> fields, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;

        // create path and map variables
        String localVarPath = "/spatialsource/{spatialsource_uid}/AdditionalDocument"
            .replaceAll("\\{" + "spatialsource_uid" + "\\}", apiClient.escapeString(spatialsourceUid.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (envelope != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("envelope", envelope));
        if (page != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("page", page));
        if (sort != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("sort", sort));
        if (fields != null)
        localVarCollectionQueryParams.addAll(apiClient.parameterToPairs("csv", "fields", fields));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call getSpatialSourceAddDocsValidateBeforeCall(String spatialsourceUid, String envelope, Integer page, String sort, List<String> fields, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'spatialsourceUid' is set
        if (spatialsourceUid == null) {
            throw new ApiException("Missing the required parameter 'spatialsourceUid' when calling getSpatialSourceAddDocs(Async)");
        }
        

        com.squareup.okhttp.Call call = getSpatialSourceAddDocsCall(spatialsourceUid, envelope, page, sort, fields, progressListener, progressRequestListener);
        return call;

    }

    /**
     * Returns the additional documents of a spatial source
     * Returns the additional documents of a spatial source
     * @param spatialsourceUid SpatialSource UID (required)
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param page Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)
     * @param sort The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)
     * @param fields Comma separated list of field names (optional)
     * @return List&lt;AdditionalDocumentsEndpointType&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public List<AdditionalDocumentsEndpointType> getSpatialSourceAddDocs(String spatialsourceUid, String envelope, Integer page, String sort, List<String> fields) throws ApiException {
        ApiResponse<List<AdditionalDocumentsEndpointType>> resp = getSpatialSourceAddDocsWithHttpInfo(spatialsourceUid, envelope, page, sort, fields);
        return resp.getData();
    }

    /**
     * Returns the additional documents of a spatial source
     * Returns the additional documents of a spatial source
     * @param spatialsourceUid SpatialSource UID (required)
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param page Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)
     * @param sort The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)
     * @param fields Comma separated list of field names (optional)
     * @return ApiResponse&lt;List&lt;AdditionalDocumentsEndpointType&gt;&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<List<AdditionalDocumentsEndpointType>> getSpatialSourceAddDocsWithHttpInfo(String spatialsourceUid, String envelope, Integer page, String sort, List<String> fields) throws ApiException {
        com.squareup.okhttp.Call call = getSpatialSourceAddDocsValidateBeforeCall(spatialsourceUid, envelope, page, sort, fields, null, null);
        Type localVarReturnType = new TypeToken<List<AdditionalDocumentsEndpointType>>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Returns the additional documents of a spatial source (asynchronously)
     * Returns the additional documents of a spatial source
     * @param spatialsourceUid SpatialSource UID (required)
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param page Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)
     * @param sort The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)
     * @param fields Comma separated list of field names (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call getSpatialSourceAddDocsAsync(String spatialsourceUid, String envelope, Integer page, String sort, List<String> fields, final ApiCallback<List<AdditionalDocumentsEndpointType>> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = getSpatialSourceAddDocsValidateBeforeCall(spatialsourceUid, envelope, page, sort, fields, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<List<AdditionalDocumentsEndpointType>>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for getSpatialSourceByUID
     * @param spatialsourceUid SpatialSource UID (required)
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call getSpatialSourceByUIDCall(String spatialsourceUid, String envelope, List<String> embed, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;

        // create path and map variables
        String localVarPath = "/spatialsource/{spatialsource_uid}"
            .replaceAll("\\{" + "spatialsource_uid" + "\\}", apiClient.escapeString(spatialsourceUid.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (envelope != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("envelope", envelope));
        if (embed != null)
        localVarCollectionQueryParams.addAll(apiClient.parameterToPairs("csv", "embed", embed));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call getSpatialSourceByUIDValidateBeforeCall(String spatialsourceUid, String envelope, List<String> embed, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'spatialsourceUid' is set
        if (spatialsourceUid == null) {
            throw new ApiException("Missing the required parameter 'spatialsourceUid' when calling getSpatialSourceByUID(Async)");
        }
        

        com.squareup.okhttp.Call call = getSpatialSourceByUIDCall(spatialsourceUid, envelope, embed, progressListener, progressRequestListener);
        return call;

    }

    /**
     * Returns a single SpatialSource
     * Returns a single SpatialSource
     * @param spatialsourceUid SpatialSource UID (required)
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)
     * @return SpatialSourcesEndpointType
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public SpatialSourcesEndpointType getSpatialSourceByUID(String spatialsourceUid, String envelope, List<String> embed) throws ApiException {
        ApiResponse<SpatialSourcesEndpointType> resp = getSpatialSourceByUIDWithHttpInfo(spatialsourceUid, envelope, embed);
        return resp.getData();
    }

    /**
     * Returns a single SpatialSource
     * Returns a single SpatialSource
     * @param spatialsourceUid SpatialSource UID (required)
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)
     * @return ApiResponse&lt;SpatialSourcesEndpointType&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<SpatialSourcesEndpointType> getSpatialSourceByUIDWithHttpInfo(String spatialsourceUid, String envelope, List<String> embed) throws ApiException {
        com.squareup.okhttp.Call call = getSpatialSourceByUIDValidateBeforeCall(spatialsourceUid, envelope, embed, null, null);
        Type localVarReturnType = new TypeToken<SpatialSourcesEndpointType>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Returns a single SpatialSource (asynchronously)
     * Returns a single SpatialSource
     * @param spatialsourceUid SpatialSource UID (required)
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call getSpatialSourceByUIDAsync(String spatialsourceUid, String envelope, List<String> embed, final ApiCallback<SpatialSourcesEndpointType> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = getSpatialSourceByUIDValidateBeforeCall(spatialsourceUid, envelope, embed, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<SpatialSourcesEndpointType>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for getSpatialSourceSingleAddDoc
     * @param spatialsourceUid SpatialSource UID (required)
     * @param adddocUid SpatialSource UID (required)
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param fields Comma separated list of field names (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call getSpatialSourceSingleAddDocCall(String spatialsourceUid, String adddocUid, String envelope, List<String> fields, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;

        // create path and map variables
        String localVarPath = "/spatialsource/{spatialsource_uid}/AdditionalDocument/{adddoc_uid}"
            .replaceAll("\\{" + "spatialsource_uid" + "\\}", apiClient.escapeString(spatialsourceUid.toString()))
            .replaceAll("\\{" + "adddoc_uid" + "\\}", apiClient.escapeString(adddocUid.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (envelope != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("envelope", envelope));
        if (fields != null)
        localVarCollectionQueryParams.addAll(apiClient.parameterToPairs("csv", "fields", fields));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call getSpatialSourceSingleAddDocValidateBeforeCall(String spatialsourceUid, String adddocUid, String envelope, List<String> fields, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'spatialsourceUid' is set
        if (spatialsourceUid == null) {
            throw new ApiException("Missing the required parameter 'spatialsourceUid' when calling getSpatialSourceSingleAddDoc(Async)");
        }
        
        // verify the required parameter 'adddocUid' is set
        if (adddocUid == null) {
            throw new ApiException("Missing the required parameter 'adddocUid' when calling getSpatialSourceSingleAddDoc(Async)");
        }
        

        com.squareup.okhttp.Call call = getSpatialSourceSingleAddDocCall(spatialsourceUid, adddocUid, envelope, fields, progressListener, progressRequestListener);
        return call;

    }

    /**
     * Returns the additional documents of a spatial source
     * Returns the additional documents of a spatial source
     * @param spatialsourceUid SpatialSource UID (required)
     * @param adddocUid SpatialSource UID (required)
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param fields Comma separated list of field names (optional)
     * @return List&lt;AdditionalDocumentsEndpointType&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public List<AdditionalDocumentsEndpointType> getSpatialSourceSingleAddDoc(String spatialsourceUid, String adddocUid, String envelope, List<String> fields) throws ApiException {
        ApiResponse<List<AdditionalDocumentsEndpointType>> resp = getSpatialSourceSingleAddDocWithHttpInfo(spatialsourceUid, adddocUid, envelope, fields);
        return resp.getData();
    }

    /**
     * Returns the additional documents of a spatial source
     * Returns the additional documents of a spatial source
     * @param spatialsourceUid SpatialSource UID (required)
     * @param adddocUid SpatialSource UID (required)
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param fields Comma separated list of field names (optional)
     * @return ApiResponse&lt;List&lt;AdditionalDocumentsEndpointType&gt;&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<List<AdditionalDocumentsEndpointType>> getSpatialSourceSingleAddDocWithHttpInfo(String spatialsourceUid, String adddocUid, String envelope, List<String> fields) throws ApiException {
        com.squareup.okhttp.Call call = getSpatialSourceSingleAddDocValidateBeforeCall(spatialsourceUid, adddocUid, envelope, fields, null, null);
        Type localVarReturnType = new TypeToken<List<AdditionalDocumentsEndpointType>>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Returns the additional documents of a spatial source (asynchronously)
     * Returns the additional documents of a spatial source
     * @param spatialsourceUid SpatialSource UID (required)
     * @param adddocUid SpatialSource UID (required)
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param fields Comma separated list of field names (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call getSpatialSourceSingleAddDocAsync(String spatialsourceUid, String adddocUid, String envelope, List<String> fields, final ApiCallback<List<AdditionalDocumentsEndpointType>> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = getSpatialSourceSingleAddDocValidateBeforeCall(spatialsourceUid, adddocUid, envelope, fields, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<List<AdditionalDocumentsEndpointType>>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for getSpatialSources
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param uid Comma separated list of SpatialSources UID (optional)
     * @param name Comma separated list of SpatialSources names (optional)
     * @param type Comma separated list of SpatialSources types (optional)
     * @param projects Comma separated list of project UID (optional)
     * @param tags Comma separated list of tags (optional)
     * @param page Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)
     * @param sort The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)
     * @param fields Comma separated list of tags (optional)
     * @param embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call getSpatialSourcesCall(String envelope, List<String> uid, List<String> name, List<String> type, List<String> projects, List<String> tags, Integer page, String sort, List<String> fields, List<String> embed, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;

        // create path and map variables
        String localVarPath = "/spatialsources";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (envelope != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("envelope", envelope));
        if (uid != null)
        localVarCollectionQueryParams.addAll(apiClient.parameterToPairs("csv", "uid", uid));
        if (name != null)
        localVarCollectionQueryParams.addAll(apiClient.parameterToPairs("csv", "name", name));
        if (type != null)
        localVarCollectionQueryParams.addAll(apiClient.parameterToPairs("csv", "type", type));
        if (projects != null)
        localVarCollectionQueryParams.addAll(apiClient.parameterToPairs("csv", "projects", projects));
        if (tags != null)
        localVarCollectionQueryParams.addAll(apiClient.parameterToPairs("csv", "tags", tags));
        if (page != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("page", page));
        if (sort != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("sort", sort));
        if (fields != null)
        localVarCollectionQueryParams.addAll(apiClient.parameterToPairs("csv", "fields", fields));
        if (embed != null)
        localVarCollectionQueryParams.addAll(apiClient.parameterToPairs("csv", "embed", embed));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call getSpatialSourcesValidateBeforeCall(String envelope, List<String> uid, List<String> name, List<String> type, List<String> projects, List<String> tags, Integer page, String sort, List<String> fields, List<String> embed, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        

        com.squareup.okhttp.Call call = getSpatialSourcesCall(envelope, uid, name, type, projects, tags, page, sort, fields, embed, progressListener, progressRequestListener);
        return call;

    }

    /**
     * Returns a list of SpatialSources
     * Returns a list of SpatialSources
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param uid Comma separated list of SpatialSources UID (optional)
     * @param name Comma separated list of SpatialSources names (optional)
     * @param type Comma separated list of SpatialSources types (optional)
     * @param projects Comma separated list of project UID (optional)
     * @param tags Comma separated list of tags (optional)
     * @param page Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)
     * @param sort The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)
     * @param fields Comma separated list of tags (optional)
     * @param embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)
     * @return List&lt;SpatialSourcesEndpointType&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public List<SpatialSourcesEndpointType> getSpatialSources(String envelope, List<String> uid, List<String> name, List<String> type, List<String> projects, List<String> tags, Integer page, String sort, List<String> fields, List<String> embed) throws ApiException {
        ApiResponse<List<SpatialSourcesEndpointType>> resp = getSpatialSourcesWithHttpInfo(envelope, uid, name, type, projects, tags, page, sort, fields, embed);
        return resp.getData();
    }

    /**
     * Returns a list of SpatialSources
     * Returns a list of SpatialSources
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param uid Comma separated list of SpatialSources UID (optional)
     * @param name Comma separated list of SpatialSources names (optional)
     * @param type Comma separated list of SpatialSources types (optional)
     * @param projects Comma separated list of project UID (optional)
     * @param tags Comma separated list of tags (optional)
     * @param page Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)
     * @param sort The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)
     * @param fields Comma separated list of tags (optional)
     * @param embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)
     * @return ApiResponse&lt;List&lt;SpatialSourcesEndpointType&gt;&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<List<SpatialSourcesEndpointType>> getSpatialSourcesWithHttpInfo(String envelope, List<String> uid, List<String> name, List<String> type, List<String> projects, List<String> tags, Integer page, String sort, List<String> fields, List<String> embed) throws ApiException {
        com.squareup.okhttp.Call call = getSpatialSourcesValidateBeforeCall(envelope, uid, name, type, projects, tags, page, sort, fields, embed, null, null);
        Type localVarReturnType = new TypeToken<List<SpatialSourcesEndpointType>>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Returns a list of SpatialSources (asynchronously)
     * Returns a list of SpatialSources
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param uid Comma separated list of SpatialSources UID (optional)
     * @param name Comma separated list of SpatialSources names (optional)
     * @param type Comma separated list of SpatialSources types (optional)
     * @param projects Comma separated list of project UID (optional)
     * @param tags Comma separated list of tags (optional)
     * @param page Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)
     * @param sort The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)
     * @param fields Comma separated list of tags (optional)
     * @param embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call getSpatialSourcesAsync(String envelope, List<String> uid, List<String> name, List<String> type, List<String> projects, List<String> tags, Integer page, String sort, List<String> fields, List<String> embed, final ApiCallback<List<SpatialSourcesEndpointType>> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = getSpatialSourcesValidateBeforeCall(envelope, uid, name, type, projects, tags, page, sort, fields, embed, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<List<SpatialSourcesEndpointType>>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for newSpatialSource
     * @param newspatialsource New SpatialSource data (required)
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)
     * @param processUid deprecated (optional)
     * @param i4lProcessUid Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call newSpatialSourceCall(SpatialSourcesPostRequest newspatialsource, String envelope, List<String> embed, String processUid, String i4lProcessUid, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = newspatialsource;

        // create path and map variables
        String localVarPath = "/spatialsources";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (envelope != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("envelope", envelope));
        if (embed != null)
        localVarCollectionQueryParams.addAll(apiClient.parameterToPairs("csv", "embed", embed));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        if (processUid != null)
        localVarHeaderParams.put("process_uid", apiClient.parameterToString(processUid));
        if (i4lProcessUid != null)
        localVarHeaderParams.put("i4l-process-uid", apiClient.parameterToString(i4lProcessUid));

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call newSpatialSourceValidateBeforeCall(SpatialSourcesPostRequest newspatialsource, String envelope, List<String> embed, String processUid, String i4lProcessUid, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'newspatialsource' is set
        if (newspatialsource == null) {
            throw new ApiException("Missing the required parameter 'newspatialsource' when calling newSpatialSource(Async)");
        }
        

        com.squareup.okhttp.Call call = newSpatialSourceCall(newspatialsource, envelope, embed, processUid, i4lProcessUid, progressListener, progressRequestListener);
        return call;

    }

    /**
     * Create a new SpatialSource
     * Create a new SpatialSource. To add a new SpatialSources , the content of SpatialSources  must be stored in advanced via the ContentItem endpoint.
     * @param newspatialsource New SpatialSource data (required)
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)
     * @param processUid deprecated (optional)
     * @param i4lProcessUid Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)
     * @return SpatialSourcesEndpointType
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public SpatialSourcesEndpointType newSpatialSource(SpatialSourcesPostRequest newspatialsource, String envelope, List<String> embed, String processUid, String i4lProcessUid) throws ApiException {
        ApiResponse<SpatialSourcesEndpointType> resp = newSpatialSourceWithHttpInfo(newspatialsource, envelope, embed, processUid, i4lProcessUid);
        return resp.getData();
    }

    /**
     * Create a new SpatialSource
     * Create a new SpatialSource. To add a new SpatialSources , the content of SpatialSources  must be stored in advanced via the ContentItem endpoint.
     * @param newspatialsource New SpatialSource data (required)
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)
     * @param processUid deprecated (optional)
     * @param i4lProcessUid Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)
     * @return ApiResponse&lt;SpatialSourcesEndpointType&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<SpatialSourcesEndpointType> newSpatialSourceWithHttpInfo(SpatialSourcesPostRequest newspatialsource, String envelope, List<String> embed, String processUid, String i4lProcessUid) throws ApiException {
        com.squareup.okhttp.Call call = newSpatialSourceValidateBeforeCall(newspatialsource, envelope, embed, processUid, i4lProcessUid, null, null);
        Type localVarReturnType = new TypeToken<SpatialSourcesEndpointType>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Create a new SpatialSource (asynchronously)
     * Create a new SpatialSource. To add a new SpatialSources , the content of SpatialSources  must be stored in advanced via the ContentItem endpoint.
     * @param newspatialsource New SpatialSource data (required)
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)
     * @param processUid deprecated (optional)
     * @param i4lProcessUid Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call newSpatialSourceAsync(SpatialSourcesPostRequest newspatialsource, String envelope, List<String> embed, String processUid, String i4lProcessUid, final ApiCallback<SpatialSourcesEndpointType> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = newSpatialSourceValidateBeforeCall(newspatialsource, envelope, embed, processUid, i4lProcessUid, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<SpatialSourcesEndpointType>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for newSpatialSourceAddAddDoc
     * @param spatialsourceUid SpatialSource UID (required)
     * @param newadddocdata New additional document data (required)
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param i4lProcessUid Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call newSpatialSourceAddAddDocCall(String spatialsourceUid, AdditionalDocumentsPost newadddocdata, String envelope, String i4lProcessUid, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = newadddocdata;

        // create path and map variables
        String localVarPath = "/spatialsource/{spatialsource_uid}/AdditionalDocument"
            .replaceAll("\\{" + "spatialsource_uid" + "\\}", apiClient.escapeString(spatialsourceUid.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (envelope != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("envelope", envelope));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        if (i4lProcessUid != null)
        localVarHeaderParams.put("i4l-process-uid", apiClient.parameterToString(i4lProcessUid));

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call newSpatialSourceAddAddDocValidateBeforeCall(String spatialsourceUid, AdditionalDocumentsPost newadddocdata, String envelope, String i4lProcessUid, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'spatialsourceUid' is set
        if (spatialsourceUid == null) {
            throw new ApiException("Missing the required parameter 'spatialsourceUid' when calling newSpatialSourceAddAddDoc(Async)");
        }
        
        // verify the required parameter 'newadddocdata' is set
        if (newadddocdata == null) {
            throw new ApiException("Missing the required parameter 'newadddocdata' when calling newSpatialSourceAddAddDoc(Async)");
        }
        

        com.squareup.okhttp.Call call = newSpatialSourceAddAddDocCall(spatialsourceUid, newadddocdata, envelope, i4lProcessUid, progressListener, progressRequestListener);
        return call;

    }

    /**
     * Add a new additional document to a spatial source
     * Add a new additional document to a spatial source
     * @param spatialsourceUid SpatialSource UID (required)
     * @param newadddocdata New additional document data (required)
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param i4lProcessUid Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)
     * @return AdditionalDocumentsEndpointType
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public AdditionalDocumentsEndpointType newSpatialSourceAddAddDoc(String spatialsourceUid, AdditionalDocumentsPost newadddocdata, String envelope, String i4lProcessUid) throws ApiException {
        ApiResponse<AdditionalDocumentsEndpointType> resp = newSpatialSourceAddAddDocWithHttpInfo(spatialsourceUid, newadddocdata, envelope, i4lProcessUid);
        return resp.getData();
    }

    /**
     * Add a new additional document to a spatial source
     * Add a new additional document to a spatial source
     * @param spatialsourceUid SpatialSource UID (required)
     * @param newadddocdata New additional document data (required)
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param i4lProcessUid Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)
     * @return ApiResponse&lt;AdditionalDocumentsEndpointType&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<AdditionalDocumentsEndpointType> newSpatialSourceAddAddDocWithHttpInfo(String spatialsourceUid, AdditionalDocumentsPost newadddocdata, String envelope, String i4lProcessUid) throws ApiException {
        com.squareup.okhttp.Call call = newSpatialSourceAddAddDocValidateBeforeCall(spatialsourceUid, newadddocdata, envelope, i4lProcessUid, null, null);
        Type localVarReturnType = new TypeToken<AdditionalDocumentsEndpointType>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Add a new additional document to a spatial source (asynchronously)
     * Add a new additional document to a spatial source
     * @param spatialsourceUid SpatialSource UID (required)
     * @param newadddocdata New additional document data (required)
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param i4lProcessUid Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call newSpatialSourceAddAddDocAsync(String spatialsourceUid, AdditionalDocumentsPost newadddocdata, String envelope, String i4lProcessUid, final ApiCallback<AdditionalDocumentsEndpointType> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = newSpatialSourceAddAddDocValidateBeforeCall(spatialsourceUid, newadddocdata, envelope, i4lProcessUid, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<AdditionalDocumentsEndpointType>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for putSpatialSourceByUID
     * @param spatialsourceUid SpatialSource UID (required)
     * @param updatedspatialsource Updated spatial source (required)
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)
     * @param i4lProcessUid Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call putSpatialSourceByUIDCall(String spatialsourceUid, SpatialSourcesPostRequest updatedspatialsource, String envelope, List<String> embed, String i4lProcessUid, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = updatedspatialsource;

        // create path and map variables
        String localVarPath = "/spatialsource/{spatialsource_uid}"
            .replaceAll("\\{" + "spatialsource_uid" + "\\}", apiClient.escapeString(spatialsourceUid.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (envelope != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("envelope", envelope));
        if (embed != null)
        localVarCollectionQueryParams.addAll(apiClient.parameterToPairs("csv", "embed", embed));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        if (i4lProcessUid != null)
        localVarHeaderParams.put("i4l-process-uid", apiClient.parameterToString(i4lProcessUid));

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "PUT", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call putSpatialSourceByUIDValidateBeforeCall(String spatialsourceUid, SpatialSourcesPostRequest updatedspatialsource, String envelope, List<String> embed, String i4lProcessUid, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'spatialsourceUid' is set
        if (spatialsourceUid == null) {
            throw new ApiException("Missing the required parameter 'spatialsourceUid' when calling putSpatialSourceByUID(Async)");
        }
        
        // verify the required parameter 'updatedspatialsource' is set
        if (updatedspatialsource == null) {
            throw new ApiException("Missing the required parameter 'updatedspatialsource' when calling putSpatialSourceByUID(Async)");
        }
        

        com.squareup.okhttp.Call call = putSpatialSourceByUIDCall(spatialsourceUid, updatedspatialsource, envelope, embed, i4lProcessUid, progressListener, progressRequestListener);
        return call;

    }

    /**
     * Replace an existing SpatialSource by a newer version
     * An existing SpatialSource will be replaced by a newer version. The UID of SpatialSource remains
     * @param spatialsourceUid SpatialSource UID (required)
     * @param updatedspatialsource Updated spatial source (required)
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)
     * @param i4lProcessUid Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)
     * @return SpatialSourcesEndpointType
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public SpatialSourcesEndpointType putSpatialSourceByUID(String spatialsourceUid, SpatialSourcesPostRequest updatedspatialsource, String envelope, List<String> embed, String i4lProcessUid) throws ApiException {
        ApiResponse<SpatialSourcesEndpointType> resp = putSpatialSourceByUIDWithHttpInfo(spatialsourceUid, updatedspatialsource, envelope, embed, i4lProcessUid);
        return resp.getData();
    }

    /**
     * Replace an existing SpatialSource by a newer version
     * An existing SpatialSource will be replaced by a newer version. The UID of SpatialSource remains
     * @param spatialsourceUid SpatialSource UID (required)
     * @param updatedspatialsource Updated spatial source (required)
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)
     * @param i4lProcessUid Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)
     * @return ApiResponse&lt;SpatialSourcesEndpointType&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<SpatialSourcesEndpointType> putSpatialSourceByUIDWithHttpInfo(String spatialsourceUid, SpatialSourcesPostRequest updatedspatialsource, String envelope, List<String> embed, String i4lProcessUid) throws ApiException {
        com.squareup.okhttp.Call call = putSpatialSourceByUIDValidateBeforeCall(spatialsourceUid, updatedspatialsource, envelope, embed, i4lProcessUid, null, null);
        Type localVarReturnType = new TypeToken<SpatialSourcesEndpointType>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Replace an existing SpatialSource by a newer version (asynchronously)
     * An existing SpatialSource will be replaced by a newer version. The UID of SpatialSource remains
     * @param spatialsourceUid SpatialSource UID (required)
     * @param updatedspatialsource Updated spatial source (required)
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)
     * @param i4lProcessUid Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call putSpatialSourceByUIDAsync(String spatialsourceUid, SpatialSourcesPostRequest updatedspatialsource, String envelope, List<String> embed, String i4lProcessUid, final ApiCallback<SpatialSourcesEndpointType> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = putSpatialSourceByUIDValidateBeforeCall(spatialsourceUid, updatedspatialsource, envelope, embed, i4lProcessUid, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<SpatialSourcesEndpointType>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
}
