/*
 * its4land Public API
 * The its4land Public API provides access to the services of the its4land Publish and Share platform.
 *
 * OpenAPI spec version: 0.0.2
 * Contact: contact@its4land.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package io.swagger.client.api;

import io.swagger.client.ApiCallback;
import io.swagger.client.ApiClient;
import io.swagger.client.ApiException;
import io.swagger.client.ApiResponse;
import io.swagger.client.Configuration;
import io.swagger.client.Pair;
import io.swagger.client.ProgressRequestBody;
import io.swagger.client.ProgressResponseBody;

import com.google.gson.reflect.TypeToken;

import java.io.IOException;


import io.swagger.client.model.RFC6902PatchRequest;
import io.swagger.client.model.TagsEndpointType;

import java.lang.reflect.Type;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class TagsApi {
    private ApiClient apiClient;

    public TagsApi() {
        this(Configuration.getDefaultApiClient());
    }

    public TagsApi(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    public ApiClient getApiClient() {
        return apiClient;
    }

    public void setApiClient(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    /**
     * Build call for getTagByName
     * @param tagName Tag Name (required)
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call getTagByNameCall(String tagName, String envelope, List<String> embed, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;

        // create path and map variables
        String localVarPath = "/tags/{tag_name}"
            .replaceAll("\\{" + "tag_name" + "\\}", apiClient.escapeString(tagName.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (envelope != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("envelope", envelope));
        if (embed != null)
        localVarCollectionQueryParams.addAll(apiClient.parameterToPairs("csv", "embed", embed));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call getTagByNameValidateBeforeCall(String tagName, String envelope, List<String> embed, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'tagName' is set
        if (tagName == null) {
            throw new ApiException("Missing the required parameter 'tagName' when calling getTagByName(Async)");
        }
        

        com.squareup.okhttp.Call call = getTagByNameCall(tagName, envelope, embed, progressListener, progressRequestListener);
        return call;

    }

    /**
     * Returns a single tag
     * Returns a tag
     * @param tagName Tag Name (required)
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)
     * @return TagsEndpointType
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public TagsEndpointType getTagByName(String tagName, String envelope, List<String> embed) throws ApiException {
        ApiResponse<TagsEndpointType> resp = getTagByNameWithHttpInfo(tagName, envelope, embed);
        return resp.getData();
    }

    /**
     * Returns a single tag
     * Returns a tag
     * @param tagName Tag Name (required)
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)
     * @return ApiResponse&lt;TagsEndpointType&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<TagsEndpointType> getTagByNameWithHttpInfo(String tagName, String envelope, List<String> embed) throws ApiException {
        com.squareup.okhttp.Call call = getTagByNameValidateBeforeCall(tagName, envelope, embed, null, null);
        Type localVarReturnType = new TypeToken<TagsEndpointType>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Returns a single tag (asynchronously)
     * Returns a tag
     * @param tagName Tag Name (required)
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call getTagByNameAsync(String tagName, String envelope, List<String> embed, final ApiCallback<TagsEndpointType> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = getTagByNameValidateBeforeCall(tagName, envelope, embed, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<TagsEndpointType>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for getTags
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param uid Comma separated list of Tag UID (optional)
     * @param displayvalue Comma separated list of Tag display value (optional)
     * @param objecttypes Comma separated list of objects types (optional)
     * @param objectuuid Comma separated list of object UID (optional)
     * @param page Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)
     * @param sort The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)
     * @param fields Comma separated list of tags (optional)
     * @param embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call getTagsCall(String envelope, List<String> uid, List<String> displayvalue, List<String> objecttypes, List<String> objectuuid, Integer page, String sort, List<String> fields, List<String> embed, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;

        // create path and map variables
        String localVarPath = "/tags";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (envelope != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("envelope", envelope));
        if (uid != null)
        localVarCollectionQueryParams.addAll(apiClient.parameterToPairs("csv", "uid", uid));
        if (displayvalue != null)
        localVarCollectionQueryParams.addAll(apiClient.parameterToPairs("csv", "displayvalue", displayvalue));
        if (objecttypes != null)
        localVarCollectionQueryParams.addAll(apiClient.parameterToPairs("csv", "objecttypes", objecttypes));
        if (objectuuid != null)
        localVarCollectionQueryParams.addAll(apiClient.parameterToPairs("csv", "objectuuid", objectuuid));
        if (page != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("page", page));
        if (sort != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("sort", sort));
        if (fields != null)
        localVarCollectionQueryParams.addAll(apiClient.parameterToPairs("csv", "fields", fields));
        if (embed != null)
        localVarCollectionQueryParams.addAll(apiClient.parameterToPairs("csv", "embed", embed));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call getTagsValidateBeforeCall(String envelope, List<String> uid, List<String> displayvalue, List<String> objecttypes, List<String> objectuuid, Integer page, String sort, List<String> fields, List<String> embed, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        

        com.squareup.okhttp.Call call = getTagsCall(envelope, uid, displayvalue, objecttypes, objectuuid, page, sort, fields, embed, progressListener, progressRequestListener);
        return call;

    }

    /**
     * Get a list of tags
     * Get a list of tags
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param uid Comma separated list of Tag UID (optional)
     * @param displayvalue Comma separated list of Tag display value (optional)
     * @param objecttypes Comma separated list of objects types (optional)
     * @param objectuuid Comma separated list of object UID (optional)
     * @param page Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)
     * @param sort The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)
     * @param fields Comma separated list of tags (optional)
     * @param embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)
     * @return List&lt;TagsEndpointType&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public List<TagsEndpointType> getTags(String envelope, List<String> uid, List<String> displayvalue, List<String> objecttypes, List<String> objectuuid, Integer page, String sort, List<String> fields, List<String> embed) throws ApiException {
        ApiResponse<List<TagsEndpointType>> resp = getTagsWithHttpInfo(envelope, uid, displayvalue, objecttypes, objectuuid, page, sort, fields, embed);
        return resp.getData();
    }

    /**
     * Get a list of tags
     * Get a list of tags
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param uid Comma separated list of Tag UID (optional)
     * @param displayvalue Comma separated list of Tag display value (optional)
     * @param objecttypes Comma separated list of objects types (optional)
     * @param objectuuid Comma separated list of object UID (optional)
     * @param page Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)
     * @param sort The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)
     * @param fields Comma separated list of tags (optional)
     * @param embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)
     * @return ApiResponse&lt;List&lt;TagsEndpointType&gt;&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<List<TagsEndpointType>> getTagsWithHttpInfo(String envelope, List<String> uid, List<String> displayvalue, List<String> objecttypes, List<String> objectuuid, Integer page, String sort, List<String> fields, List<String> embed) throws ApiException {
        com.squareup.okhttp.Call call = getTagsValidateBeforeCall(envelope, uid, displayvalue, objecttypes, objectuuid, page, sort, fields, embed, null, null);
        Type localVarReturnType = new TypeToken<List<TagsEndpointType>>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Get a list of tags (asynchronously)
     * Get a list of tags
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param uid Comma separated list of Tag UID (optional)
     * @param displayvalue Comma separated list of Tag display value (optional)
     * @param objecttypes Comma separated list of objects types (optional)
     * @param objectuuid Comma separated list of object UID (optional)
     * @param page Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)
     * @param sort The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)
     * @param fields Comma separated list of tags (optional)
     * @param embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call getTagsAsync(String envelope, List<String> uid, List<String> displayvalue, List<String> objecttypes, List<String> objectuuid, Integer page, String sort, List<String> fields, List<String> embed, final ApiCallback<List<TagsEndpointType>> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = getTagsValidateBeforeCall(envelope, uid, displayvalue, objecttypes, objectuuid, page, sort, fields, embed, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<List<TagsEndpointType>>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for mergeTagByUID
     * @param tagUid Tag UID (required)
     * @param mergetag Update data (required)
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param i4lProcessUid Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call mergeTagByUIDCall(String tagUid, RFC6902PatchRequest mergetag, String envelope, String i4lProcessUid, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = mergetag;

        // create path and map variables
        String localVarPath = "/tags/{tag_uid}/merge"
            .replaceAll("\\{" + "tag_uid" + "\\}", apiClient.escapeString(tagUid.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (envelope != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("envelope", envelope));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        if (i4lProcessUid != null)
        localVarHeaderParams.put("i4l-process-uid", apiClient.parameterToString(i4lProcessUid));

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "PATCH", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call mergeTagByUIDValidateBeforeCall(String tagUid, RFC6902PatchRequest mergetag, String envelope, String i4lProcessUid, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'tagUid' is set
        if (tagUid == null) {
            throw new ApiException("Missing the required parameter 'tagUid' when calling mergeTagByUID(Async)");
        }
        
        // verify the required parameter 'mergetag' is set
        if (mergetag == null) {
            throw new ApiException("Missing the required parameter 'mergetag' when calling mergeTagByUID(Async)");
        }
        

        com.squareup.okhttp.Call call = mergeTagByUIDCall(tagUid, mergetag, envelope, i4lProcessUid, progressListener, progressRequestListener);
        return call;

    }

    /**
     * Merge tags
     * merge tags
     * @param tagUid Tag UID (required)
     * @param mergetag Update data (required)
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param i4lProcessUid Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)
     * @return TagsEndpointType
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public TagsEndpointType mergeTagByUID(String tagUid, RFC6902PatchRequest mergetag, String envelope, String i4lProcessUid) throws ApiException {
        ApiResponse<TagsEndpointType> resp = mergeTagByUIDWithHttpInfo(tagUid, mergetag, envelope, i4lProcessUid);
        return resp.getData();
    }

    /**
     * Merge tags
     * merge tags
     * @param tagUid Tag UID (required)
     * @param mergetag Update data (required)
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param i4lProcessUid Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)
     * @return ApiResponse&lt;TagsEndpointType&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<TagsEndpointType> mergeTagByUIDWithHttpInfo(String tagUid, RFC6902PatchRequest mergetag, String envelope, String i4lProcessUid) throws ApiException {
        com.squareup.okhttp.Call call = mergeTagByUIDValidateBeforeCall(tagUid, mergetag, envelope, i4lProcessUid, null, null);
        Type localVarReturnType = new TypeToken<TagsEndpointType>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Merge tags (asynchronously)
     * merge tags
     * @param tagUid Tag UID (required)
     * @param mergetag Update data (required)
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param i4lProcessUid Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call mergeTagByUIDAsync(String tagUid, RFC6902PatchRequest mergetag, String envelope, String i4lProcessUid, final ApiCallback<TagsEndpointType> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = mergeTagByUIDValidateBeforeCall(tagUid, mergetag, envelope, i4lProcessUid, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<TagsEndpointType>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for updateTagByName
     * @param tagName Tag UID (required)
     * @param patchtag Update data (required)
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)
     * @param i4lProcessUid Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call updateTagByNameCall(String tagName, RFC6902PatchRequest patchtag, String envelope, List<String> embed, String i4lProcessUid, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = patchtag;

        // create path and map variables
        String localVarPath = "/tags/{tag_name}"
            .replaceAll("\\{" + "tag_name" + "\\}", apiClient.escapeString(tagName.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (envelope != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("envelope", envelope));
        if (embed != null)
        localVarCollectionQueryParams.addAll(apiClient.parameterToPairs("csv", "embed", embed));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        if (i4lProcessUid != null)
        localVarHeaderParams.put("i4l-process-uid", apiClient.parameterToString(i4lProcessUid));

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "PATCH", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call updateTagByNameValidateBeforeCall(String tagName, RFC6902PatchRequest patchtag, String envelope, List<String> embed, String i4lProcessUid, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'tagName' is set
        if (tagName == null) {
            throw new ApiException("Missing the required parameter 'tagName' when calling updateTagByName(Async)");
        }
        
        // verify the required parameter 'patchtag' is set
        if (patchtag == null) {
            throw new ApiException("Missing the required parameter 'patchtag' when calling updateTagByName(Async)");
        }
        

        com.squareup.okhttp.Call call = updateTagByNameCall(tagName, patchtag, envelope, embed, i4lProcessUid, progressListener, progressRequestListener);
        return call;

    }

    /**
     * Updates a tag
     * Updates a tag
     * @param tagName Tag UID (required)
     * @param patchtag Update data (required)
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)
     * @param i4lProcessUid Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)
     * @return TagsEndpointType
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public TagsEndpointType updateTagByName(String tagName, RFC6902PatchRequest patchtag, String envelope, List<String> embed, String i4lProcessUid) throws ApiException {
        ApiResponse<TagsEndpointType> resp = updateTagByNameWithHttpInfo(tagName, patchtag, envelope, embed, i4lProcessUid);
        return resp.getData();
    }

    /**
     * Updates a tag
     * Updates a tag
     * @param tagName Tag UID (required)
     * @param patchtag Update data (required)
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)
     * @param i4lProcessUid Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)
     * @return ApiResponse&lt;TagsEndpointType&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<TagsEndpointType> updateTagByNameWithHttpInfo(String tagName, RFC6902PatchRequest patchtag, String envelope, List<String> embed, String i4lProcessUid) throws ApiException {
        com.squareup.okhttp.Call call = updateTagByNameValidateBeforeCall(tagName, patchtag, envelope, embed, i4lProcessUid, null, null);
        Type localVarReturnType = new TypeToken<TagsEndpointType>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Updates a tag (asynchronously)
     * Updates a tag
     * @param tagName Tag UID (required)
     * @param patchtag Update data (required)
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)
     * @param i4lProcessUid Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call updateTagByNameAsync(String tagName, RFC6902PatchRequest patchtag, String envelope, List<String> embed, String i4lProcessUid, final ApiCallback<TagsEndpointType> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = updateTagByNameValidateBeforeCall(tagName, patchtag, envelope, embed, i4lProcessUid, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<TagsEndpointType>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
}
