/*
 * its4land Public API
 * The its4land Public API provides access to the services of the its4land Publish and Share platform.
 *
 * OpenAPI spec version: 0.0.2
 * Contact: contact@its4land.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package io.swagger.client.api;

import io.swagger.client.ApiCallback;
import io.swagger.client.ApiClient;
import io.swagger.client.ApiException;
import io.swagger.client.ApiResponse;
import io.swagger.client.Configuration;
import io.swagger.client.Pair;
import io.swagger.client.ProgressRequestBody;
import io.swagger.client.ProgressResponseBody;

import com.google.gson.reflect.TypeToken;

import java.io.IOException;


import io.swagger.client.model.WP5ValidationSetsEndpointType;
import io.swagger.client.model.WP5ValidationSetsPostRequest;

import java.lang.reflect.Type;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class Wp5ValidationSetsApi {
    private ApiClient apiClient;

    public Wp5ValidationSetsApi() {
        this(Configuration.getDefaultApiClient());
    }

    public Wp5ValidationSetsApi(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    public ApiClient getApiClient() {
        return apiClient;
    }

    public void setApiClient(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    /**
     * Build call for getWP5ValidationSetByUID
     * @param wp5validationsetUid WP5ValidationSet UID (required)
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call getWP5ValidationSetByUIDCall(String wp5validationsetUid, String envelope, List<String> embed, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;

        // create path and map variables
        String localVarPath = "/WP5ValidationSets/{wp5validationset_uid}"
            .replaceAll("\\{" + "wp5validationset_uid" + "\\}", apiClient.escapeString(wp5validationsetUid.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (envelope != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("envelope", envelope));
        if (embed != null)
        localVarCollectionQueryParams.addAll(apiClient.parameterToPairs("csv", "embed", embed));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call getWP5ValidationSetByUIDValidateBeforeCall(String wp5validationsetUid, String envelope, List<String> embed, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'wp5validationsetUid' is set
        if (wp5validationsetUid == null) {
            throw new ApiException("Missing the required parameter 'wp5validationsetUid' when calling getWP5ValidationSetByUID(Async)");
        }
        

        com.squareup.okhttp.Call call = getWP5ValidationSetByUIDCall(wp5validationsetUid, envelope, embed, progressListener, progressRequestListener);
        return call;

    }

    /**
     * Returns a single WP5ValidationSet
     * Returns a single WP5ValidationSet
     * @param wp5validationsetUid WP5ValidationSet UID (required)
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)
     * @return WP5ValidationSetsEndpointType
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public WP5ValidationSetsEndpointType getWP5ValidationSetByUID(String wp5validationsetUid, String envelope, List<String> embed) throws ApiException {
        ApiResponse<WP5ValidationSetsEndpointType> resp = getWP5ValidationSetByUIDWithHttpInfo(wp5validationsetUid, envelope, embed);
        return resp.getData();
    }

    /**
     * Returns a single WP5ValidationSet
     * Returns a single WP5ValidationSet
     * @param wp5validationsetUid WP5ValidationSet UID (required)
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)
     * @return ApiResponse&lt;WP5ValidationSetsEndpointType&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<WP5ValidationSetsEndpointType> getWP5ValidationSetByUIDWithHttpInfo(String wp5validationsetUid, String envelope, List<String> embed) throws ApiException {
        com.squareup.okhttp.Call call = getWP5ValidationSetByUIDValidateBeforeCall(wp5validationsetUid, envelope, embed, null, null);
        Type localVarReturnType = new TypeToken<WP5ValidationSetsEndpointType>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Returns a single WP5ValidationSet (asynchronously)
     * Returns a single WP5ValidationSet
     * @param wp5validationsetUid WP5ValidationSet UID (required)
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call getWP5ValidationSetByUIDAsync(String wp5validationsetUid, String envelope, List<String> embed, final ApiCallback<WP5ValidationSetsEndpointType> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = getWP5ValidationSetByUIDValidateBeforeCall(wp5validationsetUid, envelope, embed, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<WP5ValidationSetsEndpointType>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for getWP5ValidationSets
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param uid Comma separated list of TrainingSet UID (optional)
     * @param name Comma separated list of WP5ValidationSets Names (optional)
     * @param models Comma separated list of model UID (optional)
     * @param projects Comma separated list of project UID (optional)
     * @param tags Comma separated list of tags (optional)
     * @param page Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)
     * @param sort The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)
     * @param fields Comma separated list of field names (optional)
     * @param embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call getWP5ValidationSetsCall(String envelope, List<String> uid, List<String> name, List<String> models, List<String> projects, List<String> tags, Integer page, String sort, List<String> fields, List<String> embed, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;

        // create path and map variables
        String localVarPath = "/WP5ValidationSets";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (envelope != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("envelope", envelope));
        if (uid != null)
        localVarCollectionQueryParams.addAll(apiClient.parameterToPairs("csv", "uid", uid));
        if (name != null)
        localVarCollectionQueryParams.addAll(apiClient.parameterToPairs("csv", "name", name));
        if (models != null)
        localVarCollectionQueryParams.addAll(apiClient.parameterToPairs("csv", "models", models));
        if (projects != null)
        localVarCollectionQueryParams.addAll(apiClient.parameterToPairs("csv", "projects", projects));
        if (tags != null)
        localVarCollectionQueryParams.addAll(apiClient.parameterToPairs("csv", "tags", tags));
        if (page != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("page", page));
        if (sort != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("sort", sort));
        if (fields != null)
        localVarCollectionQueryParams.addAll(apiClient.parameterToPairs("csv", "fields", fields));
        if (embed != null)
        localVarCollectionQueryParams.addAll(apiClient.parameterToPairs("csv", "embed", embed));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call getWP5ValidationSetsValidateBeforeCall(String envelope, List<String> uid, List<String> name, List<String> models, List<String> projects, List<String> tags, Integer page, String sort, List<String> fields, List<String> embed, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        

        com.squareup.okhttp.Call call = getWP5ValidationSetsCall(envelope, uid, name, models, projects, tags, page, sort, fields, embed, progressListener, progressRequestListener);
        return call;

    }

    /**
     * Returns a list of WP5ValidationSets
     * Returns a list of WP5ValidationSets
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param uid Comma separated list of TrainingSet UID (optional)
     * @param name Comma separated list of WP5ValidationSets Names (optional)
     * @param models Comma separated list of model UID (optional)
     * @param projects Comma separated list of project UID (optional)
     * @param tags Comma separated list of tags (optional)
     * @param page Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)
     * @param sort The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)
     * @param fields Comma separated list of field names (optional)
     * @param embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)
     * @return List&lt;WP5ValidationSetsEndpointType&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public List<WP5ValidationSetsEndpointType> getWP5ValidationSets(String envelope, List<String> uid, List<String> name, List<String> models, List<String> projects, List<String> tags, Integer page, String sort, List<String> fields, List<String> embed) throws ApiException {
        ApiResponse<List<WP5ValidationSetsEndpointType>> resp = getWP5ValidationSetsWithHttpInfo(envelope, uid, name, models, projects, tags, page, sort, fields, embed);
        return resp.getData();
    }

    /**
     * Returns a list of WP5ValidationSets
     * Returns a list of WP5ValidationSets
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param uid Comma separated list of TrainingSet UID (optional)
     * @param name Comma separated list of WP5ValidationSets Names (optional)
     * @param models Comma separated list of model UID (optional)
     * @param projects Comma separated list of project UID (optional)
     * @param tags Comma separated list of tags (optional)
     * @param page Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)
     * @param sort The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)
     * @param fields Comma separated list of field names (optional)
     * @param embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)
     * @return ApiResponse&lt;List&lt;WP5ValidationSetsEndpointType&gt;&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<List<WP5ValidationSetsEndpointType>> getWP5ValidationSetsWithHttpInfo(String envelope, List<String> uid, List<String> name, List<String> models, List<String> projects, List<String> tags, Integer page, String sort, List<String> fields, List<String> embed) throws ApiException {
        com.squareup.okhttp.Call call = getWP5ValidationSetsValidateBeforeCall(envelope, uid, name, models, projects, tags, page, sort, fields, embed, null, null);
        Type localVarReturnType = new TypeToken<List<WP5ValidationSetsEndpointType>>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Returns a list of WP5ValidationSets (asynchronously)
     * Returns a list of WP5ValidationSets
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param uid Comma separated list of TrainingSet UID (optional)
     * @param name Comma separated list of WP5ValidationSets Names (optional)
     * @param models Comma separated list of model UID (optional)
     * @param projects Comma separated list of project UID (optional)
     * @param tags Comma separated list of tags (optional)
     * @param page Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)
     * @param sort The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)
     * @param fields Comma separated list of field names (optional)
     * @param embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call getWP5ValidationSetsAsync(String envelope, List<String> uid, List<String> name, List<String> models, List<String> projects, List<String> tags, Integer page, String sort, List<String> fields, List<String> embed, final ApiCallback<List<WP5ValidationSetsEndpointType>> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = getWP5ValidationSetsValidateBeforeCall(envelope, uid, name, models, projects, tags, page, sort, fields, embed, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<List<WP5ValidationSetsEndpointType>>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for newWP5ValidationSets
     * @param newwp5validationsets New WP5ValidationSet data (required)
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)
     * @param i4lProcessUid Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call newWP5ValidationSetsCall(WP5ValidationSetsPostRequest newwp5validationsets, String envelope, List<String> embed, String i4lProcessUid, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = newwp5validationsets;

        // create path and map variables
        String localVarPath = "/WP5ValidationSets";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (envelope != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("envelope", envelope));
        if (embed != null)
        localVarCollectionQueryParams.addAll(apiClient.parameterToPairs("csv", "embed", embed));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        if (i4lProcessUid != null)
        localVarHeaderParams.put("i4l-process-uid", apiClient.parameterToString(i4lProcessUid));

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call newWP5ValidationSetsValidateBeforeCall(WP5ValidationSetsPostRequest newwp5validationsets, String envelope, List<String> embed, String i4lProcessUid, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'newwp5validationsets' is set
        if (newwp5validationsets == null) {
            throw new ApiException("Missing the required parameter 'newwp5validationsets' when calling newWP5ValidationSets(Async)");
        }
        

        com.squareup.okhttp.Call call = newWP5ValidationSetsCall(newwp5validationsets, envelope, embed, i4lProcessUid, progressListener, progressRequestListener);
        return call;

    }

    /**
     * Create a new WP5ValidationSets
     * Create a new TrainingSet. To add a new WP5ValidationSets , the content of WP5ValidationSets  must be stored in advanced via the ContentItem endpoint
     * @param newwp5validationsets New WP5ValidationSet data (required)
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)
     * @param i4lProcessUid Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)
     * @return WP5ValidationSetsEndpointType
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public WP5ValidationSetsEndpointType newWP5ValidationSets(WP5ValidationSetsPostRequest newwp5validationsets, String envelope, List<String> embed, String i4lProcessUid) throws ApiException {
        ApiResponse<WP5ValidationSetsEndpointType> resp = newWP5ValidationSetsWithHttpInfo(newwp5validationsets, envelope, embed, i4lProcessUid);
        return resp.getData();
    }

    /**
     * Create a new WP5ValidationSets
     * Create a new TrainingSet. To add a new WP5ValidationSets , the content of WP5ValidationSets  must be stored in advanced via the ContentItem endpoint
     * @param newwp5validationsets New WP5ValidationSet data (required)
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)
     * @param i4lProcessUid Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)
     * @return ApiResponse&lt;WP5ValidationSetsEndpointType&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<WP5ValidationSetsEndpointType> newWP5ValidationSetsWithHttpInfo(WP5ValidationSetsPostRequest newwp5validationsets, String envelope, List<String> embed, String i4lProcessUid) throws ApiException {
        com.squareup.okhttp.Call call = newWP5ValidationSetsValidateBeforeCall(newwp5validationsets, envelope, embed, i4lProcessUid, null, null);
        Type localVarReturnType = new TypeToken<WP5ValidationSetsEndpointType>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Create a new WP5ValidationSets (asynchronously)
     * Create a new TrainingSet. To add a new WP5ValidationSets , the content of WP5ValidationSets  must be stored in advanced via the ContentItem endpoint
     * @param newwp5validationsets New WP5ValidationSet data (required)
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)
     * @param i4lProcessUid Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call newWP5ValidationSetsAsync(WP5ValidationSetsPostRequest newwp5validationsets, String envelope, List<String> embed, String i4lProcessUid, final ApiCallback<WP5ValidationSetsEndpointType> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = newWP5ValidationSetsValidateBeforeCall(newwp5validationsets, envelope, embed, i4lProcessUid, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<WP5ValidationSetsEndpointType>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
}
