/*
 * its4land Public API
 * The its4land Public API provides access to the services of the its4land Publish and Share platform.
 *
 * OpenAPI spec version: 0.0.2
 * Contact: contact@its4land.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package io.swagger.client.model;

import java.util.Objects;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import io.swagger.client.model.ModelsEndpointTypeModelClasses;
import io.swagger.client.model.ModelsEndpointTypeProjects;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

/**
 * ModelsPatchRequest
 */
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2019-10-11T17:16:59.919+02:00")
public class ModelsPatchRequest {
  @SerializedName("Name")
  private String name = null;

  @SerializedName("Description")
  private String description = null;

  @SerializedName("TrainingSet")
  private String trainingSet = null;

  @SerializedName("Classifier")
  private String classifier = null;

  @SerializedName("Tools")
  private List<String> tools = null;

  @SerializedName("ModelClasses")
  private List<ModelsEndpointTypeModelClasses> modelClasses = null;

  @SerializedName("Tags")
  private List<String> tags = null;

  @SerializedName("Projects")
  private List<ModelsEndpointTypeProjects> projects = null;

  public ModelsPatchRequest name(String name) {
    this.name = name;
    return this;
  }

   /**
   * Freely chosen name
   * @return name
  **/
  @ApiModelProperty(value = "Freely chosen name")
  public String getName() {
    return name;
  }

  public void setName(String name) {
    this.name = name;
  }

  public ModelsPatchRequest description(String description) {
    this.description = description;
    return this;
  }

   /**
   * Free text for description. Only plain text.
   * @return description
  **/
  @ApiModelProperty(value = "Free text for description. Only plain text.")
  public String getDescription() {
    return description;
  }

  public void setDescription(String description) {
    this.description = description;
  }

  public ModelsPatchRequest trainingSet(String trainingSet) {
    this.trainingSet = trainingSet;
    return this;
  }

   /**
   * TrainingSet of the model (UID)
   * @return trainingSet
  **/
  @ApiModelProperty(value = "TrainingSet of the model (UID)")
  public String getTrainingSet() {
    return trainingSet;
  }

  public void setTrainingSet(String trainingSet) {
    this.trainingSet = trainingSet;
  }

  public ModelsPatchRequest classifier(String classifier) {
    this.classifier = classifier;
    return this;
  }

   /**
   * UID of the assigned classifier
   * @return classifier
  **/
  @ApiModelProperty(value = "UID of the assigned classifier")
  public String getClassifier() {
    return classifier;
  }

  public void setClassifier(String classifier) {
    this.classifier = classifier;
  }

  public ModelsPatchRequest tools(List<String> tools) {
    this.tools = tools;
    return this;
  }

  public ModelsPatchRequest addToolsItem(String toolsItem) {
    if (this.tools == null) {
      this.tools = new ArrayList<String>();
    }
    this.tools.add(toolsItem);
    return this;
  }

   /**
   * Comma separated list tool names which can make use of the model.
   * @return tools
  **/
  @ApiModelProperty(value = "Comma separated list tool names which can make use of the model.")
  public List<String> getTools() {
    return tools;
  }

  public void setTools(List<String> tools) {
    this.tools = tools;
  }

  public ModelsPatchRequest modelClasses(List<ModelsEndpointTypeModelClasses> modelClasses) {
    this.modelClasses = modelClasses;
    return this;
  }

  public ModelsPatchRequest addModelClassesItem(ModelsEndpointTypeModelClasses modelClassesItem) {
    if (this.modelClasses == null) {
      this.modelClasses = new ArrayList<ModelsEndpointTypeModelClasses>();
    }
    this.modelClasses.add(modelClassesItem);
    return this;
  }

   /**
   * Array of ModelClasses (UID).
   * @return modelClasses
  **/
  @ApiModelProperty(value = "Array of ModelClasses (UID).")
  public List<ModelsEndpointTypeModelClasses> getModelClasses() {
    return modelClasses;
  }

  public void setModelClasses(List<ModelsEndpointTypeModelClasses> modelClasses) {
    this.modelClasses = modelClasses;
  }

  public ModelsPatchRequest tags(List<String> tags) {
    this.tags = tags;
    return this;
  }

  public ModelsPatchRequest addTagsItem(String tagsItem) {
    if (this.tags == null) {
      this.tags = new ArrayList<String>();
    }
    this.tags.add(tagsItem);
    return this;
  }

   /**
   * Array of tags (strings). Patch requires an updated array.
   * @return tags
  **/
  @ApiModelProperty(value = "Array of tags (strings). Patch requires an updated array.")
  public List<String> getTags() {
    return tags;
  }

  public void setTags(List<String> tags) {
    this.tags = tags;
  }

  public ModelsPatchRequest projects(List<ModelsEndpointTypeProjects> projects) {
    this.projects = projects;
    return this;
  }

  public ModelsPatchRequest addProjectsItem(ModelsEndpointTypeProjects projectsItem) {
    if (this.projects == null) {
      this.projects = new ArrayList<ModelsEndpointTypeProjects>();
    }
    this.projects.add(projectsItem);
    return this;
  }

   /**
   * Array of Projects (UID).
   * @return projects
  **/
  @ApiModelProperty(value = "Array of Projects (UID).")
  public List<ModelsEndpointTypeProjects> getProjects() {
    return projects;
  }

  public void setProjects(List<ModelsEndpointTypeProjects> projects) {
    this.projects = projects;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    ModelsPatchRequest modelsPatchRequest = (ModelsPatchRequest) o;
    return Objects.equals(this.name, modelsPatchRequest.name) &&
        Objects.equals(this.description, modelsPatchRequest.description) &&
        Objects.equals(this.trainingSet, modelsPatchRequest.trainingSet) &&
        Objects.equals(this.classifier, modelsPatchRequest.classifier) &&
        Objects.equals(this.tools, modelsPatchRequest.tools) &&
        Objects.equals(this.modelClasses, modelsPatchRequest.modelClasses) &&
        Objects.equals(this.tags, modelsPatchRequest.tags) &&
        Objects.equals(this.projects, modelsPatchRequest.projects);
  }

  @Override
  public int hashCode() {
    return Objects.hash(name, description, trainingSet, classifier, tools, modelClasses, tags, projects);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class ModelsPatchRequest {\n");
    
    sb.append("    name: ").append(toIndentedString(name)).append("\n");
    sb.append("    description: ").append(toIndentedString(description)).append("\n");
    sb.append("    trainingSet: ").append(toIndentedString(trainingSet)).append("\n");
    sb.append("    classifier: ").append(toIndentedString(classifier)).append("\n");
    sb.append("    tools: ").append(toIndentedString(tools)).append("\n");
    sb.append("    modelClasses: ").append(toIndentedString(modelClasses)).append("\n");
    sb.append("    tags: ").append(toIndentedString(tags)).append("\n");
    sb.append("    projects: ").append(toIndentedString(projects)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

