/*
 * its4land Public API
 * The its4land Public API provides access to the services of the its4land Publish and Share platform.
 *
 * OpenAPI spec version: 0.0.2
 * Contact: contact@its4land.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package io.swagger.client.api;

import io.swagger.client.ApiException;
import io.swagger.client.model.RFC6902PatchRequest;
import io.swagger.client.model.SpatialUnitBaseFeaturePostRequest;
import io.swagger.client.model.SpatialUnitConceptEndpointType;
import io.swagger.client.model.SpatialUnitConceptPostRequest;
import io.swagger.client.model.SpatialUnitsFeatureEndpointType;
import io.swagger.client.model.SpatialUnitsFeaturePostRequest;
import org.junit.Test;
import org.junit.Ignore;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * API tests for SpatialUnitsApi
 */
@Ignore
public class SpatialUnitsApiTest {

    private final SpatialUnitsApi api = new SpatialUnitsApi();

    
    /**
     * Creates a spatial unit
     *
     * Create a 2D polygon base spatial unit from a boundary face string  as GeoJSON
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void create2PpolygonSPUfromBFSTest() throws ApiException {
        SpatialUnitBaseFeaturePostRequest spatialunitdata = null;
        String envelope = null;
        String i4lProcessUid = null;
        List<String> embed = null;
        SpatialUnitsFeatureEndpointType response = api.create2PpolygonSPUfromBFS(spatialunitdata, envelope, i4lProcessUid, embed);

        // TODO: test validations
    }
    
    /**
     * Returns a single spatial unit
     *
     * Returns a single spatial unit with qualitative base qualitative base spatial profile
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void getSpatialUnitByUIDTest() throws ApiException {
        String spatialunitUid = null;
        String envelope = null;
        List<String> embed = null;
        SpatialUnitsFeatureEndpointType response = api.getSpatialUnitByUID(spatialunitUid, envelope, embed);

        // TODO: test validations
    }
    
    /**
     * Returns a single spatial unit concept
     *
     * Returns a single spatial unit concept
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void getSpatialUnitConceptByUIDTest() throws ApiException {
        String conceptUid = null;
        String envelope = null;
        List<String> embed = null;
        SpatialUnitConceptEndpointType response = api.getSpatialUnitConceptByUID(conceptUid, envelope, embed);

        // TODO: test validations
    }
    
    /**
     * Returns a list of SpatialUnits in a GeoJSON structure.
     *
     * Returns a list of SpatialUnits as GeoJSON feature with 2D polygon base spatial profile
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void getSpatialUnitsTest() throws ApiException {
        String querywindow = null;
        String envelope = null;
        List<String> uid = null;
        List<String> name = null;
        List<String> concept = null;
        List<String> level = null;
        List<String> projects = null;
        List<String> adminsource = null;
        List<String> tags = null;
        Integer page = null;
        String sort = null;
        List<String> fields = null;
        List<String> embed = null;
        List<SpatialUnitsFeatureEndpointType> response = api.getSpatialUnits(querywindow, envelope, uid, name, concept, level, projects, adminsource, tags, page, sort, fields, embed);

        // TODO: test validations
    }
    
    /**
     * Returns a list of SpatialUnits
     *
     * Returns a list of SpatialUnits as feature with 2d polygon base spatial profile
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void getSpatialUnitsByUUIDTest() throws ApiException {
        String spatialunitUid = null;
        String envelope = null;
        List<String> embed = null;
        List<SpatialUnitsFeatureEndpointType> response = api.getSpatialUnitsByUUID(spatialunitUid, envelope, embed);

        // TODO: test validations
    }
    
    /**
     * Returns a list of spatial units concepts
     *
     * Returns a list of spatial units concepts
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void getSpatialUnitsConceptsTest() throws ApiException {
        String envelope = null;
        List<String> uid = null;
        List<String> name = null;
        List<String> projects = null;
        List<String> spatialunit = null;
        List<String> tags = null;
        Integer page = null;
        String sort = null;
        List<String> fields = null;
        List<String> embed = null;
        List<SpatialUnitsFeatureEndpointType> response = api.getSpatialUnitsConcepts(envelope, uid, name, projects, spatialunit, tags, page, sort, fields, embed);

        // TODO: test validations
    }
    
    /**
     * Returns a list of SpatialUnits
     *
     * Returns a list of SpatialUnits as feature with geometry
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void getSpatialUnitsQualitativeTest() throws ApiException {
        String querywindow = null;
        String envelope = null;
        List<String> uid = null;
        List<String> name = null;
        List<String> concept = null;
        List<String> level = null;
        List<String> projects = null;
        List<String> adminsource = null;
        List<String> tags = null;
        Integer page = null;
        String sort = null;
        List<String> fields = null;
        List<String> embed = null;
        List<SpatialUnitsFeatureEndpointType> response = api.getSpatialUnitsQualitative(querywindow, envelope, uid, name, concept, level, projects, adminsource, tags, page, sort, fields, embed);

        // TODO: test validations
    }
    
    /**
     * Create a new SpatialUnit
     *
     * Create a new SpatialUnit with 2d polygon base spatial profile. The spatial unit is modeled as a GeoJSON feature. The endpoint currently allows only one spatial unit per request.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void newSpatialUnitTest() throws ApiException {
        SpatialUnitsFeaturePostRequest newspatialunit = null;
        String envelope = null;
        List<String> embed = null;
        String i4lProcessUid = null;
        SpatialUnitsFeatureEndpointType response = api.newSpatialUnit(newspatialunit, envelope, embed, i4lProcessUid);

        // TODO: test validations
    }
    
    /**
     * Create a new concept for a spatial unit
     *
     * Create a new concept for a spatial unit.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void newSpatialUnitConceptTest() throws ApiException {
        SpatialUnitConceptPostRequest newspatialunitconcept = null;
        String envelope = null;
        List<String> embed = null;
        String i4lProcessUid = null;
        SpatialUnitConceptEndpointType response = api.newSpatialUnitConcept(newspatialunitconcept, envelope, embed, i4lProcessUid);

        // TODO: test validations
    }
    
    /**
     * Create a new SpatialUnit
     *
     * Create a new SpatialUnit with qualitative base spatial profile
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void newSpatialUnitQualitativeTest() throws ApiException {
        SpatialUnitsFeaturePostRequest newspatialunit = null;
        String envelope = null;
        List<String> embed = null;
        String i4lProcessUid = null;
        SpatialUnitsFeatureEndpointType response = api.newSpatialUnitQualitative(newspatialunit, envelope, embed, i4lProcessUid);

        // TODO: test validations
    }
    
    /**
     * Update an spatial unit
     *
     * Update an spatial unit with 2d polygon base spatial profile
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void updateSpatialUnitTest() throws ApiException {
        String spatialunitUid = null;
        RFC6902PatchRequest patchspatialunit = null;
        String envelope = null;
        String i4lProcessUid = null;
        SpatialUnitsFeatureEndpointType response = api.updateSpatialUnit(spatialunitUid, patchspatialunit, envelope, i4lProcessUid);

        // TODO: test validations
    }
    
    /**
     * Updates a new spatial unit concept
     *
     * Updates a spatial unit concept
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void updateSpatialUnitConceptTest() throws ApiException {
        String conceptUid = null;
        RFC6902PatchRequest patchspatialunitconcept = null;
        String envelope = null;
        String i4lProcessUid = null;
        SpatialUnitConceptEndpointType response = api.updateSpatialUnitConcept(conceptUid, patchspatialunitconcept, envelope, i4lProcessUid);

        // TODO: test validations
    }
    
    /**
     * Updates a new SpatialUnit
     *
     * Updates SpatialUnit with qualitative base spatial profile
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void updateSpatialUnitQualitativeTest() throws ApiException {
        String spatialunitUid = null;
        RFC6902PatchRequest patchspatialunit = null;
        String envelope = null;
        String i4lProcessUid = null;
        SpatialUnitsFeatureEndpointType response = api.updateSpatialUnitQualitative(spatialunitUid, patchspatialunit, envelope, i4lProcessUid);

        // TODO: test validations
    }
    
}
